# Given the meaning entry from a dictionary which contains
# multiple words for each different meaning; this returns the
# first word for each of the different meanings.
# (The meaning entry is without enclosing double-quotes.)
sub dict_multi_first {
  local ($meaning) = @_;
  local (@vals, $v, $match, $first, $out);
  @vals = split (/\//, $meaning);
  foreach $v (@vals) {
    #print STDERR "DEBUG: Val: $v\n";
    if ($v =~ /^[0-9]+\./) { # First word for a distinct meaning.
      $match = $&;
      $first = $';  
      if ($first =~ /\/$/) { $first = $`; } # Remove trailing '/'
       #if ($match =~ /1\./) { # First word for the first meaning.
       #  $out = $first;
       #}
       #else { $out .= '/' . $first; }
      $out .= '/' . $first;
    }
  }
  if ($out =~ /^\//)  { $out = $'; } #Remove trailing '/'
  return ($out);
}
1;
