#!/usr/bin/perl
# Takes a file edited by Mrs Rita Mathur, and brings it
# to proper format under program control.
#  grep '#' wwah.rm | head
#          soce  #   
#  ׽        satAPa  #^  
#         samAXI  #   
#  ׵             # ?
#  ׸ݸ         saccamucca  #  ׸ݸ
#           sabaxa    #  
#  עۥ     saMBAliA  #  ?
#  ⢽       sEMtara   #^   ⢽
#  ۳     sAraWika   #  ó
#  ڦ       ravAiwI  #
#
#  Notation used by Mrs Rita Mathur in correcting the list of words 
#  in Punjabi.
#  
#  # sp    spelling mistake
#  # mx    incorrect meaning
#  # ss    second sense
#  # pn    proper noun
#  # ?     I do not know the word
#  # ^     refers to English word

while (<>) {
  chop;
  if (/#(sp|mx|pn|\s)\s*/) {  # Line found with change made by Rita Mathur.
    $type_of = $&; $left = $`;  $right = $';
    $#lparts = $#rparts = -1;
    @lparts = split (/\s+/, $left);
    @rparts = split (/\s+/, $right);
    #print STDERR "DEB: left=$left, right=$right, typeof=$type_of\n";
    #print STDERR "DEB: left-parts=$#lparts, right-parts=$#rparts,\n";
    if ($#lparts == 0) { # No meaning earlier present. A new entry added.
      if ($#rparts >= 0) {
        $lparts[1] = $rparts[0];
      }
      elsif ($type_of ne '#pn') { # No correction entry and not proper noun
        #print STDERR "No corrected entry given:$_\n";  # Suppress message.
      }
    }
    elsif ($#lparts >= 1) { # replace the existing entry
      if ($#lparts > 1) { # Issue warning.
        print STDERR "Incorrect number of entries on the left: $left\n";
      }
      if ($#rparts >= 0) {
        if ($rparts[0] eq '?') {
          print STDERR "Will not replace with ?: $_\n";
        }
        else {
          $tmp = $lparts[$#lparts]; 
          $lparts[$#lparts] = $rparts[0]; $rparts[0] = $tmp;
        }
      }
      elsif ($type_of ne '#pn') { # No correction entry and not proper noun
        #print STDERR "No corrected entry given:$_\n";  # Suppress message.
      }
    }
    else { print STDERR "0 entries on the left of #.\n"; }

    foreach $p (@lparts) { print $p, "\t"; }
    print '#  ';            # For debugging.    print '#  ';
    foreach $p (@rparts) { print $p, "\t"; }
    print '## ', $_, "\n";  # For debugging.    print '## ', $_, "\n";
  }
  else {
    print $_, "\n";  # No change to entry. Keep as-is.
  }
}
