;# Usage: &look(*FILEHANDLE,$key,$dict,$fold)

;# Sets file position in FILEHANDLE to be first line greater than or equal
;# (stringwise) to $key.  Pass flags for dictionary order and case folding.

sub my_look {
    local(*FH,$key,$dict,$fold) = @_;
    local($max,$min,$mid,$_);
    local($ans,$return_val);
    local($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,
       $blksize,$blocks) = stat(FH);
    $blksize = 8192 unless $blksize;
    $key =~ s/[^\w\s]//g if $dict;
    $key =~ y/A-Z/a-z/ if $fold;
    #print "my_look1 ",$key,"\n";
    $max = int($size / $blksize);
    #print "my_look ",$max,"\n";
    while ($max - $min > 1) {
	$mid = int(($max + $min) / 2);
	seek(FH,$mid * $blksize,0);
	$_ = <FH> if $mid;		# probably a partial line
	$_ = <FH>;
        #print "my_look2",$_,"\n";
	chop;
	s/[^\w\s]//g if $dict;
	y/A-Z/a-z/ if $fold;
	if ($_ lt $key) {
	    $min = $mid;
	}
	else {
	    $max = $mid;
	}
    }
    $min *= $blksize;
    seek(FH,$min,0);
    <FH> if $min;
    #print "my_look3",$_,"\n";
    while (<FH>) {
	chop;
    #print "my_look3",$_,"\n";
	s/[^\w\s]//g if $dict;
	y/A-Z/a-z/ if $fold;
	last if $_ ge $key;
	$min = tell(FH);
    }
    seek(FH,$min,0);
#   <FH> ;
# modified by AMBA.
# Following lines have been added.
# If the value is found, return 1;
# else return 0;
    if($_ eq $key) { $return_val = 1;}
    else{ $return_val = 0;}
# following line is commented by AMBA
# $min;
# following line is added by AMBA
$return_val;
}

1;
