/* this program converts the text in devanagri to roman 
 & vice versa.
 dtor :
 every devanagari word starts with nukwA.
 halanta is explicitly written by appending a halanta
 the characters lV & F (roman) are mapped to G &  respectively followed by nukwA ,in devanagari.
 
 rtod
 by default every character in roman is halant.
 lV , hqsva-mAwrA-o & hqsva-mAwrA-e are followed by V.
 nukwA is denoted by Z.
 */
#include <stdio.h>
#include <string.h>

#define halanwa 'w'
#define nukwA 'x'
#define blank ' '
#define lV_code 101
#define a_code 67
#define mAwrA_begin 107
#define mAwrA_end 119
#define chandra_bindu 65
#define anusvAra 66
#define F_code 75
#define oV_code 116
#define eV_code 113
#define f_code 71
#define visarg_code 66

int DBG;

int NEW_GIST;

char i_to_a[] = "zMakKgGcCjJtTdDNwWxXnpPbBm______yr_lVvSRshAiIuUqVeEVoO_H ";
char i_to_a_new[] = "zMakKgGcCjJtTdDNwWxXnpPbBm______yr_lYvSRshAiIuUqYeEYoO_H ";
unsigned char a_to_i[] = "kYIOsKGxmKE_BPvWphgMoeRTex______CXHNrGFjlJDdZUuVpbiLnfQSaA";
dtor(ias,as)
unsigned char ias[],as[] ;
{
	int i=0,j=0 , l ,p;
	unsigned char f , s ;
	l = strlen (ias) ;
	f=ias[i];
	while ((f !=nukwA)&&(i<l)) { 
		i++; 
		as[j++] =f;
		f=ias[i];
	}
	/* actually a blank followed by a nukwA is to be considered . 
It is assumed that the input text (in devanagari) does not contain any roman text . */
	if (f==nukwA) i++;
	while (i <l)  {
		f=ias[i];
		s = ias[i+1];
		if ((f<65) || (f>122) || (( f>90) && (f<97)))
		{
			as[j++] = f;
			if (s==nukwA)
				i+=2;
			else
				i++;
		}
		else
		{
			if ( f ==lV_code) as[j++] = 'l';
			p = check(s);
			switch(p)
			{
			case halanwa:
				{
					if((f<as[j-1])&&(NEW_GIST))
						as[j++] = i_to_a_new[f-65] ;
					else
						as[j++] = i_to_a[f-65] ;
					i+=2;
					break;
				}
			case nukwA:
				{
					switch(f){
					case F_code:
						{
							as[j++]='F';
							if (ias[i+2] == halanwa) i++;
							else as[j++] = 'a';
							break;
						}
					case f_code:
						{
							as[j++] = 'f';
							if (ias[i+2] == halanwa) i++;
							else as[j++] = 'a';
							break;
						}
					case visarg_code : 
						{
							as[j++] = 'H';
							break;
						}
					default:
						{
							if((f<as[j-1]) &&(NEW_GIST))
								as[j++] = i_to_a_new[f-65] ;
							else
								as[j++] = i_to_a[f-65] ;
							as[j++] ='Z';
							break;
						}
					}
					i +=2;
					break;
				}
			case 1:
				{
					if (f!=a_code)
						if((f<as[j-1]) &&(NEW_GIST))
							as[j++] = i_to_a_new[f-65] ;
						else
							as[j++] = i_to_a[f-65] ;
					switch(s)
					{
					case oV_code:
						as[j++] = 'o' ;
						break;
					case eV_code :
						as[j++] = 'e';
						break;
					default:
						break;
					}
					if((f<as[j-1]) &&(NEW_GIST))
						as[j++] = i_to_a_new[f-65] ;
					else
						as[j++]  = i_to_a[s-65] ;
					i+=2;
					break;
				}
			case 0:
				{
					if (f==oV_code )as[j++]='o';
					if (f==eV_code)as[j++] = 'e';
					if((f<as[j-1]) &&(NEW_GIST))
						as[j++] = i_to_a_new[f-65] ;
					else
						as[j++] =i_to_a[f-65];
					if ((f>67)&&(f<107))as[j++] = 'a';/*consonents*/
					i++;
					break;
				}
			}
		}
	}
	as[j] = '\0' ;
}


int check(ch)
unsigned char ch;
{
	if (ch == halanwa) return halanwa;
	if (ch ==nukwA) return nukwA;
	if((ch>=mAwrA_begin) && ( ch <=mAwrA_end))return 1;
	else return 0;
}

rtod(as,ias)
unsigned char as[],ias[];
{
	int i=0,j=0,l,p,q;
	unsigned char f,s,t;
	l = strlen(as);
		f=as[i];
		while ((f<65) || (f>122)||((f>90) &&(f<97)))
		{
		ias[j++] = as[i++];
		f=as[i];
	}
	/*should be modified to cover all non_alphabetic characters */
	if ((l!=0)  &&( as[i] >64) && (as[i] <123)) ias[j++] = nukwA;
	while (i<l)
	{
		f= as[i];
		s=as[i+1];
		if ((f<65) || (f>122)||((f>90) &&(f<97)))
		{
			ias[j++] = f;
			if(((s>64)&&(s<91))||((s>96)&&(s<123)))
				ias[j++] = nukwA;
			i++;
			continue;
		}
		else 
		{
			p=chkmawra(f);
			if (p)
			{
				if ((f!='M')&&(f!='H')&&(f!='z'))ias[j++] = 'C' ;
				if(f=='H') ias[j++] = 'B';
				if (( s!='V') && ( s!='Y'))
				{
					ias[j++] = a_to_i[f-65] ;
					i++ ;
				}
				else
				{
					if(f=='e')ias[j++] = 'q' ; 
					else ias[j++] = 't' ;
					i+=2;
				}
			}
			else
			{
				q =  chkmawra (s) ;
				if (q)
				{
					ias[j++] = a_to_i[f-65];
					if ((f=='F') ||(f=='f')) ias[j++] = nukwA;
					t = as[i+2];
					if ((t == 'V') ||(t == 'Y'))
					{
						if ( s == 'e')ias[j++] = 'q';
						else ias[j++] = 't';
						i+=3;
					}
					else 
					{
						ias[j++] = a_to_i[s-65];
						i+=2;
					}
				}
				else
				{
					switch(s)
					{
					case 'a' : 
						{
							ias[j++] = a_to_i[f-65] ;
							if ((f=='f')||(f=='F')) ias[j++] = nukwA;
							/* to be checked for 'f' & 'F' */
							i+=2;
							break;
						}
					case 'Z' :
						{   
							ias[j++] = a_to_i[f-65] ;
							ias[j++] = nukwA ;
							i+=2;
							break;
						}
					case 'V' :
					case 'Y' : 
						{
							i++;
							break;
						}
					default : 
						{
							ias[j++] = a_to_i[f-65];
							if ((f=='f')||(f=='F')) ias[j++] = nukwA;
							if (f != 'a') ias[j++] = halanwa;
							/* to be checked for 'F' */
							i++;
							break;
						}
					}
				}
			}
		}
	}
	ias[j] = '\0';
}

int chkmawra(ch)
unsigned  char ch;
{
	if ((ch == 'A')||(ch=='e')||(ch=='E')||(ch=='i')||(ch=='I')||(ch=='o')||(ch=='O')||(ch=='u')||(ch=='U')||(ch=='q')||(ch=='H')||(ch=='M')||(ch=='z'))return 1; 
	else return 0;
	/* this is extended mAwrA */
}

main(argc,argv)
int argc;
char *argv[];
{
	int h ,ROMAN;
	char c[100000] , ans_c[100000] ;
	NEW_GIST =0;
	ROMAN = 0;
	for(;;) {
		c[0]='\0';
		scanf("%[^\n]",c);
		if(argc > 1)
		{
			if(index(argv[1] ,'N')) NEW_GIST = 1;
			if (index(argv[1] , 'r')) ROMAN =1;
		}
		if(ROMAN)
			dtor(c,ans_c);
		else 
			rtod(c,ans_c);
		printf("%s\n",ans_c);
		h= getchar();
		h= getchar();
		if (h == EOF ) break;
		else ungetc(h,stdin);
	}
}
