#!/usr/bin/perl
# Called by refs2sents program.
# Takes as its input a file handle to a corpus file, a sentence no, and
# a file handle for the output file.
# It retrieves the sentence from the corpus file and puts it into the 
# output file.
sub getsent {
  local ($corpfile, $sno, $outfile, $affix) = @_;
  # print STDERR "Debug getsent.pl called with: @_\n";
  local ($olddelim);
  $olddelim = $/;
  $/ = '<.>';
  while (<$corpfile>) {
    if (/<s([0-9]+)>/) {
      $corpsno = $1;
      if ($sno == $corpsno) {   # Found the sentence.
        s/\n/ /g;    
        print $outfile "$_ $affix\n\n";
        last;
      }
      elsif ($sno < $corpsno) {
        print STDERR "Given sentence number <s$sno> not in increasing order. Corpus sentno: <s$corpsno> Cannot retrieve.\n";
      }
    }
    else { 
      print STDERR "Sentence number not found in corpus file. Ignoring: $_\n"; 
    }
  } 
  $/ = $olddelim;
}
1;
