#! /usr/bin/perl
# Gets references from .xtr file containing extracted sentences from corpus.
# Each sentence must be on a new line.
#   Example usage:  sents2ref.pl < aMtis.xtr   > aMtis.ref

local ($sno, $fname);
while (<>) {
  if (/<s[0-9]+>/) { # Beginning of sentence marker found.
    $sno = $&;
    if (/(<\@[^<\@]+\@>)$/) {  # Found file name at the end.
      $fname = $1;
      print $fname, " \t", $sno, "\n";
    }
    else { 
      print STDERR "Corpus file name not found in line no. $.: $_";
    }
  }
  elsif (/\s*$/) { } # A blank line.
  else { 
    print STDERR "Sentence number not found $.: $_";
  }
}
1;
