#! /usr/bin/perl
# Extracts references from the .xtr file in old xtr format.
# (Old xtr format had file name in the beginning, the new one has it
# at the end surrounded by '<@' and '@>'.)
#   Example usage:  packoldxtr.pl < aMtis.xtr   > aMtis.ref

while (<>) {
  if (/^@([^:]+):\s/) {  # Found file name in the beginning.
    $fname = $1;
    $_ = $';
    if (/<s[0-9]+>/) { # Beginning of sentence marker found.
      print '<@/usr3/epc002/corpus/', $fname, "@>\t", $&, "\n";
    }
    else { print STDERR "End of sentence marker not found $.: $_"; }
  }
  else { print STDERR "Sentence number not found $.: $_"; }
}
1;
