# Called by prirefs.cmd
# Currently only the prirefs subroutine is being used.
# $dbmfile	- Name of the DBM files containing words and irefs.

# Writes out the word and their irefs from DBM to a text file.
sub prirefs {
  local ($tmp, $fout) = @_;  # Ignore input filehandle $tmp.
  local ($w, $irefs);
  dbmopen (%word_iref, $dbmfile, 0644) || 
    die "Unable to open file: $dbmfile.\n";
  # while ( ($w, $irefs) = each %word_irefmem) { print $fout $w, $irefs, "\n"; }
  while ( ($w, $irefs) = each %word_iref) { print $fout $w, $irefs, "\n"; }
  #  system ("sort  \< $Foutname  \> $Foutname.tmp");
}

# ------------------- Not being used below this line ----------

# There is a provision of creating two global arrays from a file of frequency
# counts of words using crword_irefs containing words with nil irefs.
# (Such frequency counts are sometimes available for a corpus, anyway.)
# After that it takes a file of 
# filenames and stores irefs for the filenames in the global arrays. 
# There is also a provision of dumping the global arrays to a file 
# (using prwords).

# Takes the file of words (with their frequencies) and
# stores them in global assoc. arrays (%word_iref and %word_irefmem).
# (Does not use freqs info except assumes that the words are given
# in descending frequency order. Keeps the most frequent words in mem.
# in %word_irefmem and the rest in DBM file %word_iref.)
sub crword_irefs {
  local ($i, $w, $cnt);
  if (!(open (WRDS, "$wrdfreq"))) {
    print STDERR "Unable to open input file of words and their freq: $wrdfreq. Continuing.\n";
    return;
  }
  $i = 1;
  while (<WRDS>) {
    chop;
    if (/^\s+/) { $_ = $'; }
    ($cnt, $w) = split (/\s+/);
    if ($i <= $inmemmax) { $word_irefmem{$w} = ' ';  $i++; }
    else { $word_iref {$w} = ' '; }
  }
  $inmemcount = $i - 1;
  close (WRDS);
}

# Useful in conjunction with freq info.
# Write the words in %word_irefmem to DBM file.
sub store_word_irefmem {
  while ( ($w, $iref) = each %word_irefmem) {
    if ($word_iref{$w} ne '') {
      print STDERR "mkirefs.pl: Program error. Word $w already present in DBM.\n";
    }
    $word_iref{$w} = $iref;
  }
}
# &crword_irefs (); # Insert once before starting to call &mkirefs
# &prwords ($outf); # Insert at the end after the calls to &mkirefs but before closing $outf
1;
