# Takes as its input, a file containing refs consisting of filename and 
# sentence number, and retrieves the sentences and puts them in an output file.
# (Assumes that for each filename in the refs, the sentences are listed
# in ascending order.)
#   Example usage: refs2sents.cmd  <abc.ref  >abc.xtr
# Usually *.ref files are generated by xtrref.cmd.

require ("/home/bharathi/PNJ1/usr3/sangal/tools/src/corp2/getsent.pl");
sub refs2sents {
  local ($refsfile, $outfile) = @_;
  local ($fname, $prevfname, $sno, $affix);
  local ($firstopen) = 0;  # Set to 1 after the first open.
  while (<$refsfile>) {
    chop;
    ($fname, $sno) = split (/\s+/);
    $affix = $fname;
    # Check the formats
    if ( substr($fname, 0, 2) eq '<@') { $fname = substr ($fname, 2); }
    else { print STDERR "File $fname does not have a leading <@. Continuing.\n"; }
    if ($fname =~ /@>$/) { $fname = $`; }
    else { print STDERR "File $fname does not have a trailing '@>'. Continuing.\n"; }
    if ($sno =~ /<s([0-9]+)>/) {  $sno = $1; }
    else { print STDERR "Sentence no. $sno for file $fname not in format. Ignoring."; }
    #print STDERR "Debug refs2sents: file name  $fname;  sentence no.  $sno;\n";

    # Now try to retrieve the sentence.
    if ($fname ne $prevfname) {  # Open the file only if necessary.
      if (!($firstopen)) { close (CORPFILE); }
      if (!(open (CORPFILE, $fname))) {
        print STDERR "Unable to open file $fname.\n";
        next;
      }
      else { 
        $firstopen = 1;
        $prevfname = $fname;  # Set this filename to prev fname
      }
    }
    &getsent (CORPFILE, $sno, $outfile, $affix);
  } 
}
1;
