#!/usr/bin/perl
# Takes as its input an extracted sentence (specified by giving file name 
# containing the extracted sentences and line number). 
# Obtains corpus reference (corpus file name, sentence number)
# and displays it with context.
#   Example usage: sent2ocorp.cmd  aMtis.xtr  5
# Also works with *.x70 or other related files.

require ("/home/bharathi/PNJ1/usr3/sangal/tools/src/corp2/sent2ref.pl");

local ($fname, $lno, $corpfile, $sno);

$fname = $ARGV[0];
$lno = $ARGV[1];

($corpfile, $sno) = &sent2ref ($fname, $lno); 
# $corpfile might be in cleaned corpus. Change it to original corpus 
# pathname, if necy.
if (!($corpfile =~ /orig\//)) {
  $corpfile =~ s#/telugu/#/teluguorig/#;
  $corpfile =~ s#\.sm$##;
}
# print STDERR "sent2ocorp.cmd deb: Corpus ref: ", $corpfile, '  ',  $sno, "\n";

if ($corpfile =~ /([^\/]+)$/) { $barefname = $1 . '.ocorp'; }
# print STDERR "sent2ocorp.cmd deb: Search in file $barefname, Sentence: $sno\n";

# The older arrangement was for keeping compressed files in the corpus.
# Newer arrangement follows:
# if (!(-e $barefname)) {
#   system ("zcat  $corpfile.gz | /home/bharathi/PNJ1/usr3/sangal/tools/src/corp/putsmark.cmd > $barefname");
# }
# system ("vim -v +/\"<s$sno>\" $barefname");

system ("vim -v  $corpfile");
