#! /usr/bin/perl
# Takes a text file and puts title and section markers

$deb = 0;
# put title in the first non-white line 
while (<>) { 
  if (!(/^\s*$/)) { print "\\title\\ $_";  last; }  # Non-white line found
  else { print; }
}
while (<>) {
  if (!(/^\s*$/)) {  # non-white line
    if (/^\s*/) {   # Line with opening white space
      $spaces = $&;  $rest = $';
      $spaces =~ s/\t/       /g;     # To count a tab as 7 spaces
      $lensp = length ($spaces); # Number of opening spaces
      $lenrest = length ($rest); # Number of characters in the restline
    }
    else {  # No opening white space
      $lensp = 0;  
      $rest = $_;
      $lenrest = length ($rest); # Number of characters in the restline
    }
    @rest = split (/\s+/, $rest);  # Split into words
    $numwords = $#rest + 1;
    if ($lensp > 1) {
      if (($numwords <= 5) && (($lensp + $lenrest) < 40)) {
             # less than 6 words and not too long a line
        print "\\section\\ $_";  $white = 0;  next;
      }
      if (($lensp/$lenrest) >= .3) {  # Lot of white space in the line
        print "\\section\\ $_";  $white = 0;  next;
      }
    }
    if ($deb) { print "spaces:$lensp,rest:$lenrest;words:$numwords\n"; }
    if ($white) { # If prev line was a white line relax conditions.
      if (($numwords <= 6) && (($lensp + $lenrest) < 50)) {
             # less than 6 words and not too long a line
        print "\\section\\ $_";  $white = 0;  next;
      }
    }
    if ( ($lensp > 15) && (($lensp + $lenrest) < 55)) {
      print "\\section\\ $_";  $white = 0;  next;
    }
    $white = 0;
  }
  else { $white = 1; }   # A white line was found
  print;
}
    
