#! /usr/bin/perl
# Takes a text file and puts a paragraph marker whenever one or
#   more white lines are encountered.

# Do not put para in the beginning white space
$white = 0;
while (<>) { 
  print;
  if (!(/^\s*$/)) {  last; }     # Non-white line found
}

while (<>) {
  if (/^\s*$/) {  # white line
    $white = 1; 
  }
  else { 
    if (/\\section\\/) { $t = 0; }  # Do not put para
    elsif (/\\title\\/) { $t = 0; }   # Do not put para
    elsif (/^\s{2,}/) { # At least 2 white spaces in the beginning, put para
      print "$&\\p\\ "; $_ = $';
    }
    elsif (/^\s*\t\s*/) { # At least a tab in the beginning
      print "$&\\p\\ "; $_ = $'; 
    }
    elsif ($white) { print "\\p\\ "; }  # Prev line was white
    $white = 0;
  }
  print;
}

