# Searches for a given pattern and if found for a sentence in a
# given file, writes file name and sentence number (index) in stdout.
# Called by xtrref.cmd.

sub xtract {
  local ($infile, $outfile) = @_;
  local ($oldfile, $oldlimtr);
  #print STDERR "Inside xtract.\n"; # for debugging
  $oldfile = select ($outfile);
  $oldlimtr = $/;
  $/ = $delim;
  while (<$infile>) {
    if (/$pat/) {
      if ($delim ne 'n') { 
        if ($delim eq '<.>') { # Usual sentence end marker.
          if (/(<s[0-9]+>)/) { # Look for sentence begin marker.
            # $sentnum = $1;
            print "$fnameaffix\t$1\n";
          }
          else { # Sentence begin marker not found.
            print "$fnameaffix\t$.\n";
            print STDERR "xtr.pl: Begin sentence marker not found.$_\n";
          }
        }
        else { # Some other delimiter used.
          print "$fnameaffix\t$.\n";
        }
      }
      else { print "$_ $fnameaffix$."; }
    }
  }
  select ($oldfile);
  $/ = $oldlimtr;
}
1;
