#! /usr/bin/perl
# Takes a file generated by du command as its input, and
# selects those immediate subdirs which are large consumers
# of disk space.
if ($ARGV[0] =~ /^\-[0-9]+/) { $large = substr ($ARGV[0], 1);}
else { $large = 5000; }   # 5000 kbytes is considered large
while (<STDIN>) {
  ($size, $dirname) = split (/\s+/);
  if ($dirname =~ /\.\/\w+$/) { # Lists a single dir: ./NAME
    if ($size > $large) { print "$dirname\t$size\n"; }
  }
}

