#!/usr/bin/perl
# Summary of the anusaraka output in say FF.sum is added
# to a summary accumulation file, called say TOTAL.stat.
# Usage example: summ2stat.pl <FF.sum >>TOTAL.stat

$hdrfound = 0;
while (<STDIN>) {
  if (/^Statistics/) {
    $hdrfound = 1;
    if (/\s([^\s]+)::$/) {
      $fname = $1;
    }
    else { print "File name not found. Continuing.\n"; }
  }
  elsif ($hdrfound) { # Header was found in previous loop.
    $hdrfound = 0;
    if (/^\s*([0-9\.]+)/) { $known_cnt = $1; }
    else { print "Percent count of known words not found. Continuing.\n";}
    if (/([0-9\.]+)\s+wps\(real\)/) {
      $wps_real = $1;
    }
    else { print "wps(real) not found. Continuing.\n";}
    if (/([0-9\.]+)\s+wps\(sysuse\)/) {
      $wps_sysuse = $1;
    }
    else { print "wps(sysuse) not found. Continuing.\n";}
  }
}

print "$known_cnt %\t$wps_real wps(real)\t$wps_sysuse wps(sysuse) $fname\n";
