#!/usr/bin/perl
# Creates a summary file using the anusaaraka log file *.log
# If *.hdr file is available gets file name and tot word count to
#  compute other summaries.

$tuser = 0;  $treal = 0;  $tsys = 0;  # Time taken by system etc.
$unknown_cnt_next = 0;   # If 1 means the next line contains unknown cnt
while (<STDIN>) {
  @words = split (/ +/);
  if ($unknown_cnt_next) {
    $unknown_cnt = $words[0];
    chop ($unknown_cnt);
    $unknown_cnt_next = 0;
  }
  if ($words[0] eq 'real') { $treal += $words[1]; }
  elsif ($words[0] eq 'user') { $tuser += $words[1]; }
  elsif ($words[0] eq 'sys') { $tsys += $words[1]; }
  elsif (/unknown_word/) { $unknown_cnt_next = 1; }
}

open (HDR, $ARGV[0]) || print "Unable to open header file $ARGV[0]\n";
          # Open the header file for input text file name and tot wc.
if ( $fname = <HDR> ) {   
  chop($fname);
    # print "DEB: fname = $fname\n";
  $tot_cnt = <HDR>;  chop($tot_cnt);
    # print "DEB: tot count = $tot_cnt\n";
  $wps_sysuse = $tot_cnt/($tuser + $tsys);
  $wps_real = $tot_cnt/$treal;
  $known_prcnt = 100 -  (100 * $unknown_cnt/$tot_cnt);
  close (HDR);
}
else { $fname = 'n.a.';  $tot_count = 'n.a.'; $wps = 'n.a.'; $known_prcnt = 'n.a.';}

print "Statistics for file named $fname::\n";
print STDOUT sprintf ("%3d %% known words, %5.2f wps(real), %5.2f wps(sysuse)\n", $known_prcnt, $wps_real, $wps_sysuse); 
print "  Counts: Unknown words = $unknown_cnt,    Total words = $tot_cnt\n";
print STDOUT  sprintf ( "  Time (seconds): real = %6.2d,  user = %6.2d,  sys = %6.2d\n", $treal,  $tuser,  $tsys);

