#!/usr/bin/perl
# To port files in a directory updated from a cutoff date run this command.
# It tars all the relevant files into a tar file.
#   Example usage: porttar -c'14.5.96' tools  todec.tar
# The above creates todec.tar file containing all those files in tools
# subdirectory which have been updated since 14.5.96.
require ("/home/bharathi/PNJ1/usr3/sangal/tools/src/sysapp/porttar.pl");
require ("/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/printusage.pl");

# Assumes that the args begin after the params. (Each param begins by -)
local ($i, $parmlastpos, $argbegpos);
$parmlastpos = -1; # Gives pos of last param in ARGV. Default no params.
$argbegpos = -1;  # Gives position of 1st argument in ARGV. Default no args
$cutoffdate = '1.1.1901';
for ($i=0; $i <= $#ARGV; $i++) { # Extract the parameters and locate
                                 #  starting loc of command args.
  if (substr($ARGV[$i],0,1) eq '-') {  # A parameter found.
    $parmlastpos++;  # Change the following lines to suit your needs.
    if (substr($ARGV[$i],1,1) eq 'h') { # print help info.
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/sysapp/porttar.cmd');
      die;
    }
    elsif (substr($ARGV[$i],1,1) eq 'c') { # cutoff date
      $cutoffdate = substr ($ARGV[$i],2);
    }
    else { 
        print STDERR "Unrecognized param: $ARGV[$i]. Ignoring.\n";
        &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/sysapp/porttar.cmd');
    }
  }
  else { # Argument found. Parameters end.
    $argbegpos = $i;
    last;
  }
}
#print STDERR "DEB params end: $parmlastpos;  args begin: $argbegpos; total: $#ARGV;\n";

# Process the arguments in the command line then call porttar.
# 1. Can be used as a filter. OR
# 2. file args can be given instead of filters.

if (($#ARGV - $argbegpos) < 1) { # No args.
  print STDERR "porttar: No file args. Two file arguments needed.\n";
}
#elsif (($#ARGV - $argbegpos) == 0) { # Only one arg given. Execute the command with arg and stdout.
#  &porttar($ARGV[$argbegpos], STDOUT);
#}
elsif (($#ARGV - $argbegpos) == 1) { # Two args given. Execute the command with arg1 and arg2.
  &porttar($ARGV[$argbegpos], $ARGV[$argbegpos + 1] );
}
else { print STDERR "porttar: Too many arguments.\n"; }

