#!/usr/bin/perl
#%COMMENT

#%REQUIRE

# Assumes that the args begin after the params. (Each param begins by -)
local ($i, $parmlastpos, $argbegpos, $arg, $suff, $argsinfile, $Finname, $Finname);
#%LOCAL
$parmlastpos = -1; # Gives pos of last param in ARGV. Default no params.
$argbegpos = -1;  # Gives position of 1st argument in ARGV. Default no args
$argsinfile = 0;  # Default args file names are not in a file.
$suff = '.new'; # Default suffix for output file if necessary.
#%OPTIONS DEFAULTS

#%BEGIN RC FILE OPTIONS 
# Look up .DUMMYrc file. Override defaults.
if (open (RC, '.DUMMYrc')) {
  while (<RC>) {
    chop;
    if (/\s*#/) {  next; }   # Ignore. A comment line.
    if (/\s*-/) {  # A parameter found.
      $_ = '-' . $';
      if (substr($_,1,1) eq 'h') { # print help info.
        &printusage ('ABSNAME');
        die;
      }
#%RC ELSIF STMTS
      else { 
          print STDERR "DUMMY.cmd: Unrecognized param in rc file: $_.\n";
          &printusage ('ABSNAME');
          die;
      }
    }
    else { # 
      print STDERR "DUMMY.cmd: Param must begin with '-' in rc file: $_. Ignoring.\n";
    }
  }
  close (RC);
}
#%END RC FILE OPTIONS 

#%BEGIN CMD LINE OPTIONS 
for ($i=0; $i <= $#ARGV; $i++) { # Extract the parameters and locate
                                 #  starting loc of command args.
  if (substr($ARGV[$i],0,1) eq '-') {  # A parameter found.
    $parmlastpos++;  # Change the following lines to suit your needs.
    if (substr($ARGV[$i],1,1) eq 'h') { # print help info.
      &printusage ('ABSNAME');
      die;
    }
    elsif (substr($ARGV[$i],1,1) eq 's') { # Suffix for output file names.
       $suff = substr ($ARGV[$i],2);
    }
#%CMD LINE ELSIF STMTS
    else  { print STDERR "DUMMY.cmd: Parameter not recognized $ARGV[$i].\n";
      &printusage ('ABSNAME');
      die;
    }
  }
#%END CMD LINE OPTIONS 
  else { # Argument found. Parameters end.
    if (substr($ARGV[$i],0,1) eq '@') {  # A file of args found
      $argsinfile = 1;
      $ARGV[$i] = substr($ARGV[$i], 1);
    }
    $argbegpos = $i;
    last;
  }
}
#print STDERR "DUMMY.cmd: DEB params end: $parmlastpos;  args begin: $argbegpos; total: $#ARGV;\n";

#%BEGIN CALL PROGRAM
# Process the arguments in the command line then call DUMMY.
# 1. Can be used as a filter. OR
# 2. If more than one file arguments are given, they are treated as
#    inputs files, and the output file name is given
#    by the input file name suffixed by the default suffix
#    (which can be changed by approp flag).

if ($argbegpos < 0) { # No args.
  &DUMMY(STDIN, STDOUT);
}
elsif ($argsinfile) {  # Argument filenames in file.
  open (ARGFILE, "$ARGV[$argbegpos]") ||
    die "DUMMY.cmd: Unable to open args file $ARGV[$argbegpos]\n" ;
  while (<ARGFILE>) { # Read args.
    chop;
    if (!(open (INFILE, $_))) {
      print STDERR "DUMMY.cmd: Unable to open file $_\n" ;
      next;
    }
    if (!(open (OUTFILE, ">$_$suff"))) {
      print STDERR "DUMMY.cmd: Unable to open out file $_$suff\n";
      close (INFILE);
      next;
    }
    $Finname = $_;  $Foutname = $_ . $suff;
    &DUMMY (INFILE, OUTFILE);
    close (INFILE);
    close (OUTFILE);
  }
  close (ARGFILE);
}
else { # Call the program with each arg. 
 if (($#ARGV - $argbegpos) == 0) { # There is only one file argument use STDOUT.
    if (!(open (INFILE, "$ARGV[$argbegpos]"))) {
      print STDERR "kwic.cmd: Unable to open file $ARGV[$arg]: $!\n" ;
    }
    else {
      $Finname = $ARGV[$argbegpos];
      &kwic (INFILE, STDOUT);
      close (INFILE);
    }
 }
 else {
  for ($arg = $argbegpos; $arg <= $#ARGV; $arg++) {
    if (!(open (INFILE, "$ARGV[$arg]"))) {
      print STDERR "DUMMY.cmd: Unable to open file $ARGV[$arg]: $!\n" ;
      next;
    }
    if (!(open (OUTFILE, ">$ARGV[$arg]$suff"))) {
      print STDERR "DUMMY.cmd: Unable to open out file $ARGV[$arg]$suff: $!\n";
      close (INFILE);
      next;
    }
    $Finname = $ARGV[$arg];
    $Foutname = $ARGV[$arg] . $suff;  
    &DUMMY (INFILE, OUTFILE);
    close (INFILE);
    close (OUTFILE);
  }
 }
}

