#!/usr/bin/perl
#%COMMENT
# Takes the punjabi-hindi dictionary and tries to identify
# entries that are dissimilar Hindi word for the punjabi
# word.
#   Example usage: dictdiff_pnj.pl < IN  >OUT
# Also creates a file called 'rem' with remaining words.

#%CMD TYPE M1
$permit_diff = 2; # Maximum permissible diff in consonents. #OPT -p

$vowels = 'MHaAiIuUqeEoO';
$vowels_short = 'aiuqeo';
$vowels_long =  'AIUQEO';
$conson = 'kKgGfcCjJFtTdDNwWxXnpPbBmyrlvSRsh';
$conson_alpa = 'kgcjtdwxpb';
$conson_mahA = 'KGCJTDWXPB';
#open (REM, ">rem.dict") || die "Unable to open output file rem.dict\n";

LINE: while($a = <STDIN>) {
  $b = $a;
  @fields = split(/,/, $a);
  $fields[0] =~ s/[$vowels]//og;
  $fields[3] =~ s/[$vowels]//og;
  if ($fields[3] =~ /\//) { @subfields = split(/\//, $fields[3]); }
  else { $subfields[0] = $fields[3]; }
  $lenpunj = length ($fields[0]);
  # If the punjabi word is found to be equal or similar to any of
  #  the hindi equivalents, go to the 'next LINE' of the dictionary.
  for($i=0;  $i <= $#subfields;  $i++){
    if($fields[0] eq $subfields[$i]) { 
      #print STDERR "DEBUG: Identical: $b";
      next LINE;}
    $lenhindi = length ($subfields[$i]);
    if ($lenpunj < $lenhindi) { 
      $lenmin = $lenpunj;    $lendiff = $lenhindi - $lenpunj; }
    else { $lenmin = $lenhindi;   $lendiff = $lenpunj - $lenhindi; }
    if ($lendiff <= $permit_diff) {
      $match_cnt = 0;
      for ($j=0;  $j <= $lenmin;  $j++) {
        if (substr ($fields[0], $j, 1) eq substr($subfields[$i], $j, 1)) {
          $match_cnt++;
        } 
      }
      if (($lenmin - $match_cnt + $lendiff) <= $permit_diff)  { 
        #print STDERR "DEBUG: Similar: $b";
        #print STDERR "i=$i, $subfields[$i], match=$match_cnt, \n";
        next LINE;
      }
    }
  }
  print $b;
}
#close REM;

