#!/usr/bin/perl
# Takes the output of diff and changes it so that when it
# is used with patch, it will put put the approp info. in the orig.
#   Example usage: diff_algn.pl < a.diff > a.patch
# Later a.patch can be patched to the original 
# by saying 'patch a.orig a.patch' resulting in
# output shown below:
#   print a     a[^b]      a[^-]   [^+b]
#   means a=b,  a chng b,  del a,  insert b

while (<>) {
  if (/^[^><\-]/) {   # Control line. Contains info about kind of match.
    if ($state eq 'd') { $postpone .= '\\' . "\n"; }
    if ($postpone ne '') { print $postpone;  $postpone = ''; }
    print "\n";
    if ( /^([^cda]*)([cda])(.*)/ ) {
      $state = $2;   $pre = $1;    $post = $3;
      if ($state eq 'c') {
        print;  # print the control line.
        $/ = "\n---\n"; $_ = <>;  print;  $/ = "\n"; 
        # Form a single string for the changed input.
        if (!(/\n---\n$/)) { print STDERR "Premature end:$_\n"; }
        chop; chop; chop; chop; chop;
        s/^< //;   s/\n< /\n/g;  
        s/\n/ /g;  $pre_pr = '\\' . $_ . '\\';
        # if ($pre =~ /,/) { # More than one line has to be changed.
        #   s/\n/ /g;  $pre_pr = '/' . $_ . '/';
        # }
        # else { $pre_pr =  $_; }
      }
      elsif ($state eq 'd') { # Keep printing until next non-data-line.
        s/d/c/; chop;  print;  # First Change the control line to 'c' and print.
        $postpone = "\n" . '---' . "\n" . '> \\';
      }
      else { print; }
    }
    else { print STDERR "diff_algn.pl: Unrecognized format: $_"; }
  }
  else { # State can have four values: c, d, a, N(for none)
    chop;
    if ($state eq 'c') {  # Lines of 2nd file are being read.
      print '> ' . $pre_pr, '[^', substr($_,2);  
      $postpone = "]";   $state = 'N';
    }
    elsif ($state eq 'd') {   # Lines of 1st file are being read.
      print "\n", $_;  $postpone .= substr ($_, 2) . ' ' ;
    }
    else { print "\n", $_; }
  }
}

if ($state eq 'd') { $postpone .= '\\'; }
if ($postpone ne '') { print $postpone; }
print "\n";

