#!/usr/bin/perl
# Changes the format of the input file containing cat, feature, value,
# etc.:
#   fv_fmt.pl < fvals   > fvals.fmt
# Example input file:
#  v tam IxA gender m number s person any 
#  adj gender f number s case 1 parsarg any 
#  v tam hE number p person a gender any 
#  P number p parsarg 8 case 1 gender any 
# Example output file:
#  v{tam=IxA,gender=m,number=s,person=any,}
#  adj{gender=f,number=s,case=1,parsarg=any,}
#  v{tam=hE,number=p,person=a,gender=any,}
#  P{number=p,parsarg=8,case=1,gender=any,}

while (<>) {
  chop;
  $s = 0;
  while (/ +/) {
    if ($s == 0) { $_ = $` . '{' . $';  $s = 1; }
    elsif ($s == 1) { $_ = $` . '=' . $';  $s = 2; }
    elsif ($s == 2) { $_ = $` . ',' . $';  $s = 1; }
    else { print STDERR "fv_fmt.pl: Prog error. Invalid state: $s\n"; }
  }
  print $_, '}', "\n";
}

