#!/usr/bin/perl
# Given a list of words (one word in each line)
# returns the marked words together with line number in the original.
# (The marked words are preceded by '*', and line number
# in the original file is given by a line, prefixed by '------'.)
#   Example usage: grep_marked.pl < INFILE  > OUTFILE

while (<>) {
  chop;
  if (/---------([0-9]+)$/) { # get the line number in the original
    $line_no = $1 + 1;
  }
  if (/^\*\*/) { print $', " ($line_no)\n"; }
}

