#!/usr/bin/perl
# Takes two files as inputs: standard 2-line anusaaraka output, 
# and 2-line postedited output, and generates a three line output.
#   Example usage: join_post.pl  FF.OUT  FF.POST > FF.3

open (ANUOUT, $ARGV[0]) || die "Unable to open file $ARGV[0]: $!";
open (POST, $ARGV[1]) || die "Unable to open file $ARGV[1]: $!";

while (<ANUOUT>) {
  $telugu = $_;
  $rawout = <ANUOUT>;
  $divider = <ANUOUT>;
  if ($divider !~ /^------+[0-9]+$/) {
    print STDERR "Illegal divider found in raw output file: $divider";
  }
  $telugu2 = <POST>;
  $postout = <POST>;
  $divider2 = <POST>;
  if ($divider2 !~ /^------+[0-9]+$/) {
    print STDERR "Illegal divider found in postedited file: $divider2";
  }
  if ($telugu ne $telugu2) {
    print STDERR "Telugu lines do not match across raw output and and post-edited output:\n",
                 $telugu, $telugu2;
  }
  if (!(($telugu eq "\n") && ($rawout eq "\n") && ($postout eq "\n") && ($telugu2 eq "\n"))) {
    print $telugu, $rawout, $postout, $divider;
  }
}
