#!/usr/bin/perl
# Given two files containing sentences, tries to align the words 
# in the respective files and writes out the alignment to a file.
#   Example usage: align.cmd  f.raw  f.edi >f.algn
# In the example, aligns the raw anusaaraka output in f.raw with
# postedited output in f.edi, and writes the output to f.algn.

# cmd assumes 2 to 1.
require("/home/bharathi/PNJ1/usr3/sangal/tools/src/anu/align.pl");
require ("/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/printusage.pl");


# Assumes that the args begin after the params. (Each param begins by -)
local ($i, $parmlastpos, $argbegpos);
$parmlastpos = -1; # Gives pos of last param in ARGV. Default no params.
$argbegpos = -1;  # Gives position of 1st argument in ARGV. Default no args
for ($i=0; $i <= $#ARGV; $i++) { # Extract the parameters and locate
                                 #  starting loc of command args.
  if (substr($ARGV[$i],0,1) eq '-') {  # A parameter found.
    $parmlastpos++;  # Change the following lines to suit your needs.
    if (substr($ARGV[$i],1,1) eq 'h') { # print help info.
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/anu/align.cmd');
      die;
    }
    else { 
      print STDERR "Unrecognized param: $ARGV[$i]. Ignoring.\n";
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/anu/align.cmd');
    }
  }
  else { # Argument found. Parameters end.
    $argbegpos = $i;
    last;
  }
}
#print STDERR "DEB params end: $parmlastpos;  args begin: $argbegpos; total: $#ARGV;\n";

# Process the arguments in the command line then call align.
if ($argbegpos < 0) { # No args.
  print STDERR "align.cmd: Input file names not given.";
  &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/anu/align.cmd');
}
elsif (($#ARGV - $argbegpos) == 0) { # Only one arg given. Execute the command with arg and stdout.
   #open (INFILE, "$ARGV[$argbegpos]") ||
   #   die "Unable to open file $ARGV[$argbegpos]\n" ;
   #&align(INFILE, STDOUT);
   #close (INFILE);
  print STDERR "align.cmd: Only one input file name given. Give two.";
  &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/anu/align.cmd');
}
elsif (($#ARGV - $argbegpos) == 1) { # Two args given. Execute the command with arg1 and arg2.
  open (INFILE1, "$ARGV[$argbegpos]") ||
     die "Unable to open input file $ARGV[$argbegpos]\n" ;
  open (INFILE2, "$ARGV[$argbegpos + 1]") ||
     die "Unable to open input file $ARGV[$argbegpos + 1]\n" ;
  &align(INFILE1, INFILE2, STDOUT);
  close (INFILE2);
  close (INFILE1);
}
else { print STDERR "Too many arguments.\n"; }

