#!/usr/bin/perl
# It takes white space from the input file, and
# other non-white space matter from another file, and
# combines them into one file. Ignores the matter from the
# first file.
#   Example usage: combn_fmt.pl  a.input  a.content   >  a.out
# Replaces the non-white space units in the first file by 
# units of the second file (which are one on each line). 
# (The units are counted. Counting them on the second file
# is not a problem, to count them in the first file, 
# punctuation marks and word boundaries are used.)
#
# NOTE: It uses the same def of punct mark as 
#  /home/bharathi/PNJ1/usr3/sangal/tools/src/corp/sep_punct.pl. If it is changed,
#  this program should be suitably modified.      

# Important lines from sep_punct.pl are repeated here:
#  s/([\",:;'`\?><\]\[}{\)\(=!@#%&\*\.\xea])/ \1 /g;
#    # Removed '-', '_' in the above pattern, and added "\xea" KadI pAI

$deb = 0;  # Debug flag.

$white_f = $ARGV[0];
$contnt_f = $ARGV[1];
open (WHITE, "$white_f" ) || die "Unable to open file $white_f: $!\n";
open (CONTNT, "$contnt_f" )  || die "Unable to open file $contnt_f: $!\n";

while (<WHITE>) {
  if ($deb) { print '---', $_; }
  while ($_ ne '') {
    if (/^\s+/) { print $&;  $_ = $'; }  # Get and print white space
    elsif (/^[\",:;'`\?><\]\[}{\)\(=!@#%&\*\.\xea]/) { # Punct mark
      if ($deb) { print '-1-'; }
      $val = <CONTNT>;  chop ($val); print $val;  $_ = $';
    }
    elsif (/^[^\",:;'`\?><\]\[}{\)\(=!@#%&\*\.\xea\s]+/) { # Word
      if ($deb) { print '-2-'; }
      $val = <CONTNT>;  chop ($val); print $val;  $_ = $';
    }
    else { print STDERR "Unable to handle characters in $_." }
  }
}

