#!/usr/bin/perl
# Splits a sorted dictionary file into subfiles so that entries
# which begin with different characters go into a different file.
# Puts a header at the beginning and at the end of each file.

$hdr_beg = 'mailx tdass@macareo.pucp.edu.pe <<EOT' . "\n" .
           '~s Dict part: %filecount' . "\n" ;
           # '~c sangal' . "\n" ;
$hdr_end = 'EOT' . "\n" ;
$file_lim = 35000; # Limit on size of any individual file.

$filecount = 1;
$file_charcount = 0;
$_ = <>;
$file_charcount += length ($_);
$prevchar = substr ($_, 1, 1);
open (FF, ">xx$filecount.snd") ||
  die "Unable to open out file xx$filecount.snd: $!\n";
$hdr_tmp = $hdr_beg;  $hdr_tmp =~ s/%filecount/$filecount/;
print FF $hdr_tmp;
print FF;
while (<>) {
  $file_charcount += length ($_);
  if ( ($prevchar eq substr($_, 1, 1)) &&
       ($file_charcount <= $file_lim) ) { print FF; } # output to open file
  else { # dict entry start with a new char or file size limit reached.
         # Close presently open file, open a new file, and output the line.
    print FF $hdr_end;
    close (FF);
    $prevchar = substr ($_, 1, 1);
    $file_charcount = length ($_);
    $filecount++;
    open (FF, ">xx$filecount.snd") ||
      die "Unable to open out file xx$filecount.snd: $!\n";
    $hdr_tmp = $hdr_beg;  
    $hdr_tmp =~ s/%filecount/$filecount for $prevchar/;
    print FF $hdr_tmp;
    print FF;
  }
}
print FF $hdr_end;
close (FF);

