#!/usr/bin/perl
#%COMMENT
# Takes the punjabi-hindi dictionary and tries to identify
# entries that are dissimilar Hindi word for the punjabi
# word.
#   Example usage: dictpnjdiff.pl < IN  >OUT
# Also creates a file called 'rem' with remaining words.

#%CMD TYPE M1
$permit_diff = 2; # Maximum permissible diff in consonents. #OPT -p
$permit_cnt = 2; # Maximum permissible matching of consonents #OPT -p

$vowels = 'MHaAiIuUqeEoO';
$vowels_short = 'aiuqeo';
$vowels_long =  'AIUQEO';
$conson = 'kKgGfcCjJFtTdDNwWxXnpPbBmyrlvSRsh';
$conson_alpa = 'kgcjtdwxpb';
$conson_mahA = 'KGCJTDWXPB';
#open (REM, ">rem.dict") || die "Unable to open output file rem.dict\n";

LINE: while($a = <STDIN>) {
  $b = $a;
  $a =~ s/"//g;
  @fields = split(/,/, $a);
  $fields[0] =~ s/[\-Zz$vowels]//og;
  $fields[3] =~ s/[\-Zz$vowels]//og;
  if ($fields[3] =~ /\//) { @subfields = split(/\//, $fields[3]); }
  else { $subfields[0] = $fields[3]; }
  $lenpunj = length ($fields[0]);
  # If the punjabi word is found to be equal or similar to any of
  #  the hindi equivalents, go to the 'next LINE' of the dictionary.
  @chars = split (//, $fields[0]);
  #print STDERR "DEBUG: @chars\n";
  $found1nosim = 0;
  for($i=0;  $i <= $#subfields;  $i++){
    #print STDERR "DEBUG: A hindi word: $subfields[$i]\n";
    $mcnt = 0;
    for ($c=0;  $c <= $#chars;  $c++)  {
      if ($subfields[$i] =~ /$chars[$c]/) {
        $mcnt++;
        if ($mcnt > $permit_cnt) { next LINE; }
      }
    }
    #print STDERR "DEBUG: Not found. $subfields[$i]\n";
  }
  print $b;
}
#close REM;

