#!/usr/bin/perl
# Reverses the dictionary. Each entry consists of 3 fields, separated
# by 1 or more spaces. For example:
#	zafra nf PZasala; ganne-kI-katAI; XYZ
#	zaherir vt niMxA-karanA; AlocanA-karanA
#	zanahoria nf gAjara; XYZ
# The output will be:
#	AlocanA-karanA vt zaherir
#	PZasala nf zafra
#	XYZ nf zafra; zanahoria
#	gAjara nf zanahoria
#	ganne-kI-katAI nf zafra
#	niMxA-karanA vt zaherir

while (<>) {
  chop;
  if (/^\s+/) { $_ = $'; }  # Remove blanks at the beginning of line.
  @parts = split (/\s+/, $_, 3);
  if ($#parts != 2) {
    print STDERR "In line $. check dict entry: $_\n";    next;
  }
  ($sword, $pos, $twords) = split (/\s+/, $_, 3);
  @twords = split (/\s+/, $twords);
  foreach $tw (@twords) {
    if ($tw =~ /;$/) { $tw = $`; }  # Remove semicolon if any.
    print $tw, ' ', $pos, ' ', $sword, "\n";
  }
}
