#!/usr/bin/perl
# Takes a sorted dictionary file, and puts adjacent entries together
# if they have the same head word and lexical category.
#   Example usage: dictuniq.pl < dict.sort > dict.final

while (<>) {
  chop;
  if (/^\s+/) { $_ = $'; }  # Remove blanks at the beginning of line.
  @parts = split (/\s+/, $_, 3);
  if ($#parts != 2) {
    print STDERR "In line $. check dict entry: $_\n";    next;
  }
  ($sword, $pos, $rem) = @parts;
  #print "  DEB|"; foreach $p (@parts) { print $p, '|'; }  print "\n";  #DEBUG
  #print "  DEB:$sword,$pos,$rem,\n";  #DEBUG
  if ( ($prev_sword eq $sword)  &&  ($prev_pos eq $pos) ) {
    $prev_rem .= '; ' . $rem;
  }
  else {  
    if ($prev_sword ne '') {  # Not the first line.
      print $prev_sword, ' ', $prev_pos, ' ', $prev_rem, "\n";
    }
    $prev_sword = $sword;  $prev_pos = $pos;  $prev_rem = $rem;
  }
}
print $prev_sword, ' ', $prev_pos, ' ', $prev_rem, "\n";
