#!/usr/bin/perl
#%COMMENT
# Input file is a list of blocks sorted on attribute, each line containg
# a word form and an attribute. Name of the stem-attribute is set in $stem_attr.
# Computes strings to be deleted and added to the stem to get each line.
#  Example usage: bl_deladd.pl < IN   > OUT

#%CMD TYPE M1
#require ("/sangal/tools/anumorph/pdgm_d_s.pl"); # For home machine DOS
require ("/home/bharathi/PNJ1/usr3/sangal/tools/src/anumorph/pdgm_deladd_sub.pl");

$stem_attr = 'f1';  # Name of the attribute for which the word is the stem. #OPT -s
if ($stem_attr eq '') { print STDERR 'Stem attribute not given.',
             " Will be chosen arbitrarily for each block.\n";
}
$end_blk = "---\n";
$/ = $end_blk;
$len_sep = length ($/);
while (<>) {
  for ($i=1; $i <= $len_sep;  $i++) { chop; }  chop;
  $#rows = -1;  $#w = -1; $#attr = -1;
  @rows = split (/\n/);
    #print "DEB: //";  foreach $r (@rows) { print $r, '//'; }  print "\n";
  $stem = '';  $stem_found = 0;   $j = -1;
  foreach $r (@rows) {  # Split and find the stem (from the specified attr)
    $j++;
    ($w[$j], $attr[$j]) = split (/\s+/, $r);
    if ($attr[$j] eq $stem_attr) {
      if ($stem ne '') { print STDERR 'Two entries for the same',
        " attr $attr[$j] in a block: $w[$j], $stem\n";
      }
      else { $stem = $w[$j]; }
      $stem_found = 1;
    }
  }
  if (!($stem_found)) { 
    print STDERR 'Stem attribute not found for block. ',
           "Choosing first entry as stem.\n";
    $stem = $w[0];
  }
  #print STDERR "DEB: stem = $stem\n";

  # stem has been chosen. Now compute deladd strings.
  print $stem, "\n";
  for ($i=0; $i <= $#w;  $i++) {
    ($del, $add) = &find_deladd ($stem, $w[$i]);
    $line = '-' . $del . ',+' . $add;
    print $attr[$i], "\t", $line, "\n";
  }
  print $end_blk;
}
