#!/usr/bin/perl
# Generates a file with a list of (stem, paradigm type) on each line.
# Input: 
# 1. On STDIN the file is a list of blocks with stem, each block is on a 
# line. A block consists of items separated by '|'. The first item 
# in the block contains a stem. After that each item in
# the block contains an attribute and delete-add strings.
# 2. File with list of paradigms. (Each line contains a
# paradigm with several attribute and del-add string terminated by '|'.)
#
# Output: On STDOUT, a file with each line containing stem and its 
# pdgm type.
#
#     Example usage: bl_find_pdgm.pl < IN   > OUT

open (PDGM, "pdgm.lst") ||
  die "bl_find_pdgm.pl: Unable to open file pdgm.lst: $!\n";
$i = 0;
while (<PDGM>) {  # Load the paradigms
  chop;   $i++;   $pdgms{$_} = $i;
}
close (PDGM);

while (<>) {  # Now write stem and paradigm number
  chop;
  ($stem, $forms) = split (/::\t/);
  $val = $pdgms{$forms};
  if ($val > 0) { print $stem, "\t", $val, "\n"; }
}
