#!/usr/bin/perl
# Take the given input file of blocks (each block containing similar 
# words and their attributes) and shows those blocks which are larger
# than the given number.
# Each line in input file is: word, TAB, attribute
#   Example usage: bl_larger.pl < a.blk  > a_lrg.blk
# Options:
# -n	-  Count above which blocks are printed. 
require("/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/printusage.pl");

# Assumes that the args begin after the params. (Each param begins by -)
local ($i, $parmlastpos, $argbegpos, $Finname, $Foutname);
local ($max_cnt);
$parmlastpos = -1; # Gives pos of last param in ARGV. Default no params.
$argbegpos = -1;  # Gives position of 1st argument in ARGV. Default no args
$max_cnt = 5; # Default  Count above which blocks are printed. 

# Look up .bl_largerrc file. Override defaults.
if (open (RC, '.bl_largerrc')) {
  while (<RC>) {
    chop;
    if (/\s*#/) {  next; }   # Ignore. A comment line.
    if (/\s*-/) {  # A parameter found.
      $_ = '-' . $';
      if (substr($_,1,1) eq 'h') { # print help info.
        &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/anumorph/bl_larger.cmd');
        die;
      }
      elsif (substr($_,1, 1) eq  'n') {
        $max_cnt = substr ($_, 2);
      }
      else { 
          print STDERR "bl_larger.cmd: Unrecognized param in rc file: $_.\n";
          &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/anumorph/bl_larger.cmd');
          die;
      }
    }
    else { # 
      print STDERR "bl_larger.cmd: Param must begin with '-' in rc file: $_. Ignoring.\n";
    }
  }
  close (RC);
}

for ($i=0; $i <= $#ARGV; $i++) { # Extract the parameters and locate
                                 #  starting loc of command args.
     # Command line args override those of the rc file.
  if (substr($ARGV[$i],0,1) eq '-') {  # A parameter found.
    $parmlastpos++;  # Change the following lines to suit your needs.
    if (substr($ARGV[$i],1,1) eq 'h') { # print help info.
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/anumorph/bl_larger.cmd');
      die;
    }
    elsif (substr($ARGV[$i],1, 1) eq  'n') {
      $max_cnt = substr ($ARGV[$i], 2);
    }
    else { 
        print STDERR "bl_larger.cmd: Unrecognized param: $ARGV[$i].\n";
        &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/anumorph/bl_larger.cmd');
        die;
    }
  }
  else { # Argument found. Parameters end.
    $argbegpos = $i;
    last;
  }
}

# Process the arguments in the command line then call bl_larger.
# 1. Can be used as a filter. OR
# 2. file args can be given instead of filters.

if ($argbegpos < 0) { # No args.
  &bl_larger(STDIN, STDOUT);
}
elsif (($#ARGV - $argbegpos) == 0) { # Only one arg given. Execute the command with arg and stdout.
  open (INFILE, "$ARGV[$argbegpos]") ||
     die "bl_larger.cmd: Unable to open file $ARGV[$argbegpos]\n" ;
  $Finname = $ARGV[$argbegpos];  $Foutname = '';
  &bl_larger(INFILE, STDOUT);
  close (INFILE);
}
elsif (($#ARGV - $argbegpos) == 1) { # Two args given. Execute the command with arg1 and arg2.
  open (INFILE, "$ARGV[$argbegpos]") ||
     die "bl_larger.cmd: Unable to open input file $ARGV[$argbegpos]\n" ;
  open (OUTFILE, ">$ARGV[$argbegpos + 1]") ||
     die "bl_larger.cmd: Unable to open output file $ARGV[$argbegpos + 1]\n" ;
  $Finname = $ARGV[$argbegpos];  $Foutname = $ARGV[$argbegpos+1];  
  &bl_larger(INFILE, OUTFILE);
  close (OUTFILE);
  close (INFILE);
}
else { print STDERR "bl_larger.cmd: Too many arguments.\n"; }
#------------------------------------------------------

sub bl_larger {
local ($W_fin, $W_fout) = @_;
select($W_fout);
#%COMMENT
# Take the given input file of blocks (each block containing similar 
# words and their attributes) and shows those blocks which are larger
# than the given number.
# Each line in input file is: word, TAB, attribute
#   Example usage: bl_larger.pl < a.blk  > a_lrg.blk
#%CMD TYPE 11


$end_blk = "---\n";
$/ = $end_blk;
$len_sep = length ($/);
while (<$W_fin>) { # Read a block at a time.
  if (/$end_blk$/) { # Remove the block end marker
    for ($i=1; $i <= $len_sep;  $i++) { chop; }  chop;
  }
  else { print STDERR "Warn: End of block not found: $_\n"; }
  $#rows = -1;
  @rows = split (/\n/);
    #print STDERR "DEB: //";  foreach $r (@rows) { print STDERR $r, '//'; }  print STDERR "\n";
  if (($#rows + 1) >= $max_cnt) { print $_, "\n", $end_blk; }
}
}
1;
