#!/usr/bin/perl
# Input file is a list of blocks. First line in the block
# contains stem. After that each line in the block contains
# an attribute and delete-add strings.
# Produces two output files:
#  1. All the attr and del-add strings for a block on a line,
#     terminated by a new line. (in bl_pdgm.tmp)
#  2. The above, but prefixed by the stem and "::\t"  (in STDOUT)
#
#       Example usage: bl_pline.pl < IN   > OUT

$end_blk = "---\n";     # block terminator.
$/ = $end_blk;
$len_sep = length ($/);
open (TMPPDGM, ">bl_pdgm.tmp") ||
  die "bl_pline.pl: Unable to open out file bl_pdgm.tmp: $!\n";
while (<>) {
  for ($i=1; $i <= $len_sep;  $i++) { chop; }  chop;
  $#rows = -1;
  @rows = split (/\n/);
  $stem = $rows[0];    # First row in the block contains stem.
    #print "DEB: //";  foreach $r (@rows) { print $r, '//'; }  print "\n";
  print $stem, "::\t";   # In stdout put the stem also.
  for ($i=1;  $i <= $#rows;  $i++) { 
    print $rows[$i], '|';
    print TMPPDGM $rows[$i], '|';
  }
  print "\n";
  print TMPPDGM "\n";
}
close (TMPPDGM);
