#!/usr/bin/perl
# Take the given input file of blocks (each block containing similar 
# words and their attributes) and 
# gives some statistics about them. It computes:
#   Size of block, frequency (number of blocks with that size)
# Each line in input file is: word, TAB, attribute
#   Example usage: bl_stat.pl < a.blk  > a.stat

# Data structure: @size_cnt
# $size_cnt[3] == 70  means that 70 blocks have been found with
#       size 4  i.e., it has four words (0 to 3).

$end_blk = "---\n";
$/ = $end_blk;
$len_sep = length ($/);
while (<>) { # Read a block at a time.
  if (/$end_blk$/) { # Remove the block end marker
    for ($i=1; $i <= $len_sep;  $i++) { chop; }  chop;
  }
  else { print STDERR "Warn: End of block not found: $_\n"; }
  $#rows = -1;
  @rows = split (/\n/);
    #print STDERR "DEB: //";  foreach $r (@rows) { print STDERR $r, '//'; }  print STDERR "\n";
  if ($#rows >= 0) { $size_cnt[$#rows]++; }
}
# Now print the result.
for ($i=0;  $i <= $#size_cnt;  $i++) {
  if ($size_cnt[$i] != 0) {
    $bl_size = $i + 1;
    print "$bl_size\t$size_cnt[$i]\n";
    $tot_cnt += $size_cnt[$i];
  }
}
print "Total blocks = $tot_cnt\n";
