#!/usr/bin/perl
# Load categories, and feature values for the morph paradigms.
# Assumes the following files exist in the current directory:
# Mappings:
#  Ca - List of cat names in paradigms and their mapping to real cats.
#  map_file - Feature names in paradigms and their real feature names.
# Paradigm table dimensionality:
#  Ce - Cat names in paradigms and the features that vary.
#       (Features are given by paradigm feature names)
#  Fe - Features names in Paradigms and their values (same as real values).
# Variables set:
# $pardgmdir - Name of directory to be used for reading files Ca, Ce etc.

if ($pardgmdir eq '') { $pardgmdir = '.'; }
open (CATMAP, "$pardgmdir/Ca") || die "ldcatfv.pl: Unable to open file: $pardgmdir/Ca\n";
open (FMAP, "$pardgmdir/map_file") || die "ldcatfv.pl: Unable to open file: $pardgmdir/map_file\n";
open (PDIM, "$pardgmdir/Ce")   || die "ldcatfv.pl: Unable to open file: $pardgmdir/Ce\n";
open (PFV, "$pardgmdir/Fe")    || die "ldcatfv.pl: Unable to open file: $pardgmdir/Fe\n";

while (<CATMAP>) {chop; ($pcat, $cat) = split(/\s+/); $catmap_arr{$pcat} = $cat;}
while (<FMAP>) {chop; ($pfeat, $feat) = split(/\s+/); $featmap_arr{$pfeat} = $feat;}
while (<PDIM>) { 
  chop;
  ($pcat, $pfeat) = split(/\s+/, $_, 2);
  $pdim_arr{$pcat} = $pfeat;
  # $dim_arr{ $catmap_arr{$pcat} } .= $featmap_arr{$pfeat};
}
while (<PFV>)  {
  chop;
  ($pfeat, $vals) = split(/\s+/, $_, 2); 
  $pfv_arr{$pfeat} = $vals;
  # $fv_arr{ $featmap_arr{$pfeat} } .= $vals;
}

# print STDERR "DEBUG: pcat and pfeatures:\n";
# while (($k, $v) = each (%pdim_arr)) {
#   print  STDERR "DEBUG: $k  $v\n";
#      print STDERR "DEBUG>>>>>>: $catmap_arr{$k}  $featmap_arr{$v}\n";
# }
1;
