#!/usr/bin/perl
#%COMMENT
# Takes an input file consisting of different word forms of 
# a root, one on each line. On each line, produces the delete 
# and add strings (to the root) to obtain each word form. 
#   pardgm_deladd.pl -rROOT  < TEST.wrd   >  TEST.add
# 
# Variables set from calling *.cmd routine:
#   $root - Guessed/given root 
#%CMD TYPE M1

$root = 'NONE'; # Guessed or given root for the word forms. #OPT -r

while (<>) {
  chop;
  if (/\s+$/) { $_ = $`; }
  if (/^\s+/) { $_ = $'; }
    # print STDERR "DEBUG: root=$root";
  ($del, $add) = &find_deladd ($root, $_);
    # print STDERR "  del=$del, add=$add,\n";  #DEBUG
  $line = '-' . $del . ',+' . $add;
  print $line, "\n";
}


# Inputs are: a root and a word form.
# Returns the charstrings to be deleted from and added to root 
# to obtain the wordform.
sub find_deladd {
  local ($root, $wordform) = @_;
  local ($len_root, $len_wordform, $len_min, $i, $pre, $del, $add);
  $len_root = length $root;
  $len_wordform = length $wordform;
  if ($len_root < $len_wordform) { $len_min = $len_root; }
  else { $len_min = $len_wordform; }
  $pre = -2;
  for ($i=0;  $i <= $len_min;  $i++) {
    if ( substr($root, $i, 1) ne substr($wordform, $i, 1) ) {
      $pre = $i - 1;  last;
    }
  }
  if ($pre == -2) { # No mismatch found upto length $len_min.
    if ($len_root == $len_wordform) { $del = $add = ''; }
    elsif ($len_root < $len_wordform) {
      $del = '';   $add = substr($wordform, $len_min);
    } 
    else { $del = substr($root, $len_min);  $add = ''; } 
  }
  else {
    $del = substr ($root, $pre + 1);   $add = substr ($wordform, $pre + 1);
  }
  #print STDERR "find_deladd DEBUG: $root=$root, wordform=$wordform, del=$del, add=$add,\n";
  return ($del, $add);
}
1;
