#!/usr/bin/perl
#%COMMENT
# Takes an input file consisting of a histogram of prefixes
# computed for a set of words sorted on frequencies.
#   Example usage:  prefx_sel.cmd  -p3  -n4  < TEST.histo
# Selects those prefixes which are 3 or more character longer,
# and which have 4 or more frequency of occurrence.
#%CMD TYPE 11

$min_len = 3; # Min length of a prefix (default 3).  #OPT -p
$min_cnt = 4; # Min frequency for a prefix (default 4).  #OPT -n


while (<>) {
  chop;
  ($cnt, $prefix) = split (/\s+/);
  #print STDERR  "DEBUG: cnt=$cnt, prefix=$prefix,\n";
  $lenprefix = length ($prefix);
  if (($lenprefix >= $min_len) && ($cnt >= $min_cnt)) { print $_, "\n";}
}

