#!/usr/bin/perl
# Takes an input paradigm file (*.p) with del-add strings, and
# modifies them assuming that the root has any vowel at the end.
# Options:
# -s	-  Suffix to be used for the output file. 

require("/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/printusage.pl");

# Assumes that the args begin after the params. (Each param begins by -)
local ($i, $parmlastpos, $argbegpos, $arg, $suff, $argsinfile, $Finname, $Finname);
local ($suff);
$parmlastpos = -1; # Gives pos of last param in ARGV. Default no params.
$argbegpos = -1;  # Gives position of 1st argument in ARGV. Default no args
$argsinfile = 0;  # Default args file names are not in a file.
$suff = '.new'; # Default suffix for output file if necessary.
$suff = '.r'; # Default  Suffix to be used for the output file. 

# Look up .pardgm_rrc file. Override defaults.
if (open (RC, '.pardgm_rrc')) {
  while (<RC>) {
    chop;
    if (/\s*#/) {  next; }   # Ignore. A comment line.
    if (/\s*-/) {  # A parameter found.
      $_ = '-' . $';
      if (substr($_,1,1) eq 'h') { # print help info.
        &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/morph/pardgm_r.cmd');
        die;
      }
      elsif (substr($_,1, 1) eq  's') {
        $suff = substr ($_, 2);
      }
      else { 
          print STDERR "pardgm_r.cmd: Unrecognized param in rc file: $_.\n";
          &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/morph/pardgm_r.cmd');
          die;
      }
    }
    else { # 
      print STDERR "pardgm_r.cmd: Param must begin with '-' in rc file: $_. Ignoring.\n";
    }
  }
  close (RC);
}

for ($i=0; $i <= $#ARGV; $i++) { # Extract the parameters and locate
                                 #  starting loc of command args.
  if (substr($ARGV[$i],0,1) eq '-') {  # A parameter found.
    $parmlastpos++;  # Change the following lines to suit your needs.
    if (substr($ARGV[$i],1,1) eq 'h') { # print help info.
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/morph/pardgm_r.cmd');
      die;
    }
    elsif (substr($ARGV[$i],1,1) eq 's') { # Suffix for output file names.
       $suff = substr ($ARGV[$i],2);
    }
    elsif (substr($ARGV[$i],1, 1) eq  's') {
      $suff = substr ($ARGV[$i], 2);
    }
    else  { print STDERR "pardgm_r.cmd: Parameter not recognized $ARGV[$i].\n";
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/morph/pardgm_r.cmd');
      die;
    }
  }
  else { # Argument found. Parameters end.
    if (substr($ARGV[$i],0,1) eq '@') {  # A file of args found
      $argsinfile = 1;
      $ARGV[$i] = substr($ARGV[$i], 1);
    }
    $argbegpos = $i;
    last;
  }
}
#print STDERR "pardgm_r.cmd: DEB params end: $parmlastpos;  args begin: $argbegpos; total: $#ARGV;\n";

# Process the arguments in the command line then call pardgm_r.
# 1. Can be used as a filter. OR
# 2. If one or more file arguments are given, they are treated as
#    inputs files, and the output file name is given
#    by the input file name suffixed by the default suffix
#    (which can be changed by approp flag).

if ($argbegpos < 0) { # No args.
  &pardgm_r(STDIN, STDOUT);
}
elsif ($argsinfile) {  # Argument filenames in file.
  open (ARGFILE, "$ARGV[$argbegpos]") ||
    die "pardgm_r.cmd: Unable to open args file $ARGV[$argbegpos]\n" ;
  while (<ARGFILE>) { # Read args.
    chop;
    if (!(open (INFILE, $_))) {
      print STDERR "pardgm_r.cmd: Unable to open file $_\n" ;
      next;
    }
    if (!(open (OUTFILE, ">$_$suff"))) {
      print STDERR "pardgm_r.cmd: Unable to open out file $_$suff\n";
      close (INFILE);
      next;
    }
    $Finname = $_;  $Foutname = $_ . $suff;
    &pardgm_r (INFILE, OUTFILE);
    close (INFILE);
    close (OUTFILE);
  }
  close (ARGFILE);
}
else { # Call the program with each arg. 
  for ($arg = $argbegpos; $arg <= $#ARGV; $arg++) {
    if (!(open (INFILE, "$ARGV[$arg]"))) {
      print STDERR "pardgm_r.cmd: Unable to open file $ARGV[$arg]\n" ;
      next;
    }
    if (!(open (OUTFILE, ">$ARGV[$arg]$suff"))) {
      print STDERR "pardgm_r.cmd: Unable to open out file $ARGV[$arg]$suff\n";
      close (INFILE);
      next;
    }
    $Finname = $ARGV[$arg];
    $Foutname = $ARGV[$arg] . $suff;  
    &pardgm_r (INFILE, OUTFILE);
    close (INFILE);
    close (OUTFILE);
  }
}
#------------------------------------------------------

sub pardgm_r {
local ($W_fin, $W_fout) = @_;
select($W_fout);
#%COMMENT
# Takes an input paradigm file (*.p) with del-add strings, and
# modifies them assuming that the root has any vowel at the end.
#%CMD TYPE MM

$vowel = 'aAiIuUeEoOMHz';
#@vowel = (a,A,i,I,u,U,e,E,o,O,M,H,z);
while (<$W_fin>) {
  chop;
  ($pre, $deladd) = split (/\s+/);
  if ($deladd eq '') {
    if ($pre =~ /^-/) {
      print STDERR "Root/features not specified. Continuing:$_\n";
      $deladd = $pre;    $pre = '';
    }
    else { 
      print STDERR "Root/feature not specified. Ignoring:$_\n"; 
      next;
    }
  }
  ($del, $add) = split (/,/, $deladd);

  $frstchar = substr ($add, 1, 1);  # first char after '+'.
  if ($vowel =~  /$frstchar/) { # first char is a vowel in add string.
    $del =~ /.$/;  $lstchar = $&;
    if ($vowel =~  /$lstchar/) { # last char is a vowel in del string.
      $add = '+' . substr ($add, 2);  # Remove the first char.
      chop ($del);
    }
  }
  if ($pre =~ /(.){/) { $pre = $` . 'Q{' . $'; }
  else { print STDERR "Invalid string: $pre. Continuing.\n"; }

  if ($pre eq '') { print $del, ',', $add, "\n"; }
  else { print $pre, '    ', $del, ',', $add, "\n"; }
}
}
1;
