#!/usr/bin/perl
#%COMMENT
# Takes an input paradigm file (*.p) with del-add strings, and
# modifies them assuming that the root has any vowel at the end.
#%CMD TYPE MM

$suff = '.r'; # Suffix to be used for the output file. #OPT -s
$vowel = 'aAiIuUeEoOMHz';
#@vowel = (a,A,i,I,u,U,e,E,o,O,M,H,z);
while (<>) {
  chop;
  ($pre, $deladd) = split (/\s+/);
  if ($deladd eq '') {
    if ($pre =~ /^-/) {
      print STDERR "Root/features not specified. Continuing:$_\n";
      $deladd = $pre;    $pre = '';
    }
    else { 
      print STDERR "Root/feature not specified. Ignoring:$_\n"; 
      next;
    }
  }
  ($del, $add) = split (/,/, $deladd);

  $frstchar = substr ($add, 1, 1);  # first char after '+'.
  if ($vowel =~  /$frstchar/) { # first char is a vowel in add string.
    $del =~ /.$/;  $lstchar = $&;
    if ($vowel =~  /$lstchar/) { # last char is a vowel in del string.
      $add = '+' . substr ($add, 2);  # Remove the first char.
      chop ($del);
    }
  }
  if ($pre =~ /(.){/) { $pre = $` . 'Q{' . $'; }
  else { print STDERR "Invalid string: $pre. Continuing.\n"; }

  if ($pre eq '') { print $del, ',', $add, "\n"; }
  else { print $pre, '    ', $del, ',', $add, "\n"; }
}
