#!/usr/bin/perl
# Generates word forms given a root and a file containg
# delete add strings, one on each line.
#   Example usage: word_gen.pl  -rCele  < Cele.add  > Cele.wrd
# Cele.add is a file containg del and add strings for the different 
# forms of Cele. The root is given by -r option. The output file
# Cele.wrd contains the generated word forms.
# Example format of the input file:
#  -A,+e
#  -A,+oM

$root = 'NONE'; # Root for which the word forms have to be generated. #OPT -r

while (<>) {
  chop;
  ($del, $add) = split (/\,/);
  $del = substr ($del, 1);
  $add = substr ($add, 1);
    # print STDERR "DEBUG: delstring=$del, addstring=$add,\n";
  if ($root =~ /$del$/) { $word = $` . $add; }
  else { # String to be deleted not found. Do some approx.
    $minuslen = length($_) - length($del);
    $word = substr ($root, 0, $minuslen ) . $add;
  }
  print $word, "\n";
}

