#!/usr/bin/perl
# Takes an input file consisting of different word forms of 
# a root, one on each line.  Produces a file of histograms
# on length of words, and some other statistics.
#   word_stat.pl < TEST.wrd
# 

$i = -1;  $maxlen = -1;  $minlen = 10000;
while (<>) {  # Store words in array @wrds. Build a histogram @histo_len. 
  chop;  $i++;  $wrds[$i] = $_;
  $len = length ($_);
  $histo_len[$len]++;
     # if ($len > $maxlen) { $maxlen = $len;}
  if ($len < $minlen) { $minlen = $len; }
}
$maxlen = $#histo_len;
$sum = $cnt = 0;
print STDERR "cnt   wordlength   <- length histogram\n";  # Print histogram
for ($i=1;  $i <= $#histo_len;  $i++) {
  if ($histo_len[$i] != 0) { 
    print STDERR "$histo_len[$i] $i\n";  # Print histogram
    $sum += $i * $histo_len[$i];  $cnt += $histo_len[$i];
  }
}
$ave = $sum / $cnt;
print STDERR sprintf ("avelen=%5.2f, maxlen=%2d, minlen=%2d,\n",
  $ave, $maxlen, $minlen);

# Find one common prefix (for all the words).
$pre = $wrds[0];
for ($i=1;  $i <= $#wrds;  $i++) {
  for ($j=0;  $j <= length($pre);  $j++) {  # For ith word find the new prefix
    if ( substr($pre, $j, 1)  ne  substr($wrds[$i], $j, 1) ) {
      $newpre = substr ($pre, 0, $j);  last;
    }
  }
  $pre = $newpre;
}
$prefix = $pre;
print STDERR "Common prefix=$prefix,\n";

