#!/usr/bin/perl
#%COMMENT
# Given a file of word forms, the likely roots underlying the word
# forms, and a file of possible paradigm; guess whether
# the paradigm is satisfied by the word forms.
# Example usage: 
#   pdgm_guess.cmd  -rbanXu.pre  -pCele.add  -wbanXu.wrd  > banXu.par

#%CMD TYPE 11

$rootfile = 'NONE';  # File name containing likely roots. #OPT -r
$pardgmfile = 'NONE';  # File name containing a paradigm (del add strings). #OPT -p
$wrdfile = 'NONE';  # File name containing word forms. #OPT -w

open (ROOTFILE, "$rootfile") ||
  die "pdgm_guess.pl: Unable to open file $rootfile: $!\n";
$i = -1;
while (<ROOTFILE>) {  # Read all the roots with their counts.
  chop;  $i++;
  ($cnt, $root) = split (/\s+/);
  #print STDERR  "DEBUG: cnt=$cnt, root=$root,\n";
  $root[$i] = $root;  $count[$i] = $cnt;
}

$maxscore = $maxscore_of_root = -1;
for ($r=0;  $r <= $#root;  $r++) { # Now try the roots one by one.
  system ("pdgm_deladd.cmd  -r$root[$r]  < $wrdfile > $wrdfile.p.tmp");
  open (W_PARDGMFILE, "$wrdfile.p.tmp") ||
      die "pdgm_guess.pl: Unable to open file $wrdfile.p.tmp: $!\n";
  while (<W_PARDGMFILE>) {
    chop;
    #print STDERR "DEBUG: grep '^$_\$' $pardgmfile >> $wrdfile.tmp", "\n";
    $res = `grep '^$_\$' $pardgmfile`;
    #print STDERR "DEBUG: $res";
    if ($res ne '') { $score[$r]++; }  # Found. Add to score.
  }
  if ($score[$r] > $maxscore) { 
    $maxscore = $score[$r];     $maxscore_of_root = $r;
  }
}
print STDERR "DEBUG: root no.=$maxscore_of_root,  score=$maxscore,\n";
print STDERR "Best root: $root[$maxscore_of_root]\n";

