#!/usr/bin/perl
# Takes a file containing add and delete strings in paradigm,
# and breaks them into separate files. The files are named after
# the roots in the paradigm file.
#   Example usage: pdgm_sep.pl < noun.p.add
#
# Sample input file:
# ADI
# ADI{number=s,case=d,}    -,+
# ADI{number=s,case=o,}    -,+
# ADI{number=p,case=d,}    -I,+yA
# ADI{number=p,case=o,}    -,+M

$suffix = '.p';
while (<>) {
  if (!(/{.*}/)) { # Line contains the name of the root/paradigm
    chop;
    close ($parfile);
    if (-e "$_$suffix") { 
      print STDERR 
        "File $_$suffix already exists. Writing to TEMP$suffix\n";
      open ($parfile, ">>TEMP$suffix") ||
        die "Unable to open out file $_: $!\n";
      
    }
    else {
      open ($parfile, ">$_$suffix") ||
        die "Unable to open out file $_$suffix: $!\n";
    }
  }
  else { print $parfile $_; }
}
    
