#!/usr/bin/perl
# Output files generated by pfx_cluster.pl
# on a set of files (say, xaa, xab, ...) are merged by
# this command.
# (Actually, it uses the output files xaa.1.tmp, xab.1.tmp, etc.
# generated by pfx_cluster.pl command.)
#   pfx_cluster_merge.pl   xaa xab xac ...
# The output is placed in xaaall.1.tmp, xaall.2.tmp, etc.

# Sort and merge the files:
$comstr = 'sort  ';
for ($i=0;  $i <= $#ARGV;  $i++)  {
  $comstr .=  $ARGV[$i] . '.1.tmp ';
}
$comstr .= " > $ARGV[0]all.1a.tmp";
 #print STDERR "DEBUG: Executing... $comstr\n";
system ("$comstr");

# Now merge lines with the same word but different frequency
open (INP, "$ARGV[0]all.1a.tmp") ||
  die "Unable to open file $ARGV[0]all.1.tmp: $!\n";
open (OUTP, ">$ARGV[0]all.1.tmp") ||
  die "Unable to open out file $ARGV[0]all.1.tmp: $!\n";
$_ = <INP>;   chop;  ($cnt, $wrd) = split (/\s+/);
$prevcnt = $cnt;  $prevwrd = $wrd;
while (<INP>) {
  chop;  ($cnt, $wrd) =  split (/\s+/);
  if ($wrd eq $prevwrd) { $prevcnt += $cnt; }
  else { 
    print OUTP $prevcnt, ' ', $prevwrd, "\n";
    $prevcnt = $cnt;  $prevwrd = $wrd;
  }
}
print OUTP $prevcnt, ' ', $prevwrd, "\n";
close INP;  close OUTP;


# Remove prefixes of size less than 3, and count less than 4.
system ("pfx_sel.cmd  -n4 < $ARGV[0]all.1.tmp  > $ARGV[0]all.2.tmp");

# Reverse sort the histogram based on prefix (and then count).
system ("sort -r +1 $ARGV[0]all.2.tmp  > $ARGV[0]all.3.tmp");

# Remove shorter prefixes with the same count as longer ones.
# '-lnone' means no other cutoff criterion is used.
system ("pfx_prune.cmd -lnone < $ARGV[0]all.3.tmp  > $ARGV[0]all.4.tmp");

# Reverse sort the histogram based on count (then prefix).
system ("sort -nr  $ARGV[0]all.4.tmp  > $ARGV[0]all.r.tmp");

