#!/usr/bin/perl
# Takes an input file consisting of different word forms of 
# a root, one on each line.  Produces a file of all possible
# prefixes of the words with their counts, ie, a histogram of
# prefixes.
#   pfx_histo.pl < TEST.wrd
# 

$i = -1;
while (<>) {  # Store words in array @wrds.
  chop;  $i++;  $wrds[$i] = $_;
}

# Build a histogram of prefixes
for ($i=0;  $i <= $#wrds;  $i++) {
  $len_cur_word = length($wrds[$i]);
  for ($j=1;  $j <= $len_cur_word;  $j++) {  
    # For ith word store a prefix of length $j.
    $pre = substr ($wrds[$i], 0, $j);
    $histo_pre{$pre} += 1;
  }
}
while ( ($pre, $cnt) = each(%histo_pre)) {
  print "$cnt $pre\n";
}

