#!/usr/bin/perl
# Put block separators given the input file of words forms (with
# attributes). Each block will contain only "similar" word forms.

$separator = "---\n";
$cur_pre = 'zzzzzzzzz'; 
while (<>) {
  chop;
  ($w, $attr) = split (/\s+/);
  $new_pre = &find_pre ($w, $cur_pre);
  $score = &eval_score ($new_pre, $cur_pre, $w);
  if ($score <= 5) { # block ends.
    print $separator;  print $_, "\n";
    $cur_pre = $w;
  }
  else { print $_, "\n"; }
}
# Gives the score by matching new proposed and old prefix.
sub eval_score {
  local ($new_pre, $old_pre, $w) = @_;
  local $l_new, $l_old;
  $l_new = length ($new_pre);
  $l_old = length ($old_pre);
  if (($l_new/$l_old) < .5) { return (1); }
  elsif ($l_new <= 2) { return (4); }
  else { return(9); }
}
# Given a new word and a current prefix, compute the new largest prefix.
sub find_pre {
  local ($w, $pre) = @_;
  $prop_pre = $pre;  # Propose the prefix same as before.
  while ($prop_pre ne '') {
    if ($w =~ /^$prop_pre/) { return ($prop_pre); }
    chop ($prop_pre);
  }
  return '';
}
