#!/usr/bin/perl
#%COMMENT
# Take the given input file of blocks (each block containing similar 
# words and their attributes with suffixes also marked),
# and produce in the output the following for each line: 
#   word  stem{SUFF}
# The block boundaries "---\n" are removed.
#   Example usage: bl_stem_n.pl < a.blk  > a.stem
#
#%CMD TYPE 11

$end_blk = "---\n";
$/ = $end_blk;
$len_sep = length ($/);
while (<>) { # Read a block at a time.
  $blk_stem = '';
  if (/$end_blk$/) { # Remove the block end marker
    for ($i=1; $i <= $len_sep;  $i++) { chop; }  chop;
  }
  else { print STDERR "Warn: End of block not found: $_\n"; }
  $#rows = -1;  $#w = -1; $#attr = -1; $#prop = -1;
  $j = -1;
  @rows = split (/\n/);
    #print STDERR "DEB: //";  foreach $r (@rows) { print STDERR $r, '//'; }  print STDERR "\n";
  foreach $r (@rows) {  # Load each word and its attribute.
    $j++;
    ($w[$j], $attr[$j]) = split (/\s+/, $r);
    if ($attr[$j] =~ /_ALONE$/) { 
      if ($blk_stem ne '') {
        print STDERR 'bl_stem.pl: Two stems found in block: ',
                     "$blk_stem, $w[$j]\n";
      }
      $prop[$j] = 'STEM';  $blk_stem = $w[$j];
    }
    elsif ($attr[$j] =~ /_STEM$/) { 
      if ($blk_stem ne '') {
        print STDERR "bl_stem.pl: Two stems found in block: $blk_stem, $w[$j]\n";
      }
      $prop[$j] = 'STEM'; $blk_stem = $w[$j];
    }
    elsif ($attr[$j] =~ /_([^_]+)$/) { $prop[$j] = $1; }
    else {
      $prop[$j] = '';
      print STDERR 'bl_stem.pl: Suffix not found in: ',
                   "$w[$j] $attr[$j]\n";
    }
  }
  if ($blk_stem eq '') {
    print STDERR "bl_stem.pl: No stem found in block. First word: $w[0]\n";
  }
    #print STDERR "DEB: //";  foreach $w (@w) { print STDERR $w, '//'; }  print STDERR "\n";
  for ($i=0; $i <= $#w;  $i++) { # Print the words with their stems.
    print "$w[$i]\t$blk_stem", '{', $prop[$i], '}', "\n";
  }
}
