#!/usr/bin/perl
# Options:
# -r	-  Root for which the word forms have to be generated. 

require("/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/printusage.pl");

# Assumes that the args begin after the params. (Each param begins by -)
local ($i, $parmlastpos, $argbegpos, $arg, $suff, $argsinfile, $Finname, $Finname);
local ($root);
$parmlastpos = -1; # Gives pos of last param in ARGV. Default no params.
$argbegpos = -1;  # Gives position of 1st argument in ARGV. Default no args
$argsinfile = 0;  # Default args file names are not in a file.
$suff = '.new'; # Default suffix for output file if necessary.
$root = 'NONE'; # Default  Root for which the word forms have to be generated. 

# Look up .word_genrc file. Override defaults.
if (open (RC, '.word_genrc')) {
  while (<RC>) {
    chop;
    if (/\s*#/) {  next; }   # Ignore. A comment line.
    if (/\s*-/) {  # A parameter found.
      $_ = '-' . $';
      if (substr($_,1,1) eq 'h') { # print help info.
        &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/anumorph/word_gen.cmd');
        die;
      }
      elsif (substr($_,1, 1) eq  'r') {
        $root = substr ($_, 2);
      }
      else { 
          print STDERR "word_gen.cmd: Unrecognized param in rc file: $_.\n";
          &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/anumorph/word_gen.cmd');
          die;
      }
    }
    else { # 
      print STDERR "word_gen.cmd: Param must begin with '-' in rc file: $_. Ignoring.\n";
    }
  }
  close (RC);
}

for ($i=0; $i <= $#ARGV; $i++) { # Extract the parameters and locate
                                 #  starting loc of command args.
  if (substr($ARGV[$i],0,1) eq '-') {  # A parameter found.
    $parmlastpos++;  # Change the following lines to suit your needs.
    if (substr($ARGV[$i],1,1) eq 'h') { # print help info.
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/anumorph/word_gen.cmd');
      die;
    }
    elsif (substr($ARGV[$i],1,1) eq 's') { # Suffix for output file names.
       $suff = substr ($ARGV[$i],2);
    }
    elsif (substr($ARGV[$i],1, 1) eq  'r') {
      $root = substr ($ARGV[$i], 2);
    }
    else  { print STDERR "word_gen.cmd: Parameter not recognized $ARGV[$i].\n";
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/anumorph/word_gen.cmd');
      die;
    }
  }
  else { # Argument found. Parameters end.
    if (substr($ARGV[$i],0,1) eq '@') {  # A file of args found
      $argsinfile = 1;
      $ARGV[$i] = substr($ARGV[$i], 1);
    }
    $argbegpos = $i;
    last;
  }
}
#print STDERR "word_gen.cmd: DEB params end: $parmlastpos;  args begin: $argbegpos; total: $#ARGV;\n";

# Process the arguments in the command line then call word_gen.
# 1. Can be used as a filter. OR
# 2. If one or more file arguments are given, they are treated as
#    inputs files, and the output file name is given
#    by the input file name suffixed by the default suffix
#    (which can be changed by approp flag).

if ($argbegpos < 0) { # No args.
  &word_gen(STDIN, STDOUT);
}
elsif ($argsinfile) {  # Argument filenames in file.
  open (ARGFILE, "$ARGV[$argbegpos]") ||
    die "word_gen.cmd: Unable to open args file $ARGV[$argbegpos]\n" ;
  while (<ARGFILE>) { # Read args.
    chop;
    if (!(open (INFILE, $_))) {
      print STDERR "word_gen.cmd: Unable to open file $_\n" ;
      next;
    }
    if (!(open (OUTFILE, ">$_$suff"))) {
      print STDERR "word_gen.cmd: Unable to open out file $_$suff\n";
      close (INFILE);
      next;
    }
    $Finname = $_;  $Foutname = $_ . $suff;
    &word_gen (INFILE, OUTFILE);
    close (INFILE);
    close (OUTFILE);
  }
  close (ARGFILE);
}
else { # Call the program with each arg. 
  for ($arg = $argbegpos; $arg <= $#ARGV; $arg++) {
    if (!(open (INFILE, "$ARGV[$arg]"))) {
      print STDERR "word_gen.cmd: Unable to open file $ARGV[$arg]\n" ;
      next;
    }
    if (!(open (OUTFILE, ">$ARGV[$arg]$suff"))) {
      print STDERR "word_gen.cmd: Unable to open out file $ARGV[$arg]$suff\n";
      close (INFILE);
      next;
    }
    $Finname = $ARGV[$arg];
    $Foutname = $ARGV[$arg] . $suff;  
    &word_gen (INFILE, OUTFILE);
    close (INFILE);
    close (OUTFILE);
  }
}
#------------------------------------------------------

sub word_gen {
local ($W_fin, $W_fout) = @_;
select($W_fout);
# Generates word forms given a root and a file containg
# delete add strings, one on each line.
#   Example usage: word_gen.pl  -rCele  < Cele.add  > Cele.wrd
# Cele.add is a file containg del and add strings for the different 
# forms of Cele. The root is given by -r option. The output file
# Cele.wrd contains the generated word forms.
# Example format of the input file:
#  -A,+e
#  -A,+oM


while (<$W_fin>) {
  chop;
  ($del, $add) = split (/\,/);
  $del = substr ($del, 1);
  $add = substr ($add, 1);
    # print STDERR "DEBUG: delstring=$del, addstring=$add,\n";
  if ($root =~ /$del$/) { $word = $` . $add; }
  else { # String to be deleted not found. Do some approx.
    $minuslen = length($_) - length($del);
    $word = substr ($root, 0, $minuslen ) . $add;
  }
  print $word, "\n";
}

}
1;
