#%date = ("Jan",31,"Feb,28);
@monthname = (Jan,Feb,Mar,Apr,May);
@monthlen = (31,28,31,30,31,30,31,31,30,31,30,31);

# datechk takes day, month, year as its args and checks that it is 
#  a valid date. It also checks for correct no of days in Feb.
sub datechk {
  local ($day, $month, $year) = @_;
  # print @_,"\n";
  if ($year < 100) { # standardize year to four digits.
    $year += 1900; 
  } 
  # To standardize month name to number.
  if (($month <= 12) && ($month > 0)) {
    if ($month != 2) {
      $length = $monthlen[$month - 1];
      if ($day > $length) {
        print STDERR "In line no. $line_num, day $day in month $month exceeds permissible range.\n";
      }
      elsif ($day < 1) {
        print STDERR "In line no. $line_num, day $day in month $month is less than one.\n";
      }
    }  
    else {     # month = 2 (Feb)
      if (($year % 400 == 0) || (($year % 100 != 0) && ($year % 4 == 0))){
        $feblen = 29;
      }
      else { $feblen = 28; }
      if ($day > $feblen) {
        print STDERR "In line no. $line_num, day $day in month $month exceeds permissible range.\n";
      }
      elsif ($day < 1) {
        print STDERR "In line no. $line_num, day $day in month $month is less than one.\n";
      }
    }
  }
  else { print STDERR "In line no. $line_num, month $month is out of range.\n"; } 
}
1;       
  
