#!/usr/bin/perl
# Adds the cheque number to the entries.
# Options:
# -b	-  Starting number of cheque book. 

require("/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/printusage.pl");

# Assumes that the args begin after the params. (Each param begins by -)
local ($i, $parmlastpos, $argbegpos, $arg, $outf, $argsinfile, $Finname, $Foutname);
local ($cheqnum);
$parmlastpos = -1; # Gives pos of last param in ARGV. Default no params.
$argbegpos = -1;  # Gives position of 1st argument in ARGV. Default no args
$argsinfile = 0;  # Default args file names are not in a file.
$cheqnum = 1; # Default  Starting number of cheque book. 

# Look up .cheq_addnorc file. Override defaults.
if (open (RC, '.cheq_addnorc')) {
  while (<RC>) {
    chop;
    if (/\s*#/) {  next; }   # Ignore. A comment line.
    if (/\s*-/) {  # A parameter found.
      $_ = '-' . $';
      if (substr($_,1,1) eq 'h') { # print help info.
        &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/appl/cheq_addno.cmd');
        die;
      }
      elsif (substr($_,1, 1) eq  'b') {
        $cheqnum = substr ($_, 2);
      }
      else { 
          print STDERR "cheq_addno.cmd: Unrecognized param in rc file: $_.\n";
          &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/appl/cheq_addno.cmd');
          die;
      }
    }
    else { # 
      print STDERR "cheq_addno.cmd: Param must begin with '-' in rc file: $_. Ignoring.\n";
    }
  }
  close (RC);
}

for ($i=0; $i <= $#ARGV; $i++) { # Extract the parameters and locate
                                 #  starting loc of command args.
  if (substr($ARGV[$i],0,1) eq '-') {  # A parameter found.
    $parmlastpos++;  # Change the following lines to suit your needs.
    if (substr($ARGV[$i],1,1) eq 'h') { # print help info.
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/appl/cheq_addno.cmd');
      die;
    }
    elsif (substr($ARGV[$i],1,1) eq 'o') { # Specifies output file.
      $outfilename = substr ($ARGV[$i],2);
    }
    elsif (substr($ARGV[$i],1, 1) eq  'b') {
      $cheqnum = substr ($ARGV[$i], 2);
    }
    else { print STDERR "cheq_addno.cmd: Unrecognized param: $ARGV[$i].\n";
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/appl/cheq_addno.cmd');
      die;
    }
  }
  else { # Argument found. Parameters end.
    if (substr($ARGV[$i],0,1) eq '@') {  # A file of args found
      $argsinfile = 1;
      $ARGV[$i] = substr($ARGV[$i], 1);
    }
    $argbegpos = $i;
    last;
  }
}

#print STDERR "cheq_addno.cmd: DEB params end: $parmlastpos;  args begin: $argbegpos; total: $#ARGV;\n";

# Process the arguments in the command line then call cheq_addno.
# 1. Can be used as a filter. OR
# 2. If arg file names are given, they are treated as input files
#    and the output goes to a single file stdout.

if ($outfilename ne '') {
  open (OUT, ">$outfilename") ||
    die "cheq_addno.cmd: Unable to open output file $outfilename.\n";
  $outf = OUT;
  $Foutname = $outfilename;
}
else { $outf = STDOUT; }

if ($argbegpos < 0) { # No args.
  &cheq_addno(STDIN, $outf);
}
elsif ($argsinfile) {  # Argument filenames in file.
  open (ARGFILE, "$ARGV[$argbegpos]") ||
    die "cheq_addno.cmd: Unable to open args file $ARGV[$argbegpos]\n" ;
  while (<ARGFILE>) { # Read args.
    chop;
    if (!(open (INFILE, $_))) {
      print STDERR "cheq_addno.cmd: Unable to open file $_\n" ;
      next;
    }
    $Finname = $_;
    &cheq_addno (INFILE, $outf);
    close (INFILE);
  }
  close (ARGFILE);
}
else { # Call the program with each arg. 
  for ($arg = $argbegpos; $arg <= $#ARGV; $arg++) {
    if (!(open (INFILE, "$ARGV[$arg]"))) {
      print STDERR "cheq_addno.cmd: Unable to open file $ARGV[$arg]. Continuing.\n" ;
      next;
    }
    $Finname = $ARGV[$arg];
    &cheq_addno (INFILE, $outf);
    close (INFILE);
  }
}
close ($outf);
 
#------------------------------------------------------

sub cheq_addno {
local ($W_fin, $W_fout) = @_;
select($W_fout);
#%COMMENT
# Adds the cheque number to the entries.
#%CMD TYPE M1

while (<$W_fin>) {
  chop;
  if (/^\s*$/) { $cheqnum++;  next; }   # Skip the line.
  if (/^\s*#$/) { $cheqnum++;  next; }  # Skip the line.
  ($fld0, $rest) = split (/\s*\|\s*/, $_, 2);
  # print STDERR "DEBUG: Fld count: $#flds, @flds\n";
  # if (!($#flds == $fldcnt)) {
  #   print STDERR "Line $.: Invalid number of fields: $_\n";
  # }
  print $fld0, ' | ', $cheqnum, ' | ', $rest, "\n";
  $cheqnum++;
}
}
1;
