#!/usr/bin/perl
# Remove the e-mail wrapper around the input paper from cs/cmp-lg and unpack it.
#   cmp-lg.pl  < paper4

$state = 'rm_hdr';
while (<>) {
  if ($state eq 'rm_hdr') {
    if (/^\n/) { # header over.
      if ($. != 21) { print STDERR "Header ended at line $. Check.\n"; }
      $state = 'get_pap_no';
    }
    elsif ($. >= 50) { # Normally header should be over at 21.
      print STDERR "Header still continuing after line $. Giving up.\n";    
    }
  } 
  elsif ($state eq 'get_pap_no') {
    $buffer_to_papno .= $_;
    if (/\#\s+Paper:\s+cs.CL\/([0-9]+)/) {
      $pap_no = $1;   $state = 'cr_uu_file';
      system ("mkdir p$pap_no");
      open (UU, ">p$pap_no/$pap_no.uu") ||
        die "Unable to open file p$pap_no/$pap_no.uu\n";
      print UU $buffer_to_papno;
      if ($. != 23) { print STDERR "Paper number found at line $. Check.\n"; }
    }
    elsif ($. >= 55) { # Normally paper no should have been found at line 23.
      print STDERR "Paper no should be found after line $. Giving up.\n";    
    }
  } 
  elsif ($state eq 'cr_uu_file') {
    print UU;
  } 
  else { print STDERR "cmp-lg.pl: Illegal value of \$state=$state\n"; }
}
close UU;
system ("cd p$pap_no;  chmod +x $pap_no.uu;  $pap_no.uu > $pap_no.log;");
1;
