#!/usr/bin/perl
#%COMMENT
# Checks and outputs the fields in a proper format from an input
#  text database (1 record per line).
# 1. Number of fields in each line, and the output format should be
# given by a file 'cheq.fmt' in the current directory.
# 2. Example cheq.fmt file is given below:
#    (Must use $fldcnt, and $flds[0] etc. separated by ','s.
#     A line can be commented by using standard perl comments.)
#
# $fldcnt = 2;
# format FLDFORMAT =
# @<<<<<<<<<< | @<<<<<<<<<<<<<<<<<<<<<<<<<<<<< | @######.##
# $flds[0],     $flds[1],                        $flds[2]
# .
#
#%CMD TYPE M1
$fmtfile = 'cheq.fmt'; # Name of format file. #OPT -f

require ("$fmtfile");
$~ = "FLDFORMAT";   # Format to be used with 'write'
while (<>) {
  if (/^\s*$/)  { print; next; }  # Print but do not process the line.
  if (/^\s*#/) { print; next; }  # Print but do not process the line.
  chop;
  @flds = split (/\s*\|\s*/);
  # print STDERR "DEBUG: Fld count: $#flds, @flds\n";
  if (!($#flds == $fldcnt)) {
    print STDERR "Line $.: Invalid number of fields: $_\n";
  }
  write ;
}
