#!/usr/bin/perl
# Calculates interest and principal amount paid over the years
# when equal monthly installments (EMI) are being paid.

format OUTFORMAT =
@<< @#####  @#######      @########
$i, $pay_int,   $pay_princ, $princ
.
$~ = "OUTFORMAT";

open (SUMM, ">loan_summ.txt") || 
  die "Unable to open out file loan_summ.txt: $!\n";

$princ = 800000;
$emi = 10720;
$int = 14;
$yrs = 15;
$months = $yrs * 12;
print "Principal	I-rate	Yrs	EMI\n";
print "$princ\t\t$int\t$yrs\t$emi\n";
print SUMM "Principal	I-rate	Yrs	EMI\n";
print SUMM "$princ\t\t$int\t$yrs\t$emi\n";

print "\n";
print "Month\tInterest\tPay-principal\tPrinc-rem\n";
for ($i=1; $i <= $months;  $i++) {
  $mo_int = $princ * $int / 1200;
  if ($emi <= $mo_int) {
    print STDERR "EMI is less than interest due: $emi, $mo_int\n";
    last;
  }
  $pay_int = $mo_int;
  $pay_princ = $emi - $mo_int;
   #print $i, "\t", $pay_int, "\t", $pay_princ, "\n";
  $princ = $princ - $pay_princ;
  write ;
  if (!($i % 12)) {  # Year over.
    $cum_int += $pay_int;   # Add the final interest for 12th month
    $cur_yr = $i / 12;
    print "------------------------------------------------- ", "$cur_yr   $cum_int\n";
    print SUMM "$cur_yr   $cum_int\n";
    $cum_int = 0;
  }
  else { 
    $cum_int += $pay_int;
  }
}
