#!/usr/bin/perl
#%COMMENT
# Calculates breakup of interest and principal amount paid over the 
# years when equal monthly installments (EMI) are being paid.
# Principal is specified as the value of $princ variable.
# Writes short result in STDOUT. Detailed results in loan_full.tmp
#   Usage:  loan_int.pl > loan.out
#%CMD TYPE 11

$princ = 800000;  # Principal amount (default 800000) #OPT -p
$int = 14;
$emi = 134 * $princ / 10000;
 #$emi = 10720;  # for 8lakhs
$yrs = 15;
$months = $yrs * 12;

format FULLFORMAT =
@## @#######  @#######      @########
$i, $pay_int,   $pay_princ, $princ
.
format SHRTFORMAT =
@## @#######
$cur_yr, $cum_int
.
$~ = "SHRTFORMAT";

open (FULL, ">loan_full.tmp") || 
  die "Unable to open out file loan_full.tmp: $!\n";

print "Principal	I-rate-mo	Yrs	EMI\n";
print "$princ\t\t$int\t\t$yrs\t$emi\n";
print FULL "Principal	I-rate-mo	Yrs	EMI\n";
print FULL "$princ\t\t$int\t\t$yrs\t$emi\n";

print "\n";
print "Year\tInterest\n";
print FULL "\n";
print FULL "Month\tInterest\tPay-principal\tPrinc-rem\n";
for ($i=1; $i <= $months;  $i++) {
  $mo_int = $princ * $int / 1200;
  if ($emi <= $mo_int) {
    print STDERR "EMI is less than interest due: $emi, $mo_int\n";
    last;
  }
  $pay_int = $mo_int;
  $pay_princ = $emi - $mo_int;
   #print FULL $i, "\t", $pay_int, "\t", $pay_princ, "\n";
  $princ = $princ - $pay_princ;
  if (!($i % 12)) {  # Year over.
    $cum_int += $pay_int;   # Add the final interest for 12th month
    $cur_yr = $i / 12;
    $~ = "SHRTFORMAT";    write;
    #ERR $~ = "FULLFORMAT";   write FULL;
    print FULL "$i   $pay_int    $pay_princ    $princ\n";  # NOERR
    print FULL "------------------------------------------- ", "$cur_yr   $cum_int\n";
    $cum_int = 0;
  }
  else { 
    $cum_int += $pay_int;
    #ERR $~ = "FULLFORMAT";   write FULL;
    print FULL "$i   $pay_int    $pay_princ    $princ\n";  # NOERR
  }
}
