#!/usr/bin/perl
# Takes as its input a file such as: ~sangal/addr/main.adr
# Produces as its output a file suitable for pocket tel dir.: maintel.adr
# Begins printing after the first \n\n. (':'s get printed anyway).
$collimit = 30;  # Default max coloumn limit.
$beg = 0;
while (<>) {  # Read line by line the input address file.
  if (/^\s*$/) { $beg = 1; next;}     # recognize begin of new addr record.
  chop;
  if (/^\s+/) { $_ = $'; }   
  if (/\s+$/) { $_ = $`; }
  if (/^:/) {  # print the line anyway.
    $_ = ' ' . $';   &brprint;
  } 
  elsif ($beg) {  &brprint;  $beg = 0; } # print first line of new record.
  elsif (/^(tel:|Tel:|TEL:)/) {  # print line containing 'tel:'
    $_ = ' ' . $';   &brprint;
  }    
}

# Print the $_ without consuming more than $collimit coloumns.
# Break at a space near $collimit position if possible, else force
# break.
sub brprint {
  while ($_ ne '') {
    if (length ($_) <= $collimit) { print $_, "\n"; last; }  # Loop over.
    $inlimit = substr ($_, 0, $collimit);
    $rem = substr($_, $collimit);
    $nextchar = substr($_, $collimit, 1);
    if ($nextchar =~ /\s/) {  # Lucky. Space just after $collimit.
      print $inlimit, "\n";  $_ = '  ' . $rem;
    }
    elsif ($inlimit =~ /[^\s]*$/) { # Find the last space.
      if ( length($`) >= (2 * $collimit/3) )  { # last space is at OK distance.
        print $`, "\n";
        $_ = '  ' . $&  . $rem;
      }
      else {  # Break the line even if no space.
        print $inlimit, "~\n";  $_ = '  ' . $rem;
      } 
    }
    else { # No space found. Break the line even if no space.
      print $inlimit, "~\n";  $_ = '  ' . $rem;
    }
  }
}
