#!/usr/bin/perl
# Takes a *.iref file which contains word followed by its irefs,
# in each line. Shows the word in the approp file.  For getting 
# filenames from irefs it uses a mapping file (given by -f option).
#   Example usage: showcorpW.cmd  -f/usr3/corpus/teluguorig/wi.nam < aMtis.iref  >aMtis.nam
# The above takes a file called aMtis.iref and shows occurrences
# of the word (say, aMtis) in the files whose irefs are given,
# using the mapping file: /usr3/corpus/teluguorig/wi.nam.
#
# Options:
# -f	-  Name of file to be used for mapping between filenames and irefs. (Default: Telugu orig)
# $Id$
require("/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/printusage.pl");
require("/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/showcorpW.pl");


# Assumes that the args begin after the params. (Each param begins by -)
local ($i, $parmlastpos, $argbegpos, $Finname, $Foutname);
local ($wimapfile);
$parmlastpos = -1; # Gives pos of last param in ARGV. Default no params.
$argbegpos = -1;  # Gives position of 1st argument in ARGV. Default no args
$wimapfile = '/usr3/corpus/teluguorig/wi.nam'; # Default  Name of file to be used for mapping between filenames and irefs. (Default: Telugu orig)

# Look up .showcorpWrc file. Override defaults.
if (open (RC, '.showcorpWrc')) {
  while (<RC>) {
    chop;
    if (/\s*#/) {  next; }   # Ignore. A comment line.
    if (/\s*-/) {  # A parameter found.
      $_ = '-' . $';
      if (substr($_,1,1) eq 'h') { # print help info.
        &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/showcorpW.cmd');
        die;
      }
      elsif (substr($_,1, 1) eq  'f') {
        $wimapfile = substr ($_, 2);
      }
      else { 
          print STDERR "Unrecognized param in rc file: $_.\n";
          &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/showcorpW.cmd');
          die;
      }
    }
    else { # 
      print STDERR "Param must begin with '-' in rc file: $_. Ignoring.\n";
    }
  }
  close (RC);
}

for ($i=0; $i <= $#ARGV; $i++) { # Extract the parameters and locate
                                 #  starting loc of command args.
     # Command line args override those of the rc file.
  if (substr($ARGV[$i],0,1) eq '-') {  # A parameter found.
    $parmlastpos++;  # Change the following lines to suit your needs.
    if (substr($ARGV[$i],1,1) eq 'h') { # print help info.
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/showcorpW.cmd');
      die;
    }
    elsif (substr($ARGV[$i],1, 1) eq  'f') {
      $wimapfile = substr ($ARGV[$i], 2);
    }
    else { 
        print STDERR "Unrecognized param: $ARGV[$i].\n";
        &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/showcorpW.cmd');
        die;
    }
  }
  else { # Argument found. Parameters end.
    $argbegpos = $i;
    last;
  }
}

# Process the arguments in the command line then call showcorpW.
# 1. Can be used as a filter. OR
# 2. file args can be given instead of filters.

if ($argbegpos < 0) { # No args.
  &showcorpW(STDIN, STDOUT);
}
elsif (($#ARGV - $argbegpos) == 0) { # Only one arg given. Execute the command with arg and stdout.
  open (INFILE, "$ARGV[$argbegpos]") ||
     die "Unable to open file $ARGV[$argbegpos]\n" ;
  $Finname = $ARGV[$argbegpos];  $Foutname = '';
  &showcorpW(INFILE, STDOUT);
  close (INFILE);
}
elsif (($#ARGV - $argbegpos) == 1) { # Two args given. Execute the command with arg1 and arg2.
  open (INFILE, "$ARGV[$argbegpos]") ||
     die "Unable to open input file $ARGV[$argbegpos]\n" ;
  open (OUTFILE, ">$ARGV[$argbegpos + 1]") ||
     die "Unable to open output file $ARGV[$argbegpos + 1]\n" ;
  $Finname = $ARGV[$argbegpos];  $Foutname = $ARGV[$argbegpos+1];  
  &showcorpW(INFILE, OUTFILE);
  close (OUTFILE);
  close (INFILE);
}
else { print STDERR "Too many arguments.\n"; }

