#! /usr/bin/perl
# Takes as its input the output of morph analyser and checks 
# whether a word satisfies the specifications.
#   Ex Usage: xtrormo.cmd  <abhi.moh  >abhi.xtr
# Options:
#    -fpatfile	Pattern specification is contained in file patfile.
#               (Default file: /home/bharathi/PNJ1/usr3/sangal/tools/src/corp/patmo)
#    -csfile 	Structure of morph output is contained in sfile.
#               (Default file: /home/bharathi/PNJ1/usr3/sangal/tools/src/corp/struc)
#    -dabc	Delimiter used for sentences is 'abc'. Default: <.>.
#    -dn	Delimiter used is for sentences is new line.
# cmd type many to many.


# cmd type many to one.
# Assumes that the args begin after the params. (Each param begins by -)

require ("/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/printusage.pl");

local ($i, $parmlastpos, $argbegpos, $arg, $argsinfile);
local ($delim, $nl_limtr);
$parmlastpos = -1; # Gives pos of last param in ARGV. Default no params.
$argbegpos = -1;  # Gives position of 1st argument in ARGV. Default no args
$argsinfile = 0;  # Default args file names are not in a file.
$delim = '<.>';
for ($i=0; $i <= $#ARGV; $i++) { # Extract the parameters and locate
                                 #  starting loc of command args.
  if (substr($ARGV[$i],0,1) eq '-') {  # A parameter found.
    $parmlastpos++;  # Change the following lines to suit your needs.
    if (substr($ARGV[$i],1,1) eq 'h') { # print help info.
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/xtrormo.cmd');
      die;
    }
    elsif (substr($ARGV[$i],1,1) eq 'o') { # Specifies output file.
      $outfilename = substr ($ARGV[$i],2);
    }
    elsif (substr($ARGV[$i],1,1) eq 'd') { # Delimiter specified.
      $delim = substr ($ARGV[$i],2);
    }
    elsif (substr($ARGV[$i],1,1) eq 'n') { # Use new line as delimiter
      $delim = 'n';
    }
    else { print STDERR "xtrmo.pl: Unrecognized parm: $ARGV[$i]. Ignoring.\n";
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/xtrormo.cmd');
    }
  }
  else { # Argument found. Parameters end.
    if (substr($ARGV[$i],0,1) eq '@') {  # A file list found
      $argsinfile = 1;
      $ARGV[$i] = substr($ARGV[$i], 1);
    }
    $argbegpos = $i;
    last;
  }
}
#print STDERR "DEB params end: $parmlastpos;  args begin: $argbegpos; total: $#ARGV;\n";

# Process the arguments in the command line then call xtrmorph.
# 1. Can be used as a filter. OR
# 2. If one or more file arguments are given, they are treated as
#    inputs files, and the output file name is specified separately.

require ("/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/ldstr.pl");
&load_struc ("/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/struc");
  #require ("/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/prstr.pl"); #for debug
  #print STDERR "Category structure is:\n"; #for debug
  #&print_struc; #for debug

require ("/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/ldpatmo.pl");
&load_patmo("/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/patmo");
  #require ("/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/prpatmo.pl"); #for debug
  #print STDERR "Pattern spec is:\n"; #for debug
  #&print_patmo; #for debug

require ('/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/xtrormo.pl');

if ($outfilename ne '') {
  open (OUT, ">$outfilename") ||
    die "Unable to open output file $outfilename.\n";
  $outf = OUT;
}
else { $outf = STDOUT; }

if ($argbegpos < 0) { # No args.
  &xtrmorph(STDIN, $outf);
}
elsif ($argsinfile) {  # Args in file.
  open (ARGFILE, "$ARGV[$argbegpos]") ||
    die "Unable to open args file $ARGV[$argbegpos]\n" ;
  while (<ARGFILE>) { # Read args.
    chop;
    if (!(open (INFILE, $_))) {
      print STDERR "Unable to open file $_\n" ;
      next;
    }
    &xtrmorph (INFILE, $outf);
    close (INFILE);
  }
  close (ARGFILE);
}
else { # Call the program with each arg. 
  for ($arg = $argbegpos; $arg <= $#ARGV; $arg++) {
    if (!(open (INFILE, "$ARGV[$arg]"))) {
      print STDERR "Unable to open file $ARGV[$arg]\n" ;
      next;
    }
    &xtrmorph (INFILE, $outf);
    close (INFILE);
  }
}

