# Construct and return search pattern from given pattern or pattern file
# and type of search (for string, word, prefix, suffix, root etc.)
# This is called from xtr.pl and algn_vert.pl.
# Uses variables set from the calling routine: 
#   $stem_filename, $strtype, $patfile, $pat
sub cons_srchpat {
  local ($i, @patf, $nonword, $srchpat);
  #$nonword = '[^a-zA-Z]+';
  $nonword =  '[\",:;\'`\\\/\?><\]\[}{\)\(\-_ \n\r\t=!\@\#%&\$\|\*\+\.\xea0-9]';  # No: ~

  #print STDERR "DEB: Inside cons_srchpat.pl: Pattern = $pat, Stem of filename = $stem_filename\n";
  if ($patfile ne '') { # pattern is to be taken from a file.
    open (PATF, "$patfile") || 
      die "cons_srchpat.pl: Unable to open file $patfile: $!\n";
    $srchpat = '';
    while (<PATF>) { chop;  $srchpat .= $` . '|'; }
    close (PATF);
    if ($srchpat eq '') { 
      die "cons_srchpat.pl: Nothing to search. search pattern=NIL. (Used -f option.)\n";
    }
    #print  STDERR "cons_srchpat.pl:DEBUG: srchpat=$srchpat,\n";
    chop $srchpat; $srchpat = '(' . $srchpat . ')';
  }
  else { 
    if (($pat eq '') && ($strtype != 5)) {
      die "cons_srchpat.pl: Nothing to search. Pattern from -p option is NIL.\n";
    }
    $srchpat = $pat;
  }

  if ($strtype == '1') { }  # Do nothing to srchpat.
  elsif ($strtype == '2') { 
    $srchpat =
      '(' . $nonword . $srchpat . "$nonword)|(^" . $srchpat . "$nonword)";
  }
  elsif ($strtype == '3') {
    $srchpat ="($nonword" . $srchpat . ')|(^' . $srchpat .')';
  }
  elsif ($strtype == '4') { 
    $srchpat = '(' . $srchpat . $nonword . ')';
  }
  elsif ($strtype == '5') {  # Take words from *.iref file.(Root was specified.)
    # print STDERR "DEBUG: strtype 5 found.\n";
    open (IREF, "$stem_filename.iref") ||
      die "cons_srchpat.pl: Unable to open file $stem_filename.iref: $!\n";
    $srchpat = '';
    while (<IREF>) { if (/\s/) { $srchpat .= $` . '|'; } }
    close (IREF);
    if ($srchpat eq '') { 
      die "cons_srchpat.pl: Nothing to search. search pattern=NIL. (Used $stem_filename.iref file.)\n";
    }
    chop $srchpat; $srchpat = '(' . $srchpat . ')';
    $srchpat =
      '(' . $nonword . $srchpat . "$nonword)|(^" . $srchpat . "$nonword)";
  }
  else { print STDERR "cons_srchpat.pl: Illegal string type: $strtype.\n"; }
   #print  STDERR 'DEB: given pattern:', $pat, ':', "\n";
   #print  STDERR 'cons_srchpat.pl:DEB: search pattrn:', $srchpat, ':', "\n";
  return ($srchpat);
}
1;
