#!/usr/bin/perl
# This is used to form growing subsets of a given corpus.
#   Usage: corp_grow.pl  SZ  WCFILE  < WIFILE > WIOUTFILE
# Given (1) a size SZ of corpus in words and 
# (2) WCFILE file containing word counts of files (using wc), and
# (3) WIFILE an input wi file (containing names of files of the corpus
# (typically in random).
# Makes a copy of the input file into the output, except 
# it puts '---' marks , such that between
# two consecutive marks, there are names of files satisfying the
# size SZ.

#Format of WC file from corpus:
#1       190    2161   10349 /usr4/corpus/punjabi/ari1/1
#2       185    1857    9414 /usr4/corpus/punjabi/ari1/10

#print STDERR "corp_grow.pl DEB: $ARGV[0], $ARGV[1]\n";
 $break_size = $ARGV[0];

open (WC, $ARGV[1]) ||
  die "corp_grow.pl: Unable to open file $ARGV[1]: $!";
while (<WC>) {  # Load the word sizes with name of file
  chop;
  @part = split (/\s+/);
  $w_size{$part[4]} = $part[2]; # Store word size with filename
}

while (<STDIN>) {
  chop;
  $size = $w_size{$_};
  if ($size ne '') { $cum_size += $size; }
  else { print STDERR "corp_grow.pl: Filename not found: $_\n"; }
  print $_, "\n";
  if ($cum_size >= $break_size) { 
    print '---', "\n"; $cum_size = $cum_size - $break_size;
  }
}
if ($cum_size < $ARGV[0]) {
  print STDERR "corp_grow.pl: Total size less than asked for.\n";
}
