#!/usr/bin/perl
# Takes (1) a size SZ of corpus, (2) WC file containing information
# about file sizes in the corpus, and (3) a file of filenames of corpus files
# given by STDIN,
# and returns a list of filenames from STDOUT, as many files
# as would be just more than the given size SZ.
#   Usage: corp_size.pl  50000 ~corpus/punjabi/wc.lst \
#                             < ~corpus/punjabi/wi.nam  > a.nam

#Format of WC file from corpus:
#1       190    2161   10349 /usr4/corpus/punjabi/ari1/1
#2       185    1857    9414 /usr4/corpus/punjabi/ari1/10

#print STDERR "corp_size.pl DEB: $ARGV[0], $ARGV[1]\n";

open (WC, $ARGV[1]) ||
  die "corp_size.pl: Unable to open file $ARGV[1]: $!";
while (<WC>) {  # Load the word sizes with name of file
  chop;
  @part = split (/\s+/);
  $w_size{$part[4]} = $part[2]; # Store word size with filename
}

while (<STDIN>) {
  chop;
  $size = $w_size{$_};
  if ($size ne '') { $cum_size += $size; }
  else { print STDERR "corp_size.pl: Filename not found: $_n"; }
  print $_, "\n";
  if ($cum_size >= $ARGV[0]) { last; }
}
if ($cum_size < $ARGV[0]) {
  print STDERR "corp_size.pl: Total size less than asked for.\n";
}
