#!/usr/bin/perl
# Filters the input file by allowing only those word-index file numbers
# to pass through that are mentioned in one of the filters.
#   Example usage: filter_corp.pl  FILTER  FILTER ... < IN.iref     > OUT.iref
# Removes those occurrences of files from word-index files IN.iref
# which are not covered in the FILTER. FILTER is a file containing
# a list of files names that are allowed to go through. Each line of
# filter contains a file name optionally followed by space and some
# comments.)

foreach $filename (@ARGV) {
  open (FILT, "$filename") ||
    die "Unable to open filter $filename: $!\n";
  while (<FILT>) {
    if (/\s/) { $filter{$`} = 1; }
    else { chop;  $filter{$_} = 1; }
  }
  close (FILT);
}

# DEBUGGING:
#foreach $fno (keys %filter) { print STDERR 'File:', $fno, ':', "\n"; }
#print STDERR "Filter over-----\n";

while (<STDIN>) {
  chop;
  if (/\s+/) { 
    $word = $`;    $rest = $';
    @filenos = split (/\s+/, $rest);
    $outstr = '';
    foreach $fno (@filenos) {
      if ($filter{$fno} == 1) { $outstr .= ' ' . $fno; }
    }
    if ($outstr ne '') { print $word, ' ', $outstr, "\n"; }
    #else { print STDERR "DEBUG: Fails the filter word: $word\n"; }
  }
  else { print STDERR "Invalid format for line: $_\n"; }
}
