#!/usr/bin/perl
# Takes a freq-word file, and makes adjacent entries unique by 
# merging adjacent entries with the same word. E.g., the foll. lines:
#   100 abc
#   204 abc
# will be merged into a single line:
#   304 abc
#  Usage: frquniq.pl < ab.frq2  > ab.frq

local ($oldword, $accumcnt, $word, $cnt, $first, $fullline);
$_ = <>;
if (/\s+/) { 
  $accumcnt = $`;  $oldword = $';
}  
else { print STDERR "frquniq.pl: Check format of frq-word: $_"; }

while (<>) {
   # Replaced the foll. line by next line for speed (but less robust):
   #      if (/\s\s+/) { 
  if (/\s+/) { 
    $cnt = $`;  $word = $';
    if ($oldword eq $word) { # Try to merge.
      $accumcnt += $cnt;
    }
    else { # New cnt found. Output previous cnt.
      print $accumcnt, ' ', $oldword;
      $oldword = $word;   $accumcnt = $cnt;
    }
  }  
  else { print STDERR "CHECK the word iref cnt: $_"; }
}
# Now print the last cnt.
print $accumcnt, ' ', $oldword;

