#!/usr/bin/perl
# Takes a *.iref file which contains word followed by its irefs,
# in each line.
#   Example usage:  iref2name.pl  < gAnI.iref  > gAnI.nam
# The above works if the next few lines are made active.
# Otherwise, use:   iref2name.cmd  -fMAPFILE  < gAnI.iref  > gAnI.nam

# $wifile = '/usr4/corpus/telugu8/wi.nam';  # For anu3
# &iref2name (STDIN, STDOUT);

sub iref2name {
  local ($fin, $fout) = @_;
  local ($w, $irefs, $cumirefs, $tmpirefs, $desired_iref, $si_ptr,
         @sorted_irefs, @unsorted_irefs);
  local ($tmp, $tmp2, $ir, $tmpfile);
  $cumirefs = '';
  while (<$fin>) { # For each iref no., store value as 1.
    chop;
    ($w, $irefs) = split (/\s+/, $_, 2);
    #print STDERR "iref2name.pl DEBUG: word = $w, irefs = $irefs.\n";
    $cumirefs .= ' ' . $irefs;
  }
  #print STDERR "iref2name.pl DEBUG: cumiref = $cumirefs\n";
  if ($cumirefs eq '') { # No irefs to be converted.
    # print STDERR "DEBUG: No references found.\n";
    return;
  }  
  if ($cumirefs =~ /^\s+/) { $tmpirefs = $'; }
  else { $tmpirefs = $cumirefs; }
  @unsorted_irefs = split (/\s+/, $tmpirefs);
  @sorted_irefs = sort { $a <=> $b } @unsorted_irefs;
  $j = 0;
  for ($i=1; $i <= $#sorted_irefs; $i++) { # Remove duplicates
    if (!($sorted_irefs[$j] == $sorted_irefs[$i])) { 
      $j++;
      $sorted_irefs[$j] = $sorted_irefs[$i];
    }
  }
  $#sorted_irefs = $j;
  # print STDERR "iref2name.pl DEBUG: sorted irefs= @sorted_irefs\n";
      
      
  # foreach $ir (@sorted_irefs) { print STDERR "DEBUG: $ir\n"; }
  
  open (FNAMES, "$wifile") ||
    die "iref2name.pl: Unable to open filenames file: $wifile.\n";
  $si_ptr = 0;
  while (<FNAMES>) { 
    if ($. == $sorted_irefs[$si_ptr]) {
      print $fout $_;
      if ($si_ptr == $#sorted_irefs) { last; }  # irefs over.
      else { $si_ptr++; }
    }
    elsif ($. > $sorted_irefs[$si_ptr]) {
      print STDERR "iref2name.pl: Error si_ptr $sorted_irefs[$si_ptr] < line no. $.\n";
      $si_ptr++;   # Skip this number.
        # last;
    }
  }
  close FNAMES;
}
1;
