#!/usr/bin/perl
# Prints the number of distinct words and coverage of the corpus.
# For examples, shows how many words cover 80%, 81% etc. of corpus.
#   Example usage: num_wrds.pl < wordfrq.cum  > covrg
# Author: Nisha Sangal and Rajeev Sangal  20 Aug 1998
# Has verbose flag which prints percentages too.

$lang_cnt = 0;

for($k=80; $k<=100; $k++) {  # Do for each percentage 80, 81, etc.
  $lang_ans = &num_wrds_aux ($lang_cnt, $k); 
  if ($verbose != 0) { print "$k", '%', "  $lang_ans\n"; }
  else { print $lang_ans, "\n"; }
  $lang_cnt = $lang_ans;
}
$l100 = $lang_cnt;
while (<>) {  # Go through the whole file and find its size.
  $lang_cnt++;
}
if ($lang_cnt > 0) {
  $error = ($lang_cnt - $l100)/$lang_cnt;
  if ($error > .0015)  {
    print STDERR 'num_wrds.pl: Large mismatch in 100% and size of file:',
                   " $l100  $lang_cnt\n";
  }
}
else { print STDERR "num_wrds.pl: Possibly empty input file.\n"; }
   # $lang_ans = $lang_cnt;
   # if ($verbose != 0) { print  "100% $lang_ans\n"; }
   # else { print $lang_ans, "\n"; }

sub num_wrds_aux {
  #$i - pecentage & $j words count. 
  local ($j, $i) = @_;
  while(<>) {
    $j++;
    chop;
    @wrd_lst = split(/\t+|\s+/);
    $wrd1 = $wrd_lst[0];
    $wrd1 =~ s/\%//;
    if($wrd1 >= $i)  {
      #print "$i	$wrd_lst[1]\n";
      #print "	$j";
      last;
    }
  }
  $j;
} # End of subroutine
1;
