#!/usr/bin/perl
# Prints the number of distinct words and coverage of the corpus.
# For examples, shows how many words cover 10%, 20% etc. of corpus.
# Does this for each of the language corpora.
#   Example usage: num_wrds_many.pl
# Author: Nisha Sangal
# Goes through the wordfrq.cum files in each of the corpora.
require ('/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/num_wrds_m_aux.pl');
format STDOUT =
@#% -> PNJ=@#### HND=@#### BNG=@#### ORY=@#### MRT=@#### KND=@##### TLG=@##### 
$k, $pnj_ans, $hnd_ans, $bng_ans, $ory_ans, $mrt_ans, $knd_ans, $tlg_ans
.
open(BNG, "/usr4/corpus/bengali/wordfrq.cum") || 
  die "can't open file /usr4/corpus/bengali/wordfrq.cum : $!\n";
open(TLG, "/usr4/corpus/telugu8/wordfrq.cum") || 
  die "can't open file /usr4/corpus/telugu8/wordfrq.cum: $!\n";
open(KND, "/usr4/corpus/kannada/wordfrq.cum") || 
  die "can't open file /usr4/corpus/kannada/wordfrq.cum: $!\n";
open(PNJ, "/usr4/corpus/punjabi/wordfrq.cum") ||
  die "can't open file /usr4/corpus/punjabi/wordfrq.cum: $!\n";
open(HND, "/usr4/corpus/hindi/wordfrq.cum") ||
  die "can't open file /usr4/corpus/hindi/wordfrq.cum: $!\n";
open(MRT, "/usr4/corpus/marathi/wordfrq.cum") ||
  die "can't open file /usr4/corpus/marathi/wordfrq.cum: $!\n";
open(ORY, "/usr4/corpus/oriya/wordfrq.cum") ||
  die "can't open file /usr4/corpus/oriya/wordfrq.cum/word_ory.lst: $!\n";
$bng_cnt=0;$tlg_cnt=0;$knd_cnt=0;$pnj_cnt=0;$hnd_cnt=0;$mrt_cnt=0;$ory_cnt=0;

$k = 0;
while ($k <= 100) {
  if ($k <= 80) { $k += 10; }
  else { $k++; }
       # for($k=10; $k<=90; $k+=10) {
  $bng_ans=&num_wrds_m_aux(*BNG, $bng_cnt,$k); 
  $tlg_ans=&num_wrds_m_aux(*TLG, $tlg_cnt,$k); 
  $knd_ans=&num_wrds_m_aux(*KND, $knd_cnt,$k); 
  $pnj_ans=&num_wrds_m_aux(*PNJ, $pnj_cnt,$k); 
  $hnd_ans=&num_wrds_m_aux(*HND, $hnd_cnt,$k); 
  $mrt_ans=&num_wrds_m_aux(*MRT, $mrt_cnt,$k); 
  $ory_ans=&num_wrds_m_aux(*ORY, $ory_cnt,$k); 
  write STDOUT;
  $bng_cnt=$bng_ans;
  $tlg_cnt=$tlg_ans;
  $knd_cnt=$knd_ans;
  $pnj_cnt=$pnj_ans;
  $hnd_cnt=$hnd_ans;
  $mrt_cnt=$mrt_ans;
  $ory_cnt=$ory_ans;
}
close(BNG); close(TLG); close(PNJ); close(HND);
close(MRT); close(ORY); close(KND); 
