#!/usr/bin/perl
#%COMMENT
# Searches for the given word in the input file,
# and aligns the lines so that the matched word occurs
# on the same coloumn in each line.
#   Example usage: algn_vert.cmd -pPAT < PAT.xtr > PAT.aln
#   Example usage: algn_vert.pl -pPAT  < PAT.xtr > PAT.aln
require('/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/cons_srchpat.pl');
#%CMD TYPE MM
$pat = 'test'; # Pattern at which the line has to be aligned.  #OPT -p
$strtype = '1'; # Type of pattern (1 String, 2 Word, 3 Prefix, 4 Suffix). (Default '1')  #OPT -t
$col = 35; # Column number at which the pattern will be placed. Default:35 #OPT -c
$nospace = 0;  # Do not put spaces before the pattern. Default: yes. #OPT -no sw1
$suff = '.aln'; # Suffix for default output file name. Default: '.new'  #OPT -s
$stem_filename = 'xtr.stem'; # Name of the stem filename ($stem_filename.iref may be looked up.) #OPT -N

if ($strtype == '1') { $newpat = $pat; }
elsif ($strtype == '2') { 
  $newpat = '(\s' . $pat . '\s)|(^' . $pat . '\s)';
}
elsif ($strtype == '3') {$newpat='(\s' . $pat . ')|(^' . $pat.')';}
elsif ($strtype == '4') { $newpat = $pat . '\s'; }
elsif ($strtype == '5') { 
  $newpat = &cons_srchpat;
}
else { print STDERR "algn_vert.pl: Illegal string type: $strtype.\n"; }

$lenpat = length ($pat);
$rightcount = 72 - $col - $lenpat - 2;
if ($nospace) { $rightcount += 2; }
while (<>) {
  chop;
  s/\t/ /g;
  if (/$newpat/o) {
    $lenleft = length ($`);
    if ($lenleft >= $col) {
      $left = substr ($`, $lenleft - $col, $col); $spacecount = 0;
    }
    else { $left = $`; $spacecount = $col - $lenleft; }
    for ($i=1; $i <= $spacecount;  $i++) { print ' '; }
    $right = substr ($', 0, $rightcount);
    if ($& =~ /\s$/) { $right = ' ' . $right; } 
    if ($& =~ /^\s/) { $left .= ' '; } 
     #print STDERR "DEBUG: lenleft= $lenleft, lenpat= $lenpat, lenright= $lenright,\n";
     #print STDERR $left, '  |', $pat, '|', $right, "\n";
    if ($nospace) { print $left, $pat, $right, "\n"; }
    else { print $left, '  ', $pat, $right, "\n"; }
  }
}

