# Searches for a given pattern and extracts it from given files.
# Called by xtr.cmd.
# $pat - Given pattern.
# $strtype - Type of pattern: (1 pattern as it is, 2 word, 3 prefix, 4 sufix)
# $clean - Cleaning filter to be used. (0 no clean, 1 join words)
# $delim - Delimiter for end of sentence.
# $src_outfile -   # File name for keeping source of xtracted sentence
# $src_outhandle - # Handle of file for keeping source of xtracted sentence

# Not implemented -r option below:
## $ref - Reference marks to be put in a sep file (0=no, 1=yes, 2=yes short form).

# $Id$
$punctmark = '[\",:;\'\?><\]\[}{\)\(-=!@#%&\*\.\xea\s]';
sub xtr {
  local ($infile, $outfile) = @_;
  local ($oldfile, $oldlimtr);
  local ($nonword, $punctmark, $src_lst);
  #$punctmark = '[\",:;\'\?><\]\[}{\)\(-=!@#%&\*\.\xea\s]';
  #$nonword = $punctmark;
  $nonword = '[^a-zA-Z]+';
  # print STDERR "DEB: Inside xtr.pl: Pattern = $pat, Delimiter = :$delim:\n";

  if ($strtype == '1') { $srchpat = $pat; }
  elsif ($strtype == '2') { 
    $srchpat =
      '(' . $nonword . $pat . "$nonword)|(^" . $pat . "$nonword)";
  }
  elsif ($strtype == '3') {
    $srchpat ="($nonword" . $pat . ')|(^' . $pat .')';
  }
  elsif ($strtype == '4') { $srchpat = $pat . $nonword ; }
  else { print STDERR "xtr.pl: Illegal string type: $strtype.\n"; }
  # print  STDERR 'DEB: given pattern:', $pat, ':', "\n";
  # print  STDERR 'DEB: search pattrn:', $srchpat, ':', "\n";
  $oldfile = select ($outfile);
  $oldlimtr = $/;
  $/ = $delim;
  while (<$infile>) {
    if ($clean == 1) { s/~\n#//; }
    if (/$srchpat/o) {
      s/\n/ /g;   s/^\s+//;  
      print $_;
      #if ($delim eq 'n') { print " $."; }
      print "\n";
      if ($src_outhandle ne '') { $src_lst .= "$Finname\n"; }
       # if ($delim ne 'n') { 
       #   s/\n/ /g;   s/^\s+//;  print "$_ $fnameaffix\n";
       # }
       # else { print "$_ $fnameaffix$."; }
    }
  }
  select ($oldfile);
  $/ = $oldlimtr;
  if ($src_outhandle ne '') {
    print $src_outhandle $src_lst;  # Write the sources of sentences in src file.
  }
}
1;
