#!/usr/bin/perl
# Takes a *.iref file which contains word followed by its irefs,
# in each line and looks up telugu corpus.
#   Example usage:  iref2nametel.pl  < gAnI.iref  > gAnI.nam

#$wifile = '/usr3/corpus/telugu/wi.nam';  # For anu3
  # $wifile = '/usr3/corpus/ciil/names.all';    # For anu2
#&iref2name (STDIN, STDOUT);

sub iref2name {
  local ($fin, $fout) = @_;
  local ($w, $irefs, $cumirefs, $desired_iref, $si_ptr, @sorted_irefs);
  local ($tmp, $tmp2, $ir, $tmpfile);
  $cumirefs = '';
  while (<$fin>) { # For each iref no., store value as 1.
    chop;
    ($w, $irefs) = split (/\s+/, $_, 2);
    #print STDERR "DEBUG: word = $w, irefs = $irefs.\n";
    $cumirefs .= ' ' . $irefs;
  }
  #print STDERR "DEBUG: cumiref = $cumirefs\n";

  # All the following round about ways are to sort $cumirefs.
  $tmpfile = 'iref2name.tmp';
  open (TMP, ">$tmpfile") ||
    die "Unable to open output file $tmpfile.\n";
  if ($cumirefs =~ /^\s+/) { $cumirefs = $'; }
  $cumirefs =~ s/ /\n/g;
  print TMP $cumirefs, "\n";
  close TMP;
  system ("sort -u -n < $tmpfile > $tmpfile.2");

  open (TMP2, "$tmpfile.2") ||
    die "Unable to open input file $tmpfile.2.\n";
  $tmp = $/;  $/ = '+q%^&*@';
  $tmp2 = <TMP2>;
  @sorted_irefs = split (/\n/, $tmp2);
  #foreach $ir (@sorted_irefs) { print STDERR "DEBUG: $ir\n"; }
  $/ = $tmp;
  close TMP2;

  open (FNAMES, "$wifile") ||
    die "Unable to open filenames file: $wifile.\n";
  $si_ptr = 0;
  while (<FNAMES>) { 
    if ($. == $sorted_irefs[$si_ptr]) {
      print $fout $_;
      if ($si_ptr == $#sorted_irefs) { last; }  # irefs over.
      else { $si_ptr++; }
    }
    elsif ($. > $sorted_irefs[$si_ptr]) {
      print STDERR "iref2name.pl: Error si_ptr $sorted_irefs[$si_ptr] < line no. $.\n";
      last;
    }
  }
  close FNAMES;
}
1;
