# Searches for a given pattern and extracts it from given files.
# Called by xtr.cmd.
# $pat - Given pattern.
# $strtype - Type of pattern: (1 pattern as it is, 2 word, 3 prefix, 4 sufix)
# $clean - Cleaning filter to be used. (0 no clean, 1 join words)

# $Id$
$punctmark = '[\",:;\'\?><\]\[}{\)\(-=!@#%&\*\.\xea\s]';
sub xtr {
  local ($infile, $outfile) = @_;
  local ($oldfile, $oldlimtr);
  local ($nonword, $punctmark);
  $punctmark = '[\",:;\'\?><\]\[}{\)\(-=!@#%&\*\.\xea\s]';
  $nonword = $punctmark;
   #$nonword = '[^a-zA-Z_]+';
  # print STDERR "DEB: Inside xtr.pl: Pattern = $pat, Delimiter = :$delim:\n";

  if ($strtype == '1') { $srchpat = $pat; }
  elsif ($strtype == '2') { 
    $srchpat =
      '(' . $nonword . $pat . "$nonword)|(^" . $pat . "$nonword)";
  }
  elsif ($strtype == '3') {
    $srchpat ="($nonword" . $pat . ')|(^' . $pat .')';
  }
  elsif ($strtype == '4') { $srchpat = $pat . $nonword ; }
  else { print STDERR "srch.menu: Illegal string type: $strtype.\n"; }
  # print  STDERR 'DEB: given pattern:', $pat, ':', "\n";
  # print  STDERR 'DEB: search pattrn:', $srchpat, ':', "\n";
  $oldfile = select ($outfile);
  $oldlimtr = $/;
  $/ = $delim;
  while (<$infile>) {
    if ($clean == 1) { s/~\n#//; }
    if (/$srchpat/o) {
      if ($delim ne 'n') { 
        s/\n/ /g;   s/^\s+//;  print "$_ $fnameaffix\n\n";
      }
      else { print "$_ $fnameaffix$."; }
    }
  }
  select ($oldfile);
  $/ = $oldlimtr;
}
1;
