#!/usr/bin/perl
# Goes through a list of files and check whether the files contain
# repeating characters. If so, prints the files name with repeating chars.
# This is a way to catch possibly bad (virus affected/corrupted) files.

$chunk = 80;  # Reading takes place in chunks of $chunk chars.
$repeatcntlimit = 100; # Limit beyond which file is declared to be bad.
NEWFILE: for ($i =0; $i <= $#ARGV; $i++) { # Do for each file.
  if (!(open (FL, "$ARGV[$i]"))) {
    print STDERR "Unable to open file $ARGV[$i]\n";
    next;
  }
  # print STDERR "------- Opening file $ARGV[$i] -------\n";
  $pos = 0;
  seek (FL, $pos, 0);
  $repeatcnt = 0;  $oldchar = '';
  while ($readcnt = read(FL, $_, $chunk)) {  # Read the next chunk in the file.
    if ($readcnt == 0) { last; }   # File over.
    for ($k = 0;  $k < $readcnt; $k++) {
      $curchar =  substr ($_, $k, 1);
      # print "probe2bad.pl DEBUG: Cur char = '$curchar'; Old char = '$oldchar'\n";
      if ($oldchar eq $curchar) { 
        $repeatcnt++;
        # print "probe2bad.pl DEBUG: Repeat char count = $repeatcnt;\n";
        if ($repeatcnt >= $repeatcntlimit) { 
          print "$ARGV[$i]\n";
          next NEWFILE;
        }
      }
      else { $repeatcnt = 0;  $oldchar = $curchar; }
    }
    $pos += $chunk;
    seek (FL, $pos, 0);
  }
  close (FL);
}

