#!/usr/bin/perl
# Goes through a list of files and check whether the files contain
# bad strings. (Bad strings are those listed in bad.lst.)
# A file is considered bad, if it contains bad strings several
# times ($badcntlimit) in each 80 char chunks.

$badcntlimit = 5;   $chunk = 40;

if (-e "bad.lst") {  # Take from current directory, if possible.
  open (BAD, "bad.lst") || die "Unable to open file bad.lst\n";
}
else {
  open (BAD, "/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/bad.lst") 
  || die "Unable to open file /home/bharathi/PNJ1/usr3/sangal/tools/src/corp/bad.lst\n";
}

$j = 0;
while (<BAD>) { # Read in the bad words in an array.
  chop;
  # print STDERR "$_\n";
  $badwrd[$j] = $_;   $j++;
}
# print STDERR "DEB: Read 1 + $#badwrd bad words\n";

for ($i =0; $i <= $#ARGV; $i++) { # Do for each file.
  if (!(open (FL, "$ARGV[$i]")) {
    print STDERR "Unable to open file $ARGV[$i]\n";
    next;
  }
  # print STDERR "DEBUG: ------- Opening file $ARGV[$i] -------\n";
  $badlinecnt = 0;  $pos = 0;
  seek (FL, $pos, 0);
  while ($readcnt = read(FL, $_, $chunk)) {
    if ($readcnt == 0) { last; }
    $badpatcnt = 0;
    for ($k=0; $k <= $#badwrd;  $k++) {
      if (/$badwrd[$k]/) { 
        $badpatcnt++; 
        # print STDERR "DEB:$badpatcnt:$_\n";
      }
    }
    if ($badpatcnt >= 1) { 
      $badlinecnt++; 
      if ($badlinecnt > $badcntlimit) { last; }
    }
    $pos += $chunk;
    seek (FL, $pos, 0);
  }
  if ($badlinecnt >= $badcntlimit) { print "$ARGV[$i]\n"; }
  close (FL);
}

