#!/usr/bin/perl
# Given a char and a file, goes through the file and returns 1
# if the given char is there in the file.
# (Returns 2 if there are less than 10 lines containing the chars.
#  This is to treat the file as a suspect. Spurious occurrences?)
# Options:
# -c	-  Char to be searched  
# -l	-  Threshold of count of occurrences of char.  

require("/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/printusage.pl");

# Assumes that the args begin after the params. (Each param begins by -)
local ($i, $parmlastpos, $argbegpos, $arg, $outf, $argsinfile, $Finname, $Foutname);
local ($char, $limit);
$parmlastpos = -1; # Gives pos of last param in ARGV. Default no params.
$argbegpos = -1;  # Gives position of 1st argument in ARGV. Default no args
$argsinfile = 0;  # Default args file names are not in a file.
$char = ''; # Default  Char to be searched  
$limit = 10; # Default  Threshold of count of occurrences of char.  

# Look up .probecharrc file. Override defaults.
if (open (RC, '.probecharrc')) {
  while (<RC>) {
    chop;
    if (/\s*#/) {  next; }   # Ignore. A comment line.
    if (/\s*-/) {  # A parameter found.
      $_ = '-' . $';
      if (substr($_,1,1) eq 'h') { # print help info.
        &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/probechar.cmd');
        die;
      }
      elsif (substr($_,1, 1) eq  'c') {
        $char = substr ($_, 2);
      }
      elsif (substr($_,1, 1) eq  'l') {
        $limit = substr ($_, 2);
      }
      else { 
          print STDERR "probechar.cmd: Unrecognized param in rc file: $_.\n";
          &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/probechar.cmd');
          die;
      }
    }
    else { # 
      print STDERR "probechar.cmd: Param must begin with '-' in rc file: $_. Ignoring.\n";
    }
  }
  close (RC);
}

for ($i=0; $i <= $#ARGV; $i++) { # Extract the parameters and locate
                                 #  starting loc of command args.
  if (substr($ARGV[$i],0,1) eq '-') {  # A parameter found.
    $parmlastpos++;  # Change the following lines to suit your needs.
    if (substr($ARGV[$i],1,1) eq 'h') { # print help info.
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/probechar.cmd');
      die;
    }
    elsif (substr($ARGV[$i],1,1) eq 'o') { # Specifies output file.
      $outfilename = substr ($ARGV[$i],2);
    }
    elsif (substr($ARGV[$i],1, 1) eq  'c') {
      $char = substr ($ARGV[$i], 2);
    }
    elsif (substr($ARGV[$i],1, 1) eq  'l') {
      $limit = substr ($ARGV[$i], 2);
    }
    else { print STDERR "probechar.cmd: Unrecognized param: $ARGV[$i].\n";
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/probechar.cmd');
      die;
    }
  }
  else { # Argument found. Parameters end.
    if (substr($ARGV[$i],0,1) eq '@') {  # A file of args found
      $argsinfile = 1;
      $ARGV[$i] = substr($ARGV[$i], 1);
    }
    $argbegpos = $i;
    last;
  }
}

#print STDERR "probechar.cmd: DEB params end: $parmlastpos;  args begin: $argbegpos; total: $#ARGV;\n";

# Process the arguments in the command line then call probechar.
# 1. Can be used as a filter. OR
# 2. If arg file names are given, they are treated as input files
#    and the output goes to a single file stdout.

if ($outfilename ne '') {
  open (OUT, ">$outfilename") ||
    die "probechar.cmd: Unable to open output file $outfilename.\n";
  $outf = OUT;
  $Foutname = $outfilename;
}
else { $outf = STDOUT; }

if ($argbegpos < 0) { # No args.
  &probechar(STDIN, $outf);
}
elsif ($argsinfile) {  # Argument filenames in file.
  open (ARGFILE, "$ARGV[$argbegpos]") ||
    die "probechar.cmd: Unable to open args file $ARGV[$argbegpos]\n" ;
  while (<ARGFILE>) { # Read args.
    chop;
    if (!(open (INFILE, $_))) {
      print STDERR "probechar.cmd: Unable to open file $_\n" ;
      next;
    }
    $Finname = $_;
    &probechar (INFILE, $outf);
    close (INFILE);
  }
  close (ARGFILE);
}
else { # Call the program with each arg. 
  for ($arg = $argbegpos; $arg <= $#ARGV; $arg++) {
    if (!(open (INFILE, "$ARGV[$arg]"))) {
      print STDERR "probechar.cmd: Unable to open file $ARGV[$arg]. Continuing.\n" ;
      next;
    }
    $Finname = $ARGV[$arg];
    &probechar (INFILE, $outf);
    close (INFILE);
  }
}
close ($outf);
 
#------------------------------------------------------

sub probechar {
local ($W_fin, $W_fout) = @_;
select($W_fout);
#%COMMENT
# Given a char and a file, goes through the file and returns 1
# if the given char is there in the file.
# (Returns 2 if there are less than 10 lines containing the chars.
#  This is to treat the file as a suspect. Spurious occurrences?)
#%CMD TYPE M1


local ($cnt) = 0;
while (<$W_fin>) {
  if (/$char/o) {
    $cnt++;
    if ($cnt >= $limit) { last; }
  }
}
if ($cnt >= $limit) { $res =  1; }
elsif ($cnt == 0) { $res =  0; }
else { $res =  2; }

print $Finname, ' ', $res, "\n";

}
1;
