#!/usr/bin/perl
# Like grep searches for the given pattern but
# each time an occurrence is found, it returns
# a sentence rather than a line.
#   Example usage: sgrep.pl  PATTERN FILENAME > OUTFILE
#   Example usage: sgrep.pl  PATTERN FILENAME1 FILENAME2 >OUTFILE
# All the options of hgrep should work except -e option (because it
# provides the pattern after the option followed by white space).

# Processing the input parameters 
local ($i, $pat, $lastopt, $begfilearg, $restargs, $cumopts);
for ($i=0;  $i <= $#ARGV;  $i++) {
  if (!($ARGV[$i] =~ /^-/)) { last; } # End of options.
}
$lastopt = $i - 1;

if ($#ARGV <= $lastopt) { die "Pattern to be searched not given.\n"; }
else { $pat = $ARGV[$lastopt + 1]; }
$begfileargs = $lastopt + 2;

$cumopts = '';  # Collect all the options.
for ($i=0;  $i <= $lastopt;  $i++) { $cumopts .= ' ' . $ARGV[$i]; }

$restargs = '';  # Collect file args (after the first which is pattern).
for ($i=$begfileargs;  $i <= $#ARGV;  $i++) { $restargs .= ' ' . $ARGV[$i]; }

system ("putsmark2.cmd  $restargs | sent2line.pl | hgrep $cumopts $pat");

   # if ($#ARGV < $begfileargs) { # Use STDIN file
   #   system ("putsmark2.cmd  | sent2line.pl | hgrep $cumopts $pat");
   # }
   # else {
   #   system ("putsmark2.cmd  $restargs | sent2line.pl | hgrep $cumopts $pat");
   # }

