# Searches for a given pattern and extracts it from given files.
# Called by xtr.cmd.
# $pat - Given pattern. ($pat OR $patfile will be given)
# $patfile -  File containing given patterns - one on each line.
# $strtype - Type of pattern: (1 pattern as it is, 2 word, 3 prefix, 4 sufix)
# $clean - Cleaning filter to be used. (0 no clean, 1 join words)
# $delim - Delimiter for end of sentence.
# $stem_filename - name of the stem of the filename (without extension)
# $src_outfile -   # File name for keeping source of xtracted sentence
# $src_outhandle - # Handle of file for keeping source of xtracted sentence

# Not implemented -r option below:
## $ref - Reference marks to be put in a sep file (0=no, 1=yes, 2=yes short form).

# $Id$

sub xtr {
  local ($infile, $outfile) = @_;
  local ($oldfile, $oldlimtr);
  local ($nonword, $punctmark, $src_lst);
  #print STDERR "xtr.pl:DEBUG: stem file name:$stem_filename\n";
  if ($srchpat eq '') {  # else it was constructed already
    $srchpat = &cons_srchpat;
    if ($srchpat eq '') {
      die "xtr.pl: No search pattern found.\n";
    }
    #print STDERR "xtr.pl:DEBUG: Search pattern:$srchpat\n";
  }
  $oldfile = select ($outfile);
  $oldlimtr = $/;
  $/ = $delim;
  while (<$infile>) {
    if ($clean == 1) { s/~\n#//; }
    if (/$srchpat/o) {
      s/\n/ /g;   s/^\s+//;  
      print $_;
      #if ($delim eq 'n') { print " $."; }
      print "\n";
      if ($src_outhandle ne '') { $src_lst .= "$Finname\n"; }
       # if ($delim ne 'n') { 
       #   s/\n/ /g;   s/^\s+//;  print "$_ $fnameaffix\n";
       # }
       # else { print "$_ $fnameaffix$."; }
    }
  }
  select ($oldfile);
  $/ = $oldlimtr;
  if ($src_outhandle ne '') {
    print $src_outhandle $src_lst;  # Write the sources of sentences in src file.
  }
}
1;
