# Searches for the given string in the word-iref text file
# Gets all those lines in which the item occurs, and writes to the
# output.
# Variables set by xtriref.cmd.
#  $dbmfile	- Name of the database file. (Default: wrdiref)
#  $str		- String to be searched.
#  $strtype	- Type of string to be searched (word, prefix, etc.)

# This does not make use of DBM files.
# It can be changed to conduct binary search on the text file later on.

# Takes an input pattern in variable $str with its type in $strtype
# and writes the irefs in which it occurs into the output file $fout.
# $fin is the file handle for file containing words and their irefs.
sub xtriref {
  local ($fin, $fout) = @_;
  local ($w, $irefs, $pat, $rem, $trailing);
  # Search for a string incl. prefix, suffix, string, or word.
  # print  STDERR 'DEB: string:', $str, ':', "\n";
  if ($strtype eq '1') { $pat = $str; }
  elsif ($strtype eq '2') { $pat = '^' . $str . "\s" ; }
  elsif ($strtype eq '3') { $pat = '^' . $str; }
  elsif ($strtype eq '4') { $pat = $str . "\s" ; }
  else { print STDERR "xtriref.pl: Illegal string type: $strtype.\n"; }
  print  STDERR 'DEB: pattern|', $pat, '|', "\n";

  # if ($Foutname eq '') { $trailing = ''; }
  # else {  $trailing = ">> $Foutname"; }
  # system ("grep \"$pat\" $Finname  $trailing");
  # if ($strtype eq '1') { system ("grep \"$str\" $Finname  $trailing"); }
  # elsif ($strtype eq '2') { system ("grep -w  \"$str\" $Finname  $trailing"); }
  # elsif ($strtype eq '3')  { system ("grep \"^$str\" $Finname  $trailing"); }
  # elsif ($strtype eq '4')  { system ("grep \"$str	\" $Finname  $trailing"); }
  # else { print STDERR "xtriref.pl: Illegal string type: $strtype.\n"; }

  while (<$fin>) {
    if (/$pat/o) {  # Make this test as fast as possible. o =  compile.
      # ($w, $rem) = split (/\s+/, $_, 2);
      # if ($w =~ /$pat/) { # Verify only on the selected lines.
      print $fout $_;
      #   if ($strtype eq '2') { return; }
      # }
    }
  }
}
1;
