#!/usr/bin/perl
#!/usr/bin/perl
# Searches for a given pattern and extracts it from given files (say, abc*.sm).
#   Example Usage: xtr.cmd -pPAT -dXYZ abc*.sm > PAT.xtr
# Above uses PAT for pattern to be searched, and delim XYZ for eos marks
# cmd type many to one. Instead of the pattern a file containing patterns could also
# be listed.
# TWO NEW OPTIONS: -f, -N
# Options:
# -p	-  Pattern to be searched.
# -f	-  File containing patterns to be searched. Supersedes -p option.
# -t	-  Type of pattern (1 as it is, 2 word, 3 prefix, 4 suffix, 5 Use word-index file (stem_filename.iref))
# -d	-  Delimiter to be used for end of 'sentence' mark. 'n' for nl.
# -c	-  Clean the corpus (0=no clean, 1=join words). Default: 0.
# -N	-  Name of the stem of filenames (without extention).
# -s	-  File name for keeping source file names of xtracted sentence
# -a	-  File name for keeping vertically aligned output.
# -l	-  Number of sentences to be included before and after the current sentence. Default: 

require("/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/xtrnew.pl");
require("/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/cons_srchpat.pl");
require ("/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/printusage.pl");

# Assumes that the args begin after the params. (Each param begins by -)
local ($i, $parmlastpos, $argbegpos, $arg, $outf, $argsinfile, $Finname, $Foutname);
local ($pat , $patfile , $strtype, $delim, $clean, $stem_filename, $src_outfile, $algn_outfile, $sent_context);
$parmlastpos = -1; # Gives pos of last param in ARGV. Default no params.
$argbegpos = -1;  # Gives position of 1st argument in ARGV. Default no args
$argsinfile = 0;  # Default args file names are not in a file.
# $pat  -  Pattern to be searched.
# $patfile  -  File containing patterns to be searched. Supersedes -p option.
$strtype = 1 ; # Default  Type of pattern (1 as it is, 2 word, 3 prefix, 4 suffix, 5 Use word-index file (stem_filename.iref))
$delim = '<.>'; # Default  Delimiter to be used for end of 'sentence' mark. 'n' for nl.
$clean = 0; # Default  Clean the corpus (0=no clean, 1=join words). Default: 0.
$stem_filename = ''; # Default  Name of the stem of filenames (without extention).
$src_outfile = ''; # Default  File name for keeping source file names of xtracted sentence
$algn_outfile = ''; # Default  File name for keeping vertically aligned output.
$sent_context = 0; # Default  Number of sentences to be included before and after the current sentence. Default: 

# Look up .xtrnewrc file. Override defaults.
if (open (RC, '.xtrnewrc')) {
  while (<RC>) {
    chop;
    if (/\s*#/) {  next; }   # Ignore. A comment line.
    if (/\s*-/) {  # A parameter found.
      $_ = '-' . $';
      if (substr($_,1,1) eq 'h') { # print help info.
        &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/xtrnew.cmd');
        die;
      }
      elsif (substr($_,1, 1) eq  'p') {
        $pat  = substr ($_, 2);
      }
      elsif (substr($_,1, 1) eq  'f') {
        $patfile  = substr ($_, 2);
      }
      elsif (substr($_,1, 1) eq  't') {
        $strtype = substr ($_, 2);
      }
      elsif (substr($_,1, 1) eq  'd') {
        $delim = substr ($_, 2);
      }
      elsif (substr($_,1, 1) eq  'c') {
        $clean = substr ($_, 2);
      }
      elsif (substr($_,1, 1) eq  'N') {
        $stem_filename = substr ($_, 2);
      }
      elsif (substr($_,1, 1) eq  's') {
        $src_outfile = substr ($_, 2);
      }
      elsif (substr($_,1, 1) eq  'a') {
        $algn_outfile = substr ($_, 2);
      }
      elsif (substr($_,1, 1) eq  'l') {
        $sent_context = substr ($_, 2);
      }
      else { 
          print STDERR "xtrnew.cmd: Unrecognized param in rc file: $_.\n";
          &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/xtrnew.cmd');
          die;
      }
    }
    else { # 
      print STDERR "xtrnew.cmd: Param must begin with '-' in rc file: $_. Ignoring.\n";
    }
  }
  close (RC);
}

for ($i=0; $i <= $#ARGV; $i++) { # Extract the parameters and locate
                                 #  starting loc of command args.
  if (substr($ARGV[$i],0,1) eq '-') {  # A parameter found.
    $parmlastpos++;  # Change the following lines to suit your needs.
    if (substr($ARGV[$i],1,1) eq 'h') { # print help info.
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/xtrnew.cmd');
      die;
    }
    elsif (substr($ARGV[$i],1,1) eq 'o') { # Specifies output file.
      $outfilename = substr ($ARGV[$i],2);
    }
    elsif (substr($ARGV[$i],1, 1) eq  'p') {
      $pat  = substr ($ARGV[$i], 2);
    }
    elsif (substr($ARGV[$i],1, 1) eq  'f') {
      $patfile  = substr ($ARGV[$i], 2);
    }
    elsif (substr($ARGV[$i],1, 1) eq  't') {
      $strtype = substr ($ARGV[$i], 2);
    }
    elsif (substr($ARGV[$i],1, 1) eq  'd') {
      $delim = substr ($ARGV[$i], 2);
    }
    elsif (substr($ARGV[$i],1, 1) eq  'c') {
      $clean = substr ($ARGV[$i], 2);
    }
    elsif (substr($ARGV[$i],1, 1) eq  'N') {
      $stem_filename = substr ($ARGV[$i], 2);
    }
    elsif (substr($ARGV[$i],1, 1) eq  's') {
      $src_outfile = substr ($ARGV[$i], 2);
    }
    elsif (substr($ARGV[$i],1, 1) eq  'a') {
      $algn_outfile = substr ($ARGV[$i], 2);
    }
    elsif (substr($ARGV[$i],1, 1) eq  'l') {
      $sent_context = substr ($ARGV[$i], 2);
    }
    else { print STDERR "xtrnew.cmd: Unrecognized param: $ARGV[$i].\n";
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/corp/xtrnew.cmd');
      die;
    }
  }
  else { # Argument found. Parameters end.
    if (substr($ARGV[$i],0,1) eq '@') {  # A file of args found
      $argsinfile = 1;
      $ARGV[$i] = substr($ARGV[$i], 1);
    }
    $argbegpos = $i;
    last;
  }
}

#print STDERR "xtrnew.cmd: DEB params end: $parmlastpos;  args begin: $argbegpos; total: $#ARGV;\n";

# Process the arguments in the command line then call xtrnew.
# 1. Can be used as a filter. OR
# 2. If arg file names are given, they are treated as input files
#    and the output goes to a single file stdout.

if ($outfilename ne '') {
  open (OUT, ">$outfilename") ||
    die "xtrnew.cmd: Unable to open output file $outfilename.\n";
  $outf = OUT;
  $Foutname = $outfilename;
}
else { $outf = STDOUT; }

if ($src_outfile ne '') {
  if (open (SRCOUT, ">$src_outfile")) { $src_outhandle = SRCOUT; }
  else {
    print STDERR "Unable to open file for keeping sentence sources: $src_outfile. Continuing. $!\n;";
  }
}

if ($argbegpos < 0) { # No args.
  &xtrnew(STDIN, $outf);
}
elsif ($argsinfile) {  # Argument filenames in file.
  open (ARGFILE, "$ARGV[$argbegpos]") ||
    die "xtrnew.cmd: Unable to open args file $ARGV[$argbegpos]\n" ;
  while (<ARGFILE>) { # Read args.
    chop;
    if (!(open (INFILE, $_))) {
      print STDERR "xtrnew.cmd: Unable to open file $_\n" ;
      next;
    }
    $Finname = $_;
    &xtrnew (INFILE, $outf);
    close (INFILE);
  }
  close (ARGFILE);
}
else { # Call the program with each arg. 
  for ($arg = $argbegpos; $arg <= $#ARGV; $arg++) {
    if (!(open (INFILE, "$ARGV[$arg]"))) {
      print STDERR "xtrnew.cmd: Unable to open file $ARGV[$arg]. Continuing.\n" ;
      next;
    }
    $Finname = $ARGV[$arg];
    &xtrnew (INFILE, $outf);
    close (INFILE);
  }
}
close ($outf);
 
