# Searches for a given pattern and extracts it from given files.
# Called by xtr.cmd.
# $pat - Given pattern. ($pat OR $patfile will be given)
# $patfile -  File containing given patterns - one on each line.
# $strtype - Type of pattern: (1 pattern as it is, 2 word, 3 prefix, 4 sufix)
# $clean - Cleaning filter to be used. (0 no clean, 1 join words)
# $delim - Delimiter for end of sentence.
# $stem_filename - name of the stem of the filename (without extension)
# $src_outfile -   # File name for keeping source of xtracted sentence
# $src_outhandle - # Handle of file for keeping source of xtracted sentence
# $sent_context - # Number of sentences to be included before and after teh current sentence.

# Not implemented -r option below:
## $ref - Reference marks to be put in a sep file (0=no, 1=yes, 2=yes short form).

# $Id$

sub xtrnew {
  local ($infile, $outfile) = @_;
  local ($oldfile, $oldlimtr);
  local ($nonword, $punctmark, $src_lst);
  #print STDERR "xtr.pl:DEBUG: stem file name:$stem_filename\n";
  if ($srchpat eq '') {  # else it was constructed already
    $srchpat = &cons_srchpat;
    if ($srchpat eq '') {
      die "xtr.pl: No search pattern found.\n";
    }
    #print STDERR "xtr.pl:DEBUG: Search pattern:$srchpat\n";
  }
  $oldfile = select ($outfile);
  $oldlimtr = $/;
  $/ = $delim;
   # Cicular buffer: @pre_arr. 
   # $pre_strt	- Points to first empty slot
   # $pre_end	- Points to last filled element
   # if ($pre_strt == $pre_end) then array is empty.
  $max_pre_arr = $sent_context;  #  Last element of @pre_arr. Counting from 0 to $max_pre_arr
  $pre_strt = $pre_end = 0;  $post_flag = 0; $post_cnt = 0;
  while (<$infile>) {
    if ($clean == 1) { s/~\n#//; }
    if (/$srchpat/o) {
      if ($pre_strt != $pre_end) { # Print if non empty @pre_arr.
        print '---', "\n";  # Signal beginning of context
        $ip = $pre_strt;
        for ($i=0; $i <= $max_pre_arr; $i++) {
          if ($ip == $pre_end) { last; } # loop over.
          $ip++;  $ip = $ip % $sent_context;
          $pre_arr[$ip] =~ s/\n/ /g;
          $pre_arr[$ip] =~ s/^\s+//g;
          #print "DEB:pre:";
          print $pre_arr[$ip], "\n";
        } 
        $pre_strt = $pre_end = 0;  # Reset the pre_arr to empty.
      } 
      s/\n/ /g;   s/^\s+//;    print '**', $_;   print "\n";
      #if ($delim eq 'n') { print " $."; }
      $post_flag = 1;  # Print the post sentences (ie after this sent)
      $post_cnt = 0;
      if ($src_outhandle ne '') { $src_lst .= "$Finname\n"; }
    }
    else { # Pattern not found in the current line.
      $just_written = 0;
      if ($post_flag == 1) { # Post flag is on.
        #print "DEB:post:";
        s/\n/ /g;   s/^\s+//;  print $_, "\n"; $just_written = 1;
        $post_cnt++;
        if ($post_cnt == $sent_context) { # All the reqd post sent saved
          $post_cnt = 0;   $post_flag = 0;
        }
      }
      if ($just_written == 0) {
        # Store current line in circular buffer pre_arr.
        $pre_end++; $pre_end = $pre_end % $sent_context;
        $pre_arr[$pre_end] = $_;
        if ($pre_end == $pre_strt) { # they have become equal.
          $pre_strt++; $pre_strt = $pre_strt % $sent_context;
        }
      }
    }
  } # End of while loop
  select ($oldfile);
  $/ = $oldlimtr;
  if ($src_outhandle ne '') {
    print $src_outhandle $src_lst;  # Write the sources of sentences in src file.
  }
}
1;
