#!/usr/bin/perl
# Takes a table of coverage of different corpora, and processes
# the entries.
# Input file:
#  10% -> a=    5 b=    5 c=    5 d=    5 e=    5 g=     5 j=     5 z=    5
#  20% -> a=   12 b=   13 c=   14 d=   15 e=   15 g=    15 j=    15 z=   15
#  30% -> a=   28 b=   29 c=   29 d=   31 e=   31 g=    31 j=    31 z=   32
#         ^label1         ^label3
# Output file:
#  10% -> a=    5 b=    5 c=    5 d=    5 e=    5 g=     5 j=     5 z=    5
#  20% ->  a=7 b=8 c=9 d=10 e=10 g=10 j=10 z=10
#  30% ->  a=16 b=16 c=15 d=16 e=16 g=16 j=16 z=17

$max = -1;
while (<>) {  # Read the next line.
  chop;
  $i = -1;
  while (/[a-zA-Z]+=/) {  # Separate labels and values.
    $i++; $cur[$i] = $`; $label[$i + 1] = $&;
    $_ = $';
  }
  $i++;  $cur[$i] = $_;  # Store the value of the last label
  $label[0] = $cur[0];   # Store the first part before label[1]

  if ($max != -1) { if ($max != $i) {
      print STDERR "Cover_proc.pl: Lines with different entries: $i, $max\n";
  }}
  $max = $i;

  if ($#prev != -1) { # This is not the first line read.
    for ($j=1; $j <= $max;  $j++) { # Compute the difference (Processing part)
       $res[$j] = $cur[$j] - $prev[$j]; $prev[$j] = $cur[$j];
  } }
  else {  # This is the first line.
    for ($j=1; $j <= $max;  $j++) {  # Do essentially nothing.
      $res[$j] = $cur[$j]; $prev[$j] = $cur[$j];
  } }

  for ($j=0; $j <= $max;  $j++) { # Print
    print $label[$j], $res[$j], ' ';
  }
  print "\n";
}
  
