#!/usr/bin/perl
# Takes *.cov files and produces cross coverages.
# For example it takes w8.cov, w9.cov, w10.cov to w30.cov etc.
# w8.cov contains (for a 8lakh word corpus) coverages for 10%, 20% 
# to 100%, and similarly w9.cov for 9 lakh word corpus, etc.
#   It produces u10.cvr, u20.cvr, etc.  u10.cvr contains all the
# number of words needed to cover 10% of the different sized corpora.
#   The same thing would be done for we8.cov, we9.cov to we30.cov 
# containing coverages for 80%, 81%, 82%, to 100% to
# produce ue80.cvr, etc.

# Run on subsets of hindi corpora of different sizes (or number of
# words (8lakhs, 9lakhs to 30 lakhs).

for ($p=80; $p <= 100; $p++) { # All the percentages
  $lineno = $p - 79;
  for ($i=8; $i <= 30; $i += 1) { # All the subsets
    print "nth.sh $lineno < w$i.cov >> ue$p.cvr\n";
  }
}
