#!/usr/bin/perl
# Loads the corpus subject and their corresponding classification
# numbers using the input file.
#   &ldsubj.pl(STDIN)   # input from say 'Subj.comp'
# It builds an in-memory index, which can be used by other programs.
# Two global associative arrays are used:
#  %classi_subj,   and   %subj_classi

#&ldsubj (STDIN);
sub ldsubj {
  local ($fin) = @_;
  while (<$fin>) {
    $#words = -1;
    if (/^\s+$/) { next; }  # A blank line.
    if (/^\s+#/) { next; }  # A comment line.
    if (/^\s+/) { $_ = $'; }  # Remove opening space.
    if (/\s+$/) { $_ = $`; }  # Remove ending space.
    @words = split (/\s+/, $_, 2);
    ($classi, $subj) = @words;
    #$classi =~ tr/A-Z/a-z/;
    $subj =~ tr/A-Z/a-z/;
    $subj =~ s/\s+/ /;
       # if ($#words != 1) { 
       #   print STDERR "ldsubj.pl: Invalid format for line $.:$_\n";
       # }
    $classi_subj{$classi} = $subj;
    if ($subj =~ /\//) {  # Alternatives found.
      @subj_names = split (/\s*\/\s*/, $subj);
      for ($i=0;  $i <= $#subj_names;  $i++) {
        if ($subj_classi{$subj_names[$i]}) { # Already has a value
          print STDERR "An earlier subject found again in $classi: $subj_names[$i].\n";
        }
        else { $subj_classi{$subj_names[$i]} = $classi; }
      }
    }
    else { $subj_classi{$subj} = $classi; }
  }
}
1;
