# Program for retrieving words that co-occur in the same sentence 
# with the forms of the given root. Ex. root pI, forms are pIwA, piyegA.
#   Example usage: concord_snt.sh  pI
# The following files should exist:
#   $1.xtr contains sentences (one sentence on a line) which
#          corresponds to the orginal srch command.
#   $1.iref contains the list of words with their indices used to 
#           extract above sentences.
#           (typically this list as well as the sentences have 
#           earlier been manually edited)
#
# The above files get created by the following three steps manually:
# In these
# steps it is assumed that sentences have been pulled out as follows:
# (1) srch command has been run,
# (2) pI.iref has been edited manually, and 
# (3) srch.do has been run.
#1. srch ... pI  prefix... # creates pI.iref
#2. human-edit pI.iref keep only the forms of root pI in pI.iref
#3. srch.do   # creates pI.xtr
#

sed 's/ .*//' $1.iref > $1.lst
grep -f"$1.lst"  < $1.xtr > $1.xtr2  # keep only those which actually occur in $1.iref
ngram_mk.sh 10 < $1.xtr2 > $1.ng10   # Look only upto 10 words near $1
sed 's/^[^0-9]* //' $1.ng10 > $1.ng10a
ngram_mk.sh 1 < $1.ng10a > $1.ng1
rm_wlist.pl hndfrq.lst < $1.ng1  > $1.ng1a
rm_wlist.pl $1.lst < $1.ng1a > $1.ng1b
cum_frq.pl $1.ng1b > $1.ng1c
