#!/usr/bin/perl
# Input file is one produced by low_frq.pl, containing freq of freq f
#   in each line. Finally, contains corpus size.
# Output is: adds percentage coverage information to the above

open (OUT, ">cov_low.tmp") ||
  die "cov_low_frq.pl: Unable to open out file cov_low.tmp\n";
while (<>) {
  if (/corpus[ _]+size/i) {
    $pre = $`;
    if ($pre =~ /([0-9]+) *$/) {
      $size = $1;
    }
    else { print STDERR "Corpus size not found: $_"; }
  }
       #else { print OUT $_; }
  print OUT $_;
}
close (OUT);
if ($size == 0) { print STDERR "cov_low_frq.pl: Corpus size not found.\n"; }

# Format for output summary
format FORMAT =
@<<<<<<<<<<< @#.##%
$_,                     $prop
.
$~ = "FORMAT";   # Format to be used with 'write'

$tot_cnt = 0;  # Count of words covered so far.
open (IN, "cov_low.tmp") ||
  die "cov_low_frq.pl: Unable to open input file cov_low.tmp\n";
while (<IN>) {
  if (/corpus[ _]+size/i) { # Corpus size line found. Usually last.
    $prop = 100 * $tot_cnt / $size;
    chop;   print $_, " $prop% total_above\n";   next;
  }
  chop;
  ($n1, $n2) = split (/\s+/);
  $prod = $n1 * $n2;
  $prop = 100 * $prod / $size;
  if ($prop != 0) { $tot_cnt += $prod; }
  write;
}
