#!/usr/bin/perl
# Hindi corpus as given has several large files, each file
# containing a large number of texts.
# This splits the given files in Hindi corpus into smaller files
# each containing a different text.
#   Example usage:  hindisplit.pl pathxxx/BASEFILENAME
# The above produces in the current directory several files each 
# containing a different text, named as:
#   BASEFILENAME/1, BASEFILENAME/2, ...

# $Finname	- Name of the current input file.
# $fin		- File handle of the input file.
# $fout		- File handle of the output file. Not used.

sub hindisplit {
  local ($fin, $fout) = @_;
  local ($curtextno, $rest, $res) = 1;  # text number
  # print STDERR "hindisplit.pl DEBUG: Processing file $Finname\n";
  if ($Finname =~ /[^\/]+$/) { $basename = $&; }  # Get the base name
  else { 
    print STDERR "hindisplit.pl: Unable to obtain base-filename from $Finname\n";
    return;
  }
     #if ($basename =~ /\./) { $basename = $`; }
  $res = system ("mkdir $basename"); # Create dir with the basename.
  if ($res != 0) { 
    print STDERR "hindisplit.pl: Unable to create directory $basename: $!\n";
    return;
  }
  # print STDERR "hindisplit.pl: DEBUG: Filename $Finname, Dir $basename\n";
  $/ = '+>';
  while (<$fin>) {
    if (!(open (TEXTF, ">$basename/$curtextno"))) {
      print STDERR 
      "hindisplit.pl: Unable to open output file $basename/$curtextno\n";
      next;
    }
    print TEXTF $_, "\n";
    close (TEXTF);
    $curtextno++;
  }   # End of while loop
  $/ = "\012";

  if ($_ ne '') {
    if (!(open (TEXTF, ">$basename/$curtextno"))) {
      print STDERR 
      "hindisplit.pl: Unable to open output file $basename/$curtextno\n";
    }
    else { print TEXTF $_;  close (TEXTF);  $curtextno++; }
  }
}
1;
