#!/usr/bin/perl
# Extracts word ending with '~' in a line as well as the following word
# in the next line.
# $curiref ; # iref number for the files completed so far.

sub irefmk_tld {
  local ($fin, $fout) = @_;
  local ($foundtilde, $_);
  $foundtilde = 0;
  ++$curiref;
  while (<$fin>) {
    if ($foundtilde == 1) { # Previous line had a broken word.
      $foundtilde = 0;
      if (/\s/) {  # Match the first non-alphabetic character
            # print $fout '~', $`, '  ', $curiref, "\n";
        print $fout $oldpre, '~', $`, '  ', $curiref, "\n";
        $oldpre = '';
      }
      else { print STDERR "In file-iref $curiref not found beginning word: $_"; }
    }
    if (/~$/) { # End of this line has a broken word.
      if (/ +~$/) { # Remove space preceding '~'$.
        $_ = $` . '~' . "\n";
        print STDERR "warn: In file-iref $curiref removed space before '~' in line $.\n";
      }
      if (/[^\s]+~$/) {  
        $oldpre = $&;
           # print $fout $&, '  ', $curiref, "\n"; 
        $foundtilde = 1; 
      }
      else { print STDERR "In file-iref $curiref ignoring tilde ending: $_"; }
    }
  }  # End while loop
}
1;
