#!/usr/bin/perl
#%COMMENT
#Input : a file of frequency of occurrence f and phrase in each line
#          sorted from high to low f.
#Output : frequency of frequency of occurrence f (when f is less than 
#          or equal to given limit)
#  Example usage:  low_frq2.pl  < phrase.frq  > phrase.lcov
# (Same as low_frq.pl except allows phrases instead of only words.)
#%CMD TYPE 11

$low = 20;   # Frequency of occurrence less than or equal to given limit is considered low. (Default: 20) #OPT -l
$tot_cnt=0;  # Total count of all the words (corpus size).
$tot_dist_cnt=0;  # Number of distinct words.
$cur_cnt=0;  # Count of words with the current frequency (<= $low)
$prev_frq = $low + 1;  # Set it some value higher than $low.
while(<>) {
  chop;
  @wrd_lst = split(/\s+/, $_, 2);
  ($frq, $word) = @wrd_lst;
  $tot_cnt += $frq;
  $tot_dist_cnt++;
  if ($frq > $low) { $cur_cnt++; }
  else {  # A low frequency found.
    if ($prev_frq == $frq) {
      $cur_cnt++;
    }
    else { # A new freq found.
      if ($prev_frq  > $low) { # first time a low freq found
        print $cur_cnt, " >$low\n";
        $prev_frq = $frq;  $cur_cnt = 1;
      }
      else {
        print $cur_cnt, " $prev_frq\n";
        $prev_frq = $frq;  $cur_cnt = 1;
      }
    }
  }
} 
# Now empty the last entry.
print $cur_cnt, " $frq\n";
print "$tot_dist_cnt Distinct_words ($tot_cnt Corpus_size)\n";
  #print "$tot_cnt $tot_dist_cnt   Total words and distinct words\n";
