#!/usr/bin/perl
# Change names of corpus files to shorter ones by renaming dirs.
# Example: Old Name /usr3/corpus/telugu/u1t1-1/telugu1/barish1
#          New name /usr3/corpus/telugu/f1/barish1
# For each directory in corpus, change its midname (u1t1-1/telugu1/)
# to shorter midname (f1/ etc.).
# Midname is currently defined to be the path name after .../telugu/
# to before basename.

$genmidno = 0;   $oldmidname = '';
while (<>) {
  chop;
  $fullname = $_;
  if (/\/telugu\//) {  # Remove pathname upto telugu.
    $leftname = $` . $&;
    $_ = $';
    if (/([^\/]+)$/) { # Separate basename from midname
      $basename = $1;     $midname = $`;
      if ($midname ne $oldmidname) { # Generate new dir name.
        $oldmidname = $midname;
        $genmidno++;    $genmidname = 'f' . $genmidno . '/';
        $dirname =  $leftname . $midname;   chop $dirname;
        $gendirname =  $leftname . $genmidname;   chop $gendirname;
        print STDERR 'mv ', $dirname, '  ', $gendirname, "\n"; 
      }
      # print $fullname, ' ';
      print $leftname, $genmidname, $basename, "\n";
      # print STDERR '# ', $midname, $basename, ' --> ', $genmidname, $basename, "\n";
    }
    else { print STDERR "Midname not found. $_, ', ', $fullname\n" }
  }
  else { print STDERR "Unknown corpus name: $fullname\n" }
}
