#!/usr/bin/perl
#%COMMENT
# Takes a file containing text and makes a file of all the
# word sequences of length s (default 3).
# Assumes that punctuation marks have been separated in the input file,
# and the end of sentence markers have been inserted.
#   Example usage: ngram_seq_mk.pl  -s5  < TEXTFILE  > FRQFILE
# In the above, word sequences of length 5 or less are generated.
#%CMD TYPE M1

$seq_len = 3; # Length of word sequences which have to be retrieved. #OPT -s

$/ = '<.>';
while (<>) {
  chop; chop; chop;
  if (/^\s+/) { $_ = $'; }
  if (/\s+$/) { $_ = $`; }
  @words = split (/[\",:;\'`\?><\]\[}{\)\(=!@#%&\*\.\xea\s]+/);
     #NOT USED:-> '[",:;\'`\?\]\[}{\)\(=!@#%&\*\s]';

  #for ($i=0;  $i <= $#words;  $i++)  { #Sequences of length 1
  #  #print "DEB: word $i is  = '$words[$i]'\n";
  #  print $words[$i], "\n";
  #}
  #for ($i=0;  $i <= $#words - 1;  $i++)  { #Sequences of length 2
  #  for ($j=0;  $j <= $seq_len - 3;  $j++)  {
  #    print $words[$i+$j], ' ';
  #  }
  #  print $words[$i + $seq_len - 2],  "\n";
  #}
  for ($i=0;  $i <= ($#words - ($seq_len - 1));  $i++)  { #Sequences of length 3
    #print "DEB: word $i is  = '$words[$i]'\n";
    for ($j=0;  $j <= $seq_len - 2;  $j++)  {
      print $words[$i+$j], ' ';
    }
    print $words[$i + $seq_len - 1],  "\n";
  }
}
