#!/usr/bin/perl
# Extract the headers of all the files in the corpus by looking at the
# first few (currently, 5) lines.
# The header contains info about title, author, etc.
# $file_num	- Non local. Initially 0. Incremented in each call.
sub get_hdr {
  local ($fin, $fout) = @_;
  local ($i, $_, $foundhdr, $poss_hdr);
  $foundhdr = 0;   $poss_hdr = '';
  $file_num++;
  for ($i=1;  $i<=5;  $i++) {
    $_ = <$fin>;
    if (/<$/) { print $fout $file_num, ' ', $_;  $foundhdr = 1;  last; }
    $num = tr/</</;
    if ($num > 5) { # Possibly a header line.
      $poss_hdr = $_;
    }
  }
  if ($foundhdr == 0) { 
    if ($poss_hdr ne '') { 
      print $fout $file_num, ' ', $poss_hdr;
      print STDERR "$file_num Possible header: $poss_hdr";
    }
    else {
      print STDERR "In $Finname no header found in first 5 lines.\n";
      print $fout $file_num, " ----- unknown -------\n";
    } 
  }
}
1;
