#!/usr/bin/perl
# Extract the headers of all the files in the corpus by looking at the
# first few lines.
# The header contains info about title, author, etc.
# $file_num	- Non local var. Initially 0. Incremented in each call.
sub hindi_hdr {
  local ($fin, $fout) = @_;
  local ($i, $_, $doubt_hdr, $poss_hdr);

  $file_num++;
  $doubt_hdr = 0;
  print $fout $file_num, ' ';
  while (<$fin>) {
    if (/^\s*$/) { next; }  # Empty line. Ignore in count.
    $i++;
    if ($i > 11) { last; } # Headers should be over.
    if (!(/^\s*<.+>\s*$/)) {
      print STDERR "hindi_hdr.pl: In $Finname line $. does not seem part of the header: $_";
      $doubt_hdr++;
    }
    chop;
    print $fout $_;
  }
  print "\n";
  if ($doubt_hdr > 3) {
    print STDERR "hindi_hdr.pl: In $Finname header doubtful.\n";
  }
}
1;
