#!/usr/bin/perl
# Cleans a file of words where each word is in a new line. 
# In particular it removes TAB chars, from the beginning of words.
# Also converts the tab following the word into a space.
#   Example usage: wicln.pl < wi.ndx   > wi.ndx.2
# TO IMPLEMENT: remove a line with only [0-9\-]+ in the word.

while (<>) {
  $fullname = $_;
  s/^([\",;'`\?><\]\[}{\)\(=!@#%&\*\.\$])//; # Remove punct marks before the beginning of the word.
  s/([\",;'`\?><\]\[}{\)\(=!@#%&\*\.\$])\s/\s/; # Remove punct marks after the end of the word.
  if (/^\s+/) {  $_ = $'; }
  if (/^-+/) {  $_ = $'; }  # Remove '-' if more than one in the beginning.
  s/\t/ /g;
  print;
}

