#!/usr/bin/perl
# Punjabi corpus as given has several large files, each file
# containing a large number of texts.
# This splits the given files in Hindi corpus into smaller files
# each containing a different text.
#   Example usage:  punjsplit.pl BASE_DIRNAME/uuu
# The above produces in the current directory several files each 
# containing a different text, named as:
#   BASE_DIRNAME/1, BASE_DIRNAME/2, ...
# (Note that a directory with the same name as the BASE_DIRNAME
# is created. Files are created inside it numbered 1, 2, 3 etc.
# ignoring uuu.)

# $Finname	- Name of the current input file.
# $fin		- File handle of the input file.
# $fout		- File handle of the output file. Not used.

sub punjsplit {
  local ($fin, $fout) = @_;
  local ($curtextno, $rest, $res) = 1;  # text number
  # print STDERR "punjsplit.pl DEBUG: Processing file $Finname\n";
  if ($Finname =~ /[^\/]+$/) {  # Get the base dir name
    $basename = $`;
    if ($basename =~ /[^\/]+$/) { $basename = $&; } # Get the base name
    else { 
      print STDERR "punjsplit.pl: Unable to obtain base-dirname from $Finname\n";
      return;
    }
  }  
  else { 
    print STDERR "punjsplit.pl: Unable to obtain base-filename from $Finname\n";
    return;
  }
     #if ($basename =~ /\./) { $basename = $`; }
  $res = system ("mkdir $basename"); # Create dir with the basename.
  if ($res != 0) { 
    print STDERR "punjsplit.pl: Unable to create directory $basename.\n";
    return;
  }
  # print STDERR "punjsplit.pl: DEBUG: Filename $Finname, Dir $basename\n";
  $/ = '+>';
  while (<$fin>) {
    if (!(open (TEXTF, ">$basename/$curtextno"))) {
      print STDERR 
      "punjsplit.pl: Unable to open output file $basename/$curtextno\n";
      next;
    }
    print TEXTF $_;
    close (TEXTF);
    $curtextno++;
  }   # End of while loop
  $/ = "\012";

  if ($_ ne '') {
    if (!(open (TEXTF, ">$basename/$curtextno"))) {
      print STDERR 
      "punjsplit.pl: Unable to open output file $basename/$curtextno\n";
    }
    else { print TEXTF $_;  close (TEXTF);  $curtextno++; }
  }
}
1;
