#!/usr/bin/perl
# Takes a word-iref file, and makes adjacent entries unique by 
# merging adjacent entries with the same word. E.g., the foll. lines:
#   xCBQr  1 4 5 7 8 13 18 19 20
#   xCBQr  128 130 131 135 136 139
# will be merged into a single line:
#   xCBQr  1 4 5 7 8 13 18 19 20 128 130 131 135 136 139
# Example usage: wiuniq.pl < wi.txt2.sort > wi.txt

local ($oldword, $accumentry, $word, $entry, $first, $fullline);
$_ = <>;
if (/\s+/) { 
  $oldword = $`;  $accumentry = $';
}  
else { print STDERR "CHECK the word iref entry: $_"; }

while (<>) {
   # Replaced the foll. line by next line for speed (but less robust):
   #      if (/\s\s+/) { 
  if (/\s+/) { 
    $word = $`;  $entry = $';
    if ($oldword eq $word) { # Try to merge.
      chop $accumentry;
      $accumentry = $accumentry . ' ' . $entry;
    }
    else { # New entry found. Output previous entry.
      print $oldword, '  ', $accumentry;
      $oldword = $word;   $accumentry = $entry;
    }
  }  
  else { print STDERR "CHECK the word iref entry: $_"; }
}
# Now print the last entry.
print $oldword, '  ', $accumentry;

