#!/usr/bin/perl
#%COMMENT
# Takes an input file containing on each line: 
#  an input word, and its morph analysis (with root and features); 
# and inverts the file to produce:
#  root, words with that root
#   Example usage: word_mo.pl < IN  > MO.ndx

# Here is an example of an input file
#   unna    uMdu{v *ina* any }/
#   lexu    lexu{Avy }/lexu{n *avy_0* }/gala{v *a* 3_non_pu_e }/
#   mana    mana{n *avy_0* }/manu{v *an* any }/
#   nuMdi   nuMdi{Avy }/nuMdi{n *avy_0* }/
#   aMtAru  aMtu{v *A* 23_ba }/anu{v *wA* 23_ba }/
# The output is:
#   uMdu unna
#   lexu lexu
#   lexu lexu
#   gala lexu
#   mana mana
#   manu mana
#   nuMdi nuMdi
#   nuMdi nuMdi
#   aMtu aMtAru
#   anu aMtAru
#%CMD TYPE M1

while (<>) {
  chop;
  if (/\s+/) {
    $word = $`;  $mo_output = $'; 
    @mo_out = split (/\//, $mo_output);
    if ($#mo_out < 0) { 
      print STDERR "DEB: No morph analysis for: $word\n";
    }
    else {
       #for ($i=0;  $i <= $#mo_out; $i++) {
       #  if ($mo_out[$i] =~ /{/) { $mo_out[$i] = $`; }
       #} 
      foreach $mo (@mo_out) {
        if ($mo =~ /{/) { print $`, ' ', $word, "\n"; }
      }
    }
  }
  else { print STDERR "Unrecognized format: $_\n"; }
}
