# Takes an input file containing on each line: 
#  an input word, and its morph analysis (with root and features); 
# and inverts the file to produce:
#  root, words with that root
#   Example usage: word_mo.sh < IN  > ROOT.NDX
#
# Here is an example of an input file
#   unna    uMdu{v *ina* any }/
#   lexu    lexu{Avy }/lexu{n *avy_0* }/gala{v *a* 3_non_pu_e }/
#   mana    mana{n *avy_0* }/manu{v *an* any }/
#   nuMdi   nuMdi{Avy }/nuMdi{n *avy_0* }/
#   aMtAru  aMtu{v *A* 23_ba }/anu{v *wA* 23_ba }/
# The output is:
#   uMdu unna
#   lexu lexu
#   lexu lexu
#   gala lexu
#   mana mana
#   manu mana
#   nuMdi nuMdi
#   nuMdi nuMdi
#   aMtu aMtAru
#   anu aMtAru

word_mo.cmd | sort -u | wiuniq.pl 
