#!/usr/bin/perl
# Counts the frequencies of words of different lengths
#   Example usage: wrdlenfrq.pl  < freq.cnt  > wrdlen.frq
# Input: word freq file each line contains (frequency, word)
# Output: (length l, frequency of words of length l, 
#                count of distinct word of length l)

$maxlen = -1;
while (<>)  {
  chop;
  ($freq, $word) = split (/\s+/);
  $len = length ($word);
  if ($len > $maxlen) { $maxlen = $len; }
  $lenfreq{$len} += $freq;
  $lencount{$len}++;
  # print STDERR "DEBUG: len=$len, freq=$freq,\n";
}

for ($l=1;  $l <= $maxlen;  $l++)  {
  $f = $lenfreq{$l};
  $c = $lencount{$l};
  print STDOUT sprintf ("%3d  %6d  %5d\n", $l, $f, $c);
  #print $l, ' ', $f, ' ', $c, "\n";
}

