#!/usr/bin/perl
# Takes the link summary file in which the type of link  is marked
# after the beginning of the link. Creates files with the name of the
# link type. 
# Example  of input file: (link type is put as 'conj')
#  <P>conj
#  <A NAME=CC href="section-CC.html"><STRONG>CC</STRONG></A>
#   connects clauses to following coordinating conjunctions ("SHE left
#          BUT we stayed").

$/ = '<P>';
$first = <>;  # Throw away the first starting '<P>'
$filecount = 0;
while (<>) {
  if (/^([^\n]*)\n/) {  # From the first line extract filename
    $rest = $'; chop($rest); chop($rest); chop($rest);
    $filename = $1;
    #print STDERR "DEB: Filename: $filename\n";
    if (!($file_found{$filename})) {  # Create the file, NOT already created.
      $file_found{$filename} = 1;
      $filehandle{$filename} = "FF$filecount";   $filecount++;
      $handle = $filehandle{$filename};
      open ($handle, ">$filename.tmp") ||
        die "Unable to open out file $filename.tmp: $!\n";
    }
    else {
      $handle = $filehandle{$filename};
       #if ($handle eq '') {
       #  print STDERR "Undefined filehandle: $handle\n";
       #}
    }
    print $handle  '<P>', "\n", $rest;
  }
  else { 
    print STDERR "link_type.pl: Invalid format. <P> not found: $_\n";
  }
}
