#!/usr/bin/perl
# Breaks each line into lines of specified length 
# (default 60). Break is put after a space.
#   Usage example: brcol.pl -45 -c~~ -f <infile >outfile
# Causes line to be around 45 cols long, put ~~ when line broken, -f
# forces line breakage after 45 or so even if white space 
# not found.
# Options:
#   -number	Specified line length. (Default: 60)
#   -cabc	String 'abc' will be put at the break point whenever a line is broken.
#   -f		Force line break even if no space found.
# cmd one to one.
require("/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/brcol.pl");
require ("/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/printusage.pl");


# Assumes that the args begin after the params. (Each param begins by -)
local ($i, $parmlastpos, $argbegpos, $forcesw, $brkmark, $lim);
$parmlastpos = -1; # Gives pos of last param in ARGV. Default no params.
$argbegpos = -1;  # Gives position of 1st argument in ARGV. Default no args
$lim = 60; # Default line length.
$brkmark = '';  # Default string to be put at the break point.
$forcesw = 0;    # Line not to be broken if space not found.
for ($i=0; $i <= $#ARGV; $i++) { # Extract the parameters and locate
                                 #  starting loc of command args.
  if (substr($ARGV[$i],0,1) eq '-') {  # A parameter found.
    $parmlastpos++;  # Change the following lines to suit your needs.
    if (substr($ARGV[$i],1,1) eq 'h') { # print help info.
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/brcol.cmd');
      die;
    }
    elsif (substr($ARGV[$i],1,1) eq 'f') { # force the break even if space not found.
      $forcesw = 1;
    }
    elsif (substr($ARGV[$i],1,1) eq 'c') { # put character indicating line breakage.
      $brkmark = substr ($ARGV[$i],2);
    }
    elsif ($ARGV[$i] =~ /-([0-9]+)/) { # Number of coloumns limit.
      $lim = $1;
    }
    else { print STDERR "Unrecognized param: $ARGV[$i]\n";
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/brcol.cmd');
      die;
    }
  }
  else { # Argument found. Parameters end.
    $argbegpos = $i;
    last;
  }
}
#print STDERR "DEB params end: $parmlastpos;  args begin: $argbegpos; total: $#ARGV;\n";

# Process the arguments in the command line then call breakcol.
# 1. Can be used as a filter. OR
# 2. file args can be given instead of filters.

if ($argbegpos < 0) { # No args.
  &breakcol(STDIN, STDOUT);
}
elsif (($#ARGV - $argbegpos) == 0) { # Only one arg given. Execute the command with arg and stdout.
  open (INFILE, "$ARGV[$argbegpos]") ||
     die "Unable to open file $ARGV[$argbegpos]\n" ;
  &breakcol(INFILE, STDOUT);
  close (INFILE);
}
elsif (($#ARGV - $argbegpos) == 1) { # Two args given. Execute the command with arg1 and arg2.
  open (INFILE, "$ARGV[$argbegpos]") ||
     die "Unable to open input file $ARGV[$argbegpos]\n" ;
  open (OUTFILE, ">$ARGV[$argbegpos + 1]") ||
     die "Unable to open output file $ARGV[$argbegpos + 1]\n" ;
  &breakcol(INFILE, OUTFILE);
  close (OUTFILE);
  close (INFILE);
}
else { print STDERR "Too many arguments.\n"; }

