#! /usr/bin/perl
# Calculator. 
print "Calculator Ver. 1.02. (Type h or ? for help.)\n";
print "Type expr: ";
$v1 = 0; $v2 = 0; $v3 = 0;
while (<>) {
  $e = $_;
  if (/^ *[qQ]$/) { last;}
  elsif (/^ *[hH\?]$/) {
    print "Evaluates arithmetic and algebraic expressions.\n",
          "Also available are following commands:\n";
    print "q \t\tQuits calc.\n",
          "s <file> \tSave last expr and value in <file>.\n",
          "a <file> \tAppend last expr and value to <file>.\n",
          "l <file> \tLoads exprs from <file> and evals.\n",
           "\! <syscmd>\tExecutes system command.\n",
          "h|\? \t\tProduces this.\n",
          "\$<var1>=\$<var2> Assigns \$<var1> to val of \$<var2>\n";
    print "   Built-in variables available:\n", "   \$v1 = prev result, \$v2 = result before \$v1, etc. till \$v3.\n   \$e1 = prev expr etc.\n";
  }
  elsif (/^ *[sS] *(.*)/) {
    open (FL, ">$1"); 
    $tmp = $e1; chop ($tmp); print FL "$tmp = $v1\n"; 
    close (FL);
    print "==> Saved.\n";
  }
  elsif (/^ *[aA] *(.*)/) { 
    open (FL, ">>$1"); 
    $tmp = $e1; chop ($tmp); print FL "$tmp = $v1\n"; 
    close (FL);
    print "==> Appended.\n";
  }
  elsif (/^ *[tT] *(.*)/) { system ("Type $1\n"); }
  elsif (/^ *[lL] *(.*)/) {
    open (LOAD, $1) || do { print "Unable to open file: $1\n"; next; };
    while ($fline = <LOAD>) { 
      print STDERR "Read line: $fline";
      $e = $fline; $v = eval $e; print "==> $v\n"; }
    close (LOAD);
  }
  elsif (/^ *\!/) { system ($'); }
  else {  # NOW THE MAIN PURPOSE OF WRITING CALC.
    $v = eval $e; print "==> ", $v, "\n";
    $v3 = $v2;
    $v2 = $v1;
    $v1 = $v;
    $e3 = $e2;
    $e2 = $e1;
    $e1 = $e;
  }
  print "Type expr: ";
}
1;
