#%date = ("Jan",31,"Feb,28); 
@monthname = (Jan,Feb,Mar,Apr,May,June,July,Aug,Sept,Oct,Nov,Dec);
@monthlen = (31,28,31,30,31,30,31,31,30,31,30,31);
%monthval = ("JAN",1,"FEB",2,"MAR",3,"APR",4,"MAY",5,"JUN",6, 
             "JUL",7,"AUG",8,"SEP",9,"OCT",10,"NOV",11,"DEC",12, 
             "JANUARY",1,"FEBRUARY",2,"MARCH",3,"APRIL",4,"MAY",5,"JUNE",6, 
             "JULY",7,"AUGUST",8,"SEPTEMBER",9,"OCTOBER",10,"NOVEMBER",11,"DECEMBER",12, 
             "SEPT", 9);
# datechk takes day, month, year as its args and checks that it is 
#  a valid date. It also checks for correct no of days in Feb.
sub datechk {
  local ($day, $month, $year) = @_;
  # print @_,"\n";
  if ($year < 100) { # standardize year to four digits.
    $year += 1900; 
    $_[2] = $year;
  } 
  # To standardize month name to number.
  if ($month =~ /[a-z]/i) {
    $month =~ tr/a-z/A-Z/;
    $month = $monthval {$month};
    $_[1] = $month;
  }
  if (($month <= 12) && ($month > 0)) {
    if ($month != 2) {
      $length = $monthlen[$month - 1];
      if ($day > $length) {
        print STDERR "Day $day in month $month exceeds permissible range.\n";
        return (1);
      }
      elsif ($day < 1) {
        print STDERR "Day $day in month $month is less than one.\n";
        return (1);
      }
    }  
    else { #month = 2 (Feb)
      if (($year % 400 == 0) || (($year % 100 != 0) && ($year % 4 == 0))){
        $feblen = 29;
      }
      else { $feblen = 28; }
      if ($day > $feblen) {
        print STDERR "Day $day in month $month exceeds permissible range.\n";
        return (1);
      }
      elsif ($day < 1) {
        print STDERR "Day $day in month $month is less than one.\n";
        return (1);
      }
    }
  }
  else { print STDERR "Month $month is out of range.\n";  
        return (1); }
  return (0);
}
1;       
  
