#!/usr/bin/perl
# Takes as its input the output of dir command in dos and filters
# those lines which have a date later than the given date.
#   Example usage: datedir.cmd  -dDATE <list.dir  >list2.dir

# cmd assumes many to one.
require("/nisha/perl/datedir.pl");
require ("/tools/src/etc/printusage.pl");

open (STDERR, ">error.tmp") ||
  print "Unable to open output file error.tmp.\n";
# Assumes that the args begin after the params. (Each param begins by -)
local ($i, $parmlastpos, $argbegpos, $arg, $outf, $argsinfile);
$parmlastpos = -1; # Gives pos of last param in ARGV. Default no params.
$argbegpos = -1;  # Gives position of 1st argument in ARGV. Default no args
$argsinfile = 0;  # Default args file names are not in a file.
for ($i=0; $i <= $#ARGV; $i++) { # Extract the parameters and locate
                                 #  starting loc of command args.
  if (substr($ARGV[$i],0,1) eq '-') {  # A parameter found.
    $parmlastpos++;  # Change the following lines to suit your needs.
    if (substr($ARGV[$i],1,1) eq 'h') { # print help info.
      &printusage ('/nisha/perl/datedir.cmd');
      die;
    }
    elsif (substr($ARGV[$i],1,1) eq 'o') { # Specifies output file.
      $outfilename = substr ($ARGV[$i],2);
    }
    elsif (substr($ARGV[$i],1,1) eq 'd') { # Specifies output file.
      $givendate = substr ($ARGV[$i],2);
    }
    else { print STDERR "Unrecognized param: $ARGV[$i]. Ignoring.\n";
      &printusage ('/nisha/perl/datedir.cmd');
    }
     ##if (substr($ARGV[$i],1,1) eq 'd') { # type of param is d, get val
     ##  $dval = substr ($ARGV[$i],2);
     ##}
     ##elsif (substr($ARGV[$i],1,1) eq 'n') { # set switch n to true.
     ##  $nswitch = 1;
     ##}
  }
  else { # Argument found. Parameters end.
    if (substr($ARGV[$i],0,1) eq '@') {  # A file of args found
      $argsinfile = 1;
      $ARGV[$i] = substr($ARGV[$i], 1);
    }
    $argbegpos = $i;
    last;
  }
}
#print STDERR "DEB params end: $parmlastpos;  args begin: $argbegpos; total: $#ARGV;\n";

# Process the arguments in the command line then call datedir.
# 1. Can be used as a filter. OR
# 2. If arg file names are given, they are treated as input files
#    and the output goes to a single file stdout.

if ($outfilename ne '') {
  open (OUT, ">$outfilename") ||
    die "Unable to open output file $outfilename.\n";
  $outf = OUT;
}
else { $outf = STDOUT; }

if ($argbegpos < 0) { # No args.
  &datedir(STDIN, $outf);
}
elsif ($argsinfile) {  # Args in file.
  open (ARGFILE, "$ARGV[$argbegpos]") ||
    die "Unable to open args file $ARGV[$argbegpos]\n" ;
  while (<ARGFILE>) { # Read args.
    chop;
    if (!(open (INFILE, $_))) {
      print STDERR "Unable to open file $_\n" ;
      next;
    }
    &datedir (INFILE, $outfile);
    close (INFILE);
  }
  close (ARGFILE);
}
else { # Call the program with each arg. 
  for ($arg = $argbegpos; $arg <= $#ARGV; $arg++) {
    if (!(open (INFILE, "$ARGV[$arg]"))) {
      print STDERR "Unable to open file $ARGV[$arg]. Continuing.\n" ;
      next;
    }
    &datedir (INFILE, $outf);
    close (INFILE);
  }
}

