#!/usr/bin/perl
#%COMMENT
# Takes a field name and a keyword and retrieves records
# from the database which satisfy the field name and keyword.
#   Example: db_find.cmd -fFLDNAMES -kKEYWRDS -nDBNAME > my.id
# The above retrieves record IDs which have the field names
# called FLDNAMES, keywords KEYWRDS in the database 
# which has the name DBNAME.
#%CMD TYPE 11

$fld_list = 'head source';  # List of field names which will be searched. #OPT -f
$keywords = '';  # List of keywords which will be searched in the fields. #OPT -k
$db_name = 'my'; # Database name using which file names are constructed (e.g. 'prvrb.db' name is constructed if given 'prvrb'). (Default: 'my') #OPT -n

$fld_end = '{'; # End of field marker. Default: '{'  #OPT  -F
$val_end = '}'; # End marker for value of a field. Default: '}' #OPT  -V
$rec_end = "@\n"; # End of record marker. Default: "@\n" #OPT  -R


@flds = split (/\s+/, $fld_list);
foreach $f (@flds) {
   #print STDERR "DEBUG:field=$f,\n";
  $ndx_filename = $db_name . '_' . $f . '.ndx';
  @keys = split (/\s+/, $keywords);
  foreach $ky (@keys) {
     #print STDERR "keyword=$ky,\n";  # DEBUG
     #print STDERR "Issuing...  grep $ky $ndx_filename\n";
    $res = `grep $ky $ndx_filename`;
    ($w, $rem) = split (/\s+/, $res, 2);
    if ($rem ne '') { print $rem;}
  }
   #print STDERR "\n";  # DEBUG
}
