#!/usr/bin/perl
# Removes those lines from the input file which contain any of
# the patterns contained in exclude.rc. (One pattern per line.)
#   Example usage:  exclude.pl  < anu1.files   > anu1.fls
# Exampe exclude.rc file:
#  #  Filenames with the following patterns to be excluded.
#  # '$' indicates end of line. (A '#' as the first non-white space
#  # character in the exclude.rc file indicates a comment.)
# old/
# .old$
# tmp/
# .tmp$
# ARCH/
# /bin/
# Options:
# -f	-  Name of the rc file. 
require("/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/printusage.pl");

# Assumes that the args begin after the params. (Each param begins by -)
local ($i, $parmlastpos, $argbegpos, $Finname, $Foutname);
local ($rcfile);
$parmlastpos = -1; # Gives pos of last param in ARGV. Default no params.
$argbegpos = -1;  # Gives position of 1st argument in ARGV. Default no args
$rcfile = 'exclude.rc'; # Default  Name of the rc file. 

# Look up .excluderc file. Override defaults.
if (open (RC, '.excluderc')) {
  while (<RC>) {
    chop;
    if (/\s*#/) {  next; }   # Ignore. A comment line.
    if (/\s*-/) {  # A parameter found.
      $_ = '-' . $';
      if (substr($_,1,1) eq 'h') { # print help info.
        &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/exclude.cmd');
        die;
      }
      elsif (substr($_,1, 1) eq  'f') {
        $rcfile = substr ($_, 2);
      }
      else { 
          print STDERR "exclude.cmd: Unrecognized param in rc file: $_.\n";
          &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/exclude.cmd');
          die;
      }
    }
    else { # 
      print STDERR "exclude.cmd: Param must begin with '-' in rc file: $_. Ignoring.\n";
    }
  }
  close (RC);
}

for ($i=0; $i <= $#ARGV; $i++) { # Extract the parameters and locate
                                 #  starting loc of command args.
     # Command line args override those of the rc file.
  if (substr($ARGV[$i],0,1) eq '-') {  # A parameter found.
    $parmlastpos++;  # Change the following lines to suit your needs.
    if (substr($ARGV[$i],1,1) eq 'h') { # print help info.
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/exclude.cmd');
      die;
    }
    elsif (substr($ARGV[$i],1, 1) eq  'f') {
      $rcfile = substr ($ARGV[$i], 2);
    }
    else { 
        print STDERR "exclude.cmd: Unrecognized param: $ARGV[$i].\n";
        &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/exclude.cmd');
        die;
    }
  }
  else { # Argument found. Parameters end.
    $argbegpos = $i;
    last;
  }
}

# Process the arguments in the command line then call exclude.
# 1. Can be used as a filter. OR
# 2. file args can be given instead of filters.

if ($argbegpos < 0) { # No args.
  &exclude(STDIN, STDOUT);
}
elsif (($#ARGV - $argbegpos) == 0) { # Only one arg given. Execute the command with arg and stdout.
  open (INFILE, "$ARGV[$argbegpos]") ||
     die "exclude.cmd: Unable to open file $ARGV[$argbegpos]\n" ;
  $Finname = $ARGV[$argbegpos];  $Foutname = '';
  &exclude(INFILE, STDOUT);
  close (INFILE);
}
elsif (($#ARGV - $argbegpos) == 1) { # Two args given. Execute the command with arg1 and arg2.
  open (INFILE, "$ARGV[$argbegpos]") ||
     die "exclude.cmd: Unable to open input file $ARGV[$argbegpos]\n" ;
  open (OUTFILE, ">$ARGV[$argbegpos + 1]") ||
     die "exclude.cmd: Unable to open output file $ARGV[$argbegpos + 1]\n" ;
  $Finname = $ARGV[$argbegpos];  $Foutname = $ARGV[$argbegpos+1];  
  &exclude(INFILE, OUTFILE);
  close (OUTFILE);
  close (INFILE);
}
else { print STDERR "exclude.cmd: Too many arguments.\n"; }
#------------------------------------------------------

sub exclude {
local ($W_fin, $W_fout) = @_;
select($W_fout);
#%COMMENT
# Removes those lines from the input file which contain any of
# the patterns contained in exclude.rc. (One pattern per line.)
#   Example usage:  exclude.pl  < anu1.files   > anu1.fls
# Exampe exclude.rc file:
#  #  Filenames with the following patterns to be excluded.
#  # '$' indicates end of line. (A '#' as the first non-white space
#  # character in the exclude.rc file indicates a comment.)
# old/
# .old$
# tmp/
# .tmp$
# ARCH/
# /bin/
#%CMD TYPE 11


open (EXCL, "$rcfile") ||
  die "Unable to open $rcfile.\n";
$i = -1;
while (<EXCL>) {  # Read the patterns into @item array.
  if (/\s*#/)  { next; }  # rc file contains a comment.
  $i++;
  chop;
  $item[$i] = $_;
}
close EXCL;

INPLINE: while (<$W_fin>) { # Read the input file
  for ($i=0; $i <= $#item;  $i++)  {
    if (/$item[$i]/) { next INPLINE; }
  }
  print;
}
}
1;
