#!/usr/bin/perl
#%COMMENT
# Removes those lines from the input file which contain any of
# the patterns contained in exclude.rc. (One pattern per line.)
#   Example usage:  exclude.pl  < anu1.files   > anu1.fls
# Exampe exclude.rc file:
#  #  Filenames with the following patterns to be excluded.
#  # '$' indicates end of line. (A '#' as the first non-white space
#  # character in the exclude.rc file indicates a comment.)
# old/
# .old$
# tmp/
# .tmp$
# ARCH/
# /bin/
#%CMD TYPE 11

$rcfile = 'exclude.rc'; # Name of the rc file. #OPT -f

open (EXCL, "$rcfile") || die "Unable to open $rcfile.\n";
$i = -1;
while (<EXCL>) {  # Read the patterns into @item array.
  if (/\s*#/)  { next; }  # rc file contains a comment.
  if (/^\s*$/)  { next; }  # rc file contains an empty line
  $i++;
  chop;
  $item[$i] = $_;
}
close EXCL;

#print STDERR "exclude.pl:DEBUG: Items=$#item, Given below:\n";
#foreach $it (@item) { print $it, "\n"; }    # DEBUG

INPLINE: while (<>) { # Read the input file
  #print STDERR "exclude.pl:DEBUG:Line read:$_";
  for ($i=0; $i <= $#item;  $i++)  {
    if (/$item[$i]/) { next INPLINE; }
  }
  print;
}
