# Called by fmtrec.cmd. Used for creating a new record.
# $fldnamefile	Contains the names of the fields each in a new line.
# $dlimtrout	Contains the delimiter for fields in the output file.
# $rlimtrout	Contains the delimiter for records in the output file.
# $noreclimtr	Flag to say that no input record delimiter is used. Use
#		counting of fields to determine record boundary.
# $yesreclimout	Flag to say that output record delimiter should be used
#		even when $noreclimtr flag is set.
# $Id$
sub fmtnewrec {
  local ($fin, $fout) = @_;
  local ($oldlimtr, $eachfld, $eachval, $fnum, $dout, $rout, $i, $tf, $tv);
  # print STDERR "FieldNameFile:$fldnamefile,  FieldDelimter:$dlimtr,  RecDelimiter:$rlimtr.\n";
   # First read the field names of the record.
  open (FLDS, $fldnamefile) ||
    die "fmtrec.pl: Unable to open file containing field names: $fldnamefile.\n";
  $oldlimtr = $/;
  $/ = '%#adfh5$67';  # To read the entire file of fieldnames.
  $_ = <FLDS>;
  @fields = split (/\n/);
  close (FLDS);

  for ($i=0; $i < $#fields; $i++) {
    print $fout $fields[$i], ': ', $dlimtrout;
  }
  print $fout $fields[$#fields], ': ';
  if ((!($noreclimtr)) || ($yesreclimout)) { 
    # Record dlimtrs are present or rec dlimter flag inthe output is yes
    print $fout $rlimtrout;
  }
  else { # There is no record delimiter.
    print $fout $dlimtrout;
  }
  $/ = $oldlimtr;
}
1;
