# Called by fmtrec.cmd when user has given command option -no.
# Removes field names from the input file.
# $fldnamefile contains the names of the fields each in a new line.
# $dlimtr   contains the delimiter for fields in the input file.
# $rlimtr   contains the delimiter for records in the input file.
# $dlimtrout   contains the delimiter for fields in the output file.
# $rlimtrout   contains the delimiter for records in the output file.
# $Id: fmtrecnof.pl,v 1.1 1996/05/11 14:28:32 sangal Exp $

sub fmtrecnof {
  local ($fin, $fout) = @_;
  local ($oldlimtr, $eachfld, $eachval, $dout, $rout, $i);
  # print STDERR "FieldNameFile:$fldnamefile,  FieldDelimter:$dlimtr,  RecDelimiter:$rlimtr.\n";
   # First read the field names of the record.
  open (FLDS, $fldnamefile) ||
    die "fmtrec.pl: Unable to open file containing field names: $fldnamefile.\n";
  $oldlimtr = $/;
  $/ = '%#adfh5$67';  # To read the entire file of fieldnames.
  $_ = <FLDS>;
  @fields = split (/\n/);
  close (FLDS);

  $/ = $rlimtr;
  while (<$fin>) {
    for ($i=1; $i <= length($/); $i++) { chop; }   # Remove the delimiter.
    @vals = split (/$dlimtr/);
    if ($#fields != $#vals) {
      print STDERR "fmtrec.pl: Mismatch in number of fields $#fields and number of values $#vals for record $_. Ignoring.\n";
    }
    # print STDERR "fmtrec.pl debug: $#fields fields are @fields\n $#vals values are @vals\n";
    for ($i=0; $i <= $#fields; $i++) {
      ($fld, $v) = split (/:\s*/, $vals[$i]);
      if ($fields[$i] ne $fld) {
        print STDERR "fmtrecnof.pl: Field name in input file does not match with specified one:$fields[$i]: =!= $fld\n";
      }
      if ($i < $#fields) { print $fout $v, $dlimtrout; }
      else { print $fout $v; }
    }
    print $fout $rlimtrout;
  }
  $/ = $oldlimtr;
}
1;
