# Called by fmtrec.cmd when user has given command option -part (for partial).
# This signifies that only some of the fields in the record have been
# given values in the input file. Fields with nil values are not mentioned.
# $fldnamefile	Filename containing the names of the fields each in a new line.
# $dlimtr	the delimiter for fields in the input file.
# $rlimtr	the delimiter for records in the input file.
# $dlimtrout	the delimiter for fields in the output file.
# $rlimtrout	the delimiter for records in the output file.
# $yesreclimout	Flag to say that output record delimiter should be used
#		even when $noreclimtr flag is set.
# $newrec	New record is to be input. Print field names. (Not used here.)

sub fmtrecsel {
  local ($fin, $fout) = @_;
  local (@fields, %fieldloc, @pairs, @vals);
  local ($oldlimtr, $eachfld, $eachval, $dout, $rout, $i);
  # print STDERR "DEBUG: FieldNameFile:$fldnamefile, Partial: $part\n",
                       "flddelim--$dlimtr--, recdelim--$rlimtr--\n";
  # First read the field names of the record.
  open (FLDS, $fldnamefile) ||
    die "fmtrpart.pl: Unable to open file containing field names: $fldnamefile.\n";
  $oldlimtr = $/;
  $/ = '%#adfh5$67';  # To read the entire file of fieldnames.
  $_ = <FLDS>;
  @fields = split (/\n/);
  for ($i=0;  $i <= $#fields;  $i++) {
    $fieldloc{$fields[$i]} = $i;  # This is for fast lookup from
                                  # field name to field location.
  }
  close (FLDS);

  $/ = $rlimtr;  # record delimiter must be present (for records
                 #  with partial fields)
  $oldcity = '';
  while (<$fin>) {  # Read a record.
    # print STDERR "fmtrpart.pl DEB: Record is ---$_---\n";
    for ($i=1; $i <= length($/); $i++) { chop; }   # Remove the record delimiter.
    @pairs = split (/$dlimtr/);
    # print STDERR "fmtrpart.pl debug: $#fields fields are @fields\n $#pairs pairs are @pairs\n";
    for ($i=0;  $i <= $#fields;  $i++) { $vals[$i] = ''; } # Initialize to nil.
    for ($i=0; $i <= $#pairs; $i++) { # Store each field val approp.
      if ($pairs[$i] =~ /:\s*/) {  $fld = $`;  $v = $'; }
      else { print STDERR 
              "fmtrpart.pl: Separator between field name and value not found. $pairs[$i]\n";
              next;
      }
         # ($fld, $v) = split (/:\s*/, $pairs[$i]);
      if (($fieldloc{$fld} < 0) || ($fieldloc{$fld} > $#fields)) {
        print STDERR "fmtrpart.pl: Invalid field name $fld in input file.\n";
      }
      else {
        $vals[$fieldloc{$fld}] = $v;
      }
    }
    #-------------- NISHA: to add -----------------------------
    # At this point the fields and values have been read for a record
    # from the input file. You can print the values in the desired format
    # by writing PERL code. (This is inside while loop, therefore, the
    # opertion will be repeated for every reoced in the input file.)
    # NOTE:
    # Field names are in: $fields[1], ... $fields[$#fields]
    # Values are in     : $vals[1], ....  $vals[$#vals]
    #-----------------------------------------------------------

    # ----- Begin adding here ------------
    $deb = 0;
    $city = $vals[$fieldloc {'CITY'}];
    if ($city ne $oldcity) {
      $std = $vals[$fieldloc {'STDCODE'}];
      print ":-------- $city 0$std--------\n"; }
    $oldcity = $city;  
    $lname = $vals[$fieldloc {'LNAME'}];
    $fname = $vals[$fieldloc {'FNAME'}];
    $orgkey = $vals[$fieldloc {'ORGKEY'}];
    if (($lname eq '') && ($fname eq '') && ($orgkey ne '')) {
      print "$orgkey\n"; }
    elsif (($lname eq '') && ($fname ne '')) { 
      print "$fname   $orgkey\n"; }
    elsif (($lname ne '') && ($fname eq '')) {
      print "$lname   $orgkey\n"; }
    else { 
      print "$lname, $fname   $orgkey\n"; } 
    $org = $vals[$fieldloc {'ORG'}];
     if ($org ne '') { print "$org\n"; }
    $add1 = $vals[$fieldloc {'ADDR1'}];
     if ($add1 ne '') { print "$add1\n"; }
    $add2 = $vals[$fieldloc {'ADDR2'}];
     if ($add2 ne '') { print "$add2\n"; }
    $pin = $vals[$fieldloc {'PIN'}];
     if ($pin ne '') { print "$city	$pin\n"; }
     else { print "$city\n";}
    $teloff = $vals[$fieldloc {'TELOFF'}];
    $telhome = $vals[$fieldloc {'TELHOME'}];
    if (($teloff ne '') || ($telhome ne '')) {
      print "tel: $teloff  H: $telhome\n"; }
    else { print "tel:\n"; }
    $fax = $vals[$fieldloc {'FAX'}];
      if ($fax ne '') { print "fax: $fax\n";}
    $email = $vals[$fieldloc {'E-MAIL'}];
      if ($email ne '') {print "$email\n";}
    $ovf = $vals[$fieldloc {'OVF'}];
     if ($ovf ne '') { print "$ovf\n"; }
    $rem1 = $vals[$fieldloc {'REM1'}];
     if ($rem1 ne '') { print "$rem1\n"; }
    $rem2 = $vals[$fieldloc {'REM2'}];
     if ($rem2 ne '') { print "$rem2\n"; }
     print "\n";
    # for ($i=0; $i <= $#fields; $i++) { # Output the entire record with all field names and values.
    #   if ($i < $#fields) { print $fout $fields[$i], ':', $vals[$i], $dlimtrout; }
    #   else { print $fout $fields[$i], ':', $vals[$i]; }
    # }
    # print $fout $rlimtrout;
  }
  $/ = $oldlimtr;
}
1;
