#! /usr/bin/perl
# Takes as its input the output created by 'du'.
# Gives the sum of the size of the directories that occur with
# './dirname'. This is necessary so as not to count the files twice.
# If the first argument is given, it specifies a pattern that must
# occur in the './dirname'.
# If an arg is '-p' causes the size and names of './dirname' to be printed.
# Usage: fsizedu.pl -p "sangal" <wc.sum
$sz = 0;  $prinsw = 0; $pat = '';
for ($i=0; $i <= $#ARGV; $i++) {
  if ($ARGV[$i] eq '-p') { $prinsw = 1; }
  else { $pat = $ARGV[$i]; }
}
while (<STDIN>) {
  if (/^\s+/) { $_ = $'; }  # Remove opening space.
  if (/\s+$/) { $_ = $`; }  # Remove ending space.
  @line = split (/\s+/, $_);
  if ($pat ne '') {
    if ($line[1] =~ /$pat/) {  # Count only if given pattern found.
      if ($line[1] =~ /\.\/\w+$/) { # Count only single dir: ./NAME
        $sz += $line[0];
        if ($prinsw) { print "$_\n"; }
      }
    }
  }
  else {
      if ($line[1] =~ /\.\/\w+$/) { # Count only single dir: ./NAME
        $sz += $line[0];
        if ($prinsw) { print "$_\n"; }
      }
  }
}
$sz *= 1000;
print "$sz bytes     total $ARGV[0]\n";

