#! /usr/bin/perl
# Totals the size of files given the output of 'ls -l' command.
# If the first argument is given, it specifies a pattern that must
# occur in the file name.
# Usage: fsizels.pl  "floppy9" <wc.sum

$fsize = 0;
while (<STDIN>) {
  if (/^\s+/) { $_ = $'; }  # Remove opening space.
  if (/\s+$/) { $_ = $`; }  # Remove ending space.
  @all = split(/\s+/);
  # print STDERR "DEB: $all[0]  $all[4]\n";
  #if (substr($all[0], 0, 1) eq '-') { # To check that the info is for a file, not directory.
  #}
  if ($#ARGV >= 0) {
    if ($all[8] =~ /$ARGV[0]/) {  # Count only if given pattern found.
      $fsize += $all[4];
    }
  }
  else {
    $fsize += $all[4];
  }
}
print "$fsize bytes     total $ARGV[0]\n";

