#! /usr/bin/perl
# Takes as its input the output created by tar tv.
# Gives the sum of the size of the files.
# If the first argument is given, it specifies a pattern that must
# occur in the file name.
# Usage: fsizetar.pl  "floppy9" <wc.sum
$sz = 0;
while (<STDIN>) {
  if (/^\s+/) { $_ = $'; }  # Remove opening space.
  if (/\s+$/) { $_ = $`; }  # Remove ending space.
  @line = split (/\s+/, $_);
  if ($#ARGV >= 0) {
    if ($line[7] =~ /$ARGV[0]/) {  # Count only if given pattern found.
      $sz += $line[2];
    }
  }
  else {
    $sz += $line[2];
  }
}
print "Size =  $sz bytes \n";

