#!/usr/bin/perl
#%COMMENT
# Copies those lines from input to output that contain patterns in include.rc
#   Example usage:  include.pl < INPUT   > OUTPUT
# Filenames with the following patterns to be included.
# '$' indicates end of line. (A '#' as the first non-white space char
# in the include.rc file indicates a comment like these lines.)
#   /anusAraka/
#   /new_anusAraka/
#%CMD TYPE 11

$rcfile = 'include.rc'; # Name of the rc file. #OPT -f


open (INCL, "$rcfile") ||
  die "Unable to open $rcfile.\n";
$i = -1;
while (<INCL>) {  # Read the patterns into @item array.
  if (/\s*#/)  { next; }  # rc file contains a comment.
  $i++;
  chop;
  $item[$i] = $_;
}
close INCL;

INPLINE: while (<>) { # Read the input file
  for ($i=0; $i <= $#item;  $i++)  {
    if (/$item[$i]/) { print; }
  }
}
