#! /usr/bin/perl
# Takes the output of 'ls -l' command. For those files which
# are symbolic links to other files, generates and excutes 'ln' commands
# to create the same links. (This is useful during porting, when
# pathnames of existing links have to be changed.)
#   Example usage: ls -l | ls2ln.pl  

while (<>) {
  @all = split(/\s+/);
  #print STDERR "ls2ln.pl debug: $all[8]  $all[10]\n";
  if (substr($all[0], 0, 1) eq 'l') { # This is a symbolic link.
    if ($#all == 10) { 
      print STDERR "Creating... ln -s $all[10]  $all[8]\n";
      system ("ln -s $all[10]  $all[8]");
    }
    else { print STDERR "Invalid line for a link entry:$_"; }
  }
}

