#!/usr/bin/perl
# Removes those lines from the input file which contain any of
# the patterns contained in exclude.rc. (One pattern per line.)
#   Example usage:  exclude.pl  < anu1.files   > anu1.fls
# Exampe exclude.rc file:
#  #  Filenames with the following patterns to be excluded.
#  # '$' indicates end of line. (A '#' as the first non-white space
#  # character in the exclude.rc file indicates a comment.)
# old/
# .old$
# tmp/
# .tmp$
# ARCH/
# /bin/

open (EXCL, "exclude.rc") ||
  die "Unable to open exclude.rc.\n";
$i = -1;
while (<EXCL>) {  # Read the patterns into @item array.
  if (/\s*#/)  { next; }  # rc file contains a comment.
  $i++;
  chop;
  $item[$i] = $_;
}
close EXCL;

INPLINE: while (<>) { # Read the input file
  for ($i=0; $i <= $#item;  $i++)  {
    if (/$item[$i]/) { next INPLINE; }
  }
  print;
}
