#! /usr/bin/perl
# Takes one line from one file, the next line from the second file,
# and so on, and writes into a new file.
#   Example usage: thread.cmd  -1'< '  -2'> ' FILE1  FILE2 > file.tmp
# OPTIONS:
#   -1STRING 	STRING will be prefixed to each line output of 1st file
#   -2STRING 	STRING will be prefixed to each line output of 2nd file

$first = $second = '';  # Prefix string to be put before each line of 
                        # first or second file
if (substr($ARGV[0], 0, 1) eq '-') {  # It is an option for prefix string
  if (substr($ARGV[0], 1, 1) eq '1') {  # put chars before lines of first file.
    $first = substr($ARGV[0], 2);
  }
  elsif (substr($ARGV[0], 1, 1) eq '2') {  # put chars before lines of  second file.
    $second = substr($ARGV[0], 2);
  }
  else { print STDERR "thread.pl: Illegal option: $ARGV[0]\n"; }
  if (substr($ARGV[1], 0, 1) eq '-') {  # It is an option for prefix string
    if (substr($ARGV[1], 1, 1) eq '1') {  # put chars before lines of first file.
      $first = substr($ARGV[1], 2);
    }
    elsif (substr($ARGV[1], 1, 1) eq '2') {  # put chars before lines of  second file.
      $second = substr($ARGV[1], 2);
    }
    else { print STDERR "thread.pl: Illegal option: $ARGV[1]\n"; }
    $file1 = $ARGV[2];   $file2 = $ARGV[3];
  }
  else { $file1 = $ARGV[1];   $file2 = $ARGV[2]; }
}
else { $file1 = $ARGV[0]; $file2 = $ARGV[1]; }
  
  

open(INA, "$file1") || die "Unable to open file $file1.\n";
open(INB, "$file2") || die "Unable to open file $file2.\n";
while (<INA>) {
  print   $first, $_;
  if ($buf2 = <INB>) {
    print $second, $buf2;
  }
  else { next; }
}
close (INA);
close (INB);

