#!/usr/bin/perl
#%COMMENT
# Takes a file of record numbers and retrieves the records from
# the database of records specified by  -d parameter (default: 'my').
#   Example usage: db_get.pl   < my.in  > my.out
#   Example usage: db_get.cmd  < my.in  > my.out
#%CMD TYPE 11

$db_file = ''; # Filename in which records are stored after giving ID numbers. (Defaut: 'my.db') #OPT -d
$db_name = 'my'; # Database name using which file names are constructed (e.g. 'prvrb.db' name is constructed if given 'prvrb'). (Default: 'my') #OPT -n
$fld_end = '{'; # End of field marker.  #OPT  -F
$val_end = '}'; # End of val marker for value of a field.  #OPT  -V
$rec_end = "@\n"; # End of record marker.  #OPT  -R
#$fld_names_file = '.myrc'; # Name of file containing field names which are to be indexed. #O_PT -f
#$fld_list = 'key_words head source';  # List of field names which will be indexed on. #O_PT -i

if ($db_file eq '') { 
  if ($db_name ne '') {$db_file = $db_name . '.db';}
}
open (DB, "$db_file") || die "Unable to open file $db_file:$!\n";

#@words = split (/[\",:;'`\\\/\?><\]\[}{\)\(\-_ \n\r\t=!\@\#%&\$\|\*\+\.\xea0-9]+/);  # Not using: ~
$punct =         '[\",:;\'`\\\/\?><\]\[}{\)\(\-_ \n\r\t=!\@\#%&\$\|\*\+\.\xea0-9]';  # No: ~

$old_eol = $/;
$/ = "\n@\n";
$rec_cnt = 0;
while (<>) {
  for ($i=1; $i <= length($rec_end); $i++) { chop; }
     # chop; chop; # Remove trailing "@\n" #if (/@/) { #  print STDERR "db_ndx.pl: Continuing though spurious '\@' found in:$_"; #} 
  if (/^\s*$/) {   # White space only.
    print STDERR "db_ndx.pl: Empty record found ID=$rec_cnt: $_\n";
    next; 
  }
  $rec_cnt++;
  print DB "ID{$rec_cnt}\n";   #print DB $_, '@', "\n";  # Below print only those fields which got processed.
  @field_values = split (/$val_end/);
   #for ($k=0;  $k <= $#field_values;  $k++) { #$field_value = $field_values[$k];
  foreach $field_value (@field_values) {
    if ($field_value =~ /^\s+/) { $field_value = $'; }
    if ($field_value =~ /\s+$/) { $field_value = $`; }
    @fld_val = split (/\s*$fld_end\s*/, $field_value);
    if ($#fld_val > 1) { # if $#fld_val == 0 then OK. val is nil.
      print STDERR "  db_ndx.pl: Ignoring. Unexpected field end '$fld_end' found in ID=$rec_cnt:$field_value\n";
      foreach $item (@fld_val) { print STDERR "   item=$item\n"; } #DEBUG
    }
    $fld  = $fld_val[0];
     #print STDERR "DEBUG: Field found in recID=$rec_cnt:$fld,\n";
    if ($fld =~ /\s/) { 
      print STDERR 'db_ndx.pl: Ignoring unusual field name ',
                   "in recID=$rec_cnt (with white space): $fld,\n";
      #print DB 'db_ndx.pl:DEBUG: Unusual field name in recID:', 
      #          $rec_cnt, ':', $fld, "\n";
      next;
    }
    $val = $fld_val[1];
    if (($fld eq '') && ($val eq '')) {  next; }
    if (($fld_list eq '*') || ($fld_list =~ /$fld/)) { #build ndx on words for specified fields
      @words = split (/$punct+/, $val);
          #@words = split (/[\s,\.;\?\!:]/, $val); # simpler punct.
      foreach $w (@words) {
        print $fld, ' : ', $w, '  ', $rec_cnt, "\n";
      }
    }
    if ($fld eq '') { print STDERR "db_ndx.pl: empty field in recID=$rec_cnt: $fld\n"; }
    print DB $fld, '{', $val, '}', "\n";
  }
  print DB '@', "\n";
}
close DB;
