#!/usr/bin/perl
# Count words in dict 
# which satisfy a paradigm for a cat and ending vowel.

@vowels = ('a','A','i','I','u','U','e','E','o','O','M');
while (<>) {
  if (/^"([^"]+)","([^"]+)","([^"]+)","([^"]+)","([^"]+)"$/) {
    $head_wrd = $1;    $target_wrd = $4;
    $pdm_type = $2;    $cat = $3;
    if ($pdm_type eq 'UNKN') { next; }
    $found = 0;
    if ($head_wrd =~ /(.)$/) {
      $last_char = $1;
      $key = $cat . '_' . $last_char ;
      if ($pdm_for_ending{$key} eq '') { # New pdm for this cat-ending
        $pdm_for_ending{$key} = $pdm_type;
      }
      elsif ($pdm_for_ending{$key} ne $pdm_type) { 
        print "$pdm_for_ending{$key} + $pdm_type :$_";
         #$pdm_for_ending{$key} = $pdm_type;
        if (!($oth_pdm_for_ending{$key} =~ /$pdm_type/)) {
          $oth_pdm_for_ending{$key} .= $pdm_type . ' ';
        }
      }
      $key2 = $key . '_' . $pdm_type;  # Increment count for this entry
      $cnt_for_ending_pdm{$key2}++;
      $found = 1;
    }
    if ($found == 0) { 
      print STDERR "No char in head word $head_wrd: $_";
    }
  }
  else { print STDERR "Invalid format for line $.:$_"; }
}

# Format for count output
format CNTFORMAT =
@<<<<<<<<<<<<<<  @<<<<<<<<<<<
$k,    $v
.
$~ = "CNTFORMAT";   # Format to be used with 'write'

print "---Paradigms are:\n";

while ( ($k, $v) = each(%pdm_for_ending)) {
  print "$k\t$v";
  if ($oth_pdm_for_ending{$k}) {
    print "    OTHERS: $oth_pdm_for_ending{$k}";
  }
  print "\n";
}

print "---Paradigms counts:\n";
while ( ($k, $v) = each(%cnt_for_ending_pdm)) { write; }
#while ( ($k, $v) = each(%cnt_for_ending_pdm)) { print "$k\t$v\n"; }

