#!/usr/bin/perl
# Find paradigms which are different for the same ending

@vowels = ('a','A','i','I','u','U','e','E','o','O','M');
while (<>) {
  if (/^"([^"]+)","([^"]+)","([^"]+)","([^"]+)","([^"]+)"$/) {
    $head_wrd = $1;    $target_wrd = $4;
    $pdm_type = $2;    $cat = $3;
    if ($pdm_type eq 'UNKN') { next; }
    $found = 0;
    if ($head_wrd =~ /(.)$/) {
       $last_char = $1;
       $key = $cat . '_' . $last_char ;
       if ($pdm_type_ending{$key} eq '') {
         $pdm_type_ending{$key} = $pdm_type;
       }
       elsif ($pdm_type_ending{$key} ne $pdm_type) { 
         #print "$pdm_type_ending{$key} + $pdm_type :$_"; # Removed.
         #$pdm_type_ending{$key} = $pdm_type;
         if (!($pdm_type_ending_others{$key} =~ /$pdm_type/)) {
           $pdm_type_ending_others{$key} .= $pdm_type . ' ';
         }
       }
       $found = 1;
    }
    if ($found == 0) { print STDERR "find_pdgm.pl: Nil head word: $_"; }
  }
  else { print STDERR "find_pdgm.pl: Invalid format for line $.:$_"; }
}

#print "---Paradigms are:\n"; # Removed.

while ( ($k, $v) = each(%pdm_type_ending)) {
  print "$k\t$v";
  if ($pdm_type_ending_others{$k}) {
    print " OTHERS: $pdm_type_ending_others{$k}";
  }
  print "\n";
}

