#!/usr/bin/perl
# Takes the output of find_lang_run.sh (the result of running
# find_lang.cmd over several language files), and takes their average
# for each language. Assumes that the input texts for different
# languages comes one after another.
#   find_lang_ave.pl  < Res  > Res.ave
# Sample lines in input file (here prefixed by '#'):
#WORDS=2083-> PNJ=50 HND=18 BNG=11 ORY= 4 MRT=15 KND= 6 TLG= 8 /punjabi
#WORDS=1599-> PNJ=57 HND=19 BNG=11 ORY= 7 MRT=19 KND=12 TLG=15 /punjabi

format STDOUT =
PNJ=@# HND=@# BNG=@# ORY=@# MRT=@# KND=@# TLG=@# /@<<<<<<<<<
$pnj, $hnd, $bng, $ory, $mrt, $knd, $tlg, $prev_lang_name
.

while (<>) {
  $line = $_;
  chop;
  ($head, $_) = split (/->/, $_, 2);
  #print STDERR "DEB: head::$head, rest::$_,\n";
  @langs = split (/=/);  # First elem will have 'PNJ' etc. Ignore. $langs[0].
  for ($i=1;  $i <= $#langs;  $i++) {  # Clean up @langs. Keep numbers only.
    # print STDERR "DEBUG: $langs[$i], ";
    if ($i == 7) { # extract lang name
      if ($langs[$i] =~ /[a-zA-Z_]+$/) { $lang_name = $&; }
      else { print STDERR "Language name not found: $line"; }
    }
    if ($langs[$i] =~ /^\s*([0-9]+)/) { $langs[$i] = $1; }
    else {
      print STDERR "Warn: Number not found: $langs[$i] in $line";
    }
  }
  if ($prev_lang_name eq $lang_name) { # add to prev result
    for ($j=1; $j <= $#langs;  $j++) { $lang_sum[$j] += $langs[$j]; }
    $count++;
  }
  else { 
    #foreach $l (@lang_sum) { print STDERR $l; }   print STDERR "\n";    # DEBUG
    for ($j=1; $j <= $#lang_sum;  $j++) { $lang_sum[$j] /= $count; }
    ($jnk, $pnj, $hnd, $bng, $ory, $mrt, $knd, $tlg) = @lang_sum;
    write;
    $prev_lang_name = $lang_name; @lang_sum = @langs;  $count = 1;  # Initialize
  }
}
# Now print the last lang
for ($j=1; $j <= $#lang_sum;  $j++) { $lang_sum[$j] /= $count; }
($jnk, $pnj, $hnd, $bng, $ory, $mrt, $knd, $tlg) = @lang_sum;
write;
