#!/usr/bin/perl
# Converts a file in 8-bit ISCII notation to 8-bit PC ISCII notation.
# Author: Rajeev Sangal, 20 July 1997
# Options:
require("/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/printusage.pl");

# Assumes that the args begin after the params. (Each param begins by -)
local ($i, $parmlastpos, $argbegpos, $Finname, $Foutname);
$parmlastpos = -1; # Gives pos of last param in ARGV. Default no params.
$argbegpos = -1;  # Gives position of 1st argument in ARGV. Default no args

# Look up .i8_i8prc file. Override defaults.
if (open (RC, '.i8_i8prc')) {
  while (<RC>) {
    chop;
    if (/\s*#/) {  next; }   # Ignore. A comment line.
    if (/\s*-/) {  # A parameter found.
      $_ = '-' . $';
      if (substr($_,1,1) eq 'h') { # print help info.
        &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/scrpt/i8_i8p.cmd');
        die;
      }
      else { 
          print STDERR "i8_i8p.cmd: Unrecognized param in rc file: $_.\n";
          &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/scrpt/i8_i8p.cmd');
          die;
      }
    }
    else { # 
      print STDERR "i8_i8p.cmd: Param must begin with '-' in rc file: $_. Ignoring.\n";
    }
  }
  close (RC);
}

for ($i=0; $i <= $#ARGV; $i++) { # Extract the parameters and locate
                                 #  starting loc of command args.
     # Command line args override those of the rc file.
  if (substr($ARGV[$i],0,1) eq '-') {  # A parameter found.
    $parmlastpos++;  # Change the following lines to suit your needs.
    if (substr($ARGV[$i],1,1) eq 'h') { # print help info.
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/scrpt/i8_i8p.cmd');
      die;
    }
    else { 
        print STDERR "i8_i8p.cmd: Unrecognized param: $ARGV[$i].\n";
        &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/scrpt/i8_i8p.cmd');
        die;
    }
  }
  else { # Argument found. Parameters end.
    $argbegpos = $i;
    last;
  }
}

# Process the arguments in the command line then call i8_i8p.
# 1. Can be used as a filter. OR
# 2. file args can be given instead of filters.

if ($argbegpos < 0) { # No args.
  &i8_i8p(STDIN, STDOUT);
}
elsif (($#ARGV - $argbegpos) == 0) { # Only one arg given. Execute the command with arg and stdout.
  open (INFILE, "$ARGV[$argbegpos]") ||
     die "i8_i8p.cmd: Unable to open file $ARGV[$argbegpos]\n" ;
  $Finname = $ARGV[$argbegpos];  $Foutname = '';
  &i8_i8p(INFILE, STDOUT);
  close (INFILE);
}
elsif (($#ARGV - $argbegpos) == 1) { # Two args given. Execute the command with arg1 and arg2.
  open (INFILE, "$ARGV[$argbegpos]") ||
     die "i8_i8p.cmd: Unable to open input file $ARGV[$argbegpos]\n" ;
  open (OUTFILE, ">$ARGV[$argbegpos + 1]") ||
     die "i8_i8p.cmd: Unable to open output file $ARGV[$argbegpos + 1]\n" ;
  $Finname = $ARGV[$argbegpos];  $Foutname = $ARGV[$argbegpos+1];  
  &i8_i8p(INFILE, OUTFILE);
  close (OUTFILE);
  close (INFILE);
}
else { print STDERR "i8_i8p.cmd: Too many arguments.\n"; }
#------------------------------------------------------

sub i8_i8p {
local ($W_fin, $W_fout) = @_;
select($W_fout);
#%COMMENT
# Converts a file in 8-bit ISCII notation to 8-bit PC ISCII notation.
# Author: Rajeev Sangal, 20 July 1997
#%CMD TYPE 11
while (<$W_fin>) {
  tr/\xE0-\xEA/\xF1-\xFB/;
  tr/\xD1-\xDF/\xE1-\xEF/;
  tr/\xA1-\xD0/\x80-\xAF/;
  print $_;
}
}
1;
