#!/usr/bin/perl
#%COMMENT
# This program identifies the language of the text in the input
# file (which is assumed to be in iitk roman alphabetic notation).
#   Example usage: find_lang.pl < INFILE
#   Example usage: find_lang.cmd  -v  -w100 < INFILE
# Prints characteristics of file on STDERR if option -v is on.
# Therefore, it can also be used to try out different parameters
# for making the program run more effectively.
#%CMD TYPE 11
$v_charac = 0; # Verbose print the characteristics of file #OPT -v sw1
$word_max = 500; # Number of words to look at in the input file. #OPT -w

open(BNG, "/home/bharathi/PNJ1/usr3/sangal/tools/src/scrpt/lang_data/word_bng.lst") || 
  die "can't open file /home/bharathi/PNJ1/usr3/sangal/tools/src/scrpt/lang_data/word_bng.lst: $!\n";
open(TLG, "/home/bharathi/PNJ1/usr3/sangal/tools/src/scrpt/lang_data/word_tlg.lst") || 
  die "can't open file /home/bharathi/PNJ1/usr3/sangal/tools/src/scrpt/lang_data/word_tlg.lst: $!\n";
open(PNJ, "/home/bharathi/PNJ1/usr3/sangal/tools/src/scrpt/lang_data/word_pnj.lst") ||
  die "can't open file /home/bharathi/PNJ1/usr3/sangal/tools/src/scrpt/lang_data/word_pnj.lst: $!\n";
open(HND, "/home/bharathi/PNJ1/usr3/sangal/tools/src/scrpt/lang_data/word_hnd.lst") ||
  die "can't open file /home/bharathi/PNJ1/usr3/sangal/tools/src/scrpt/lang_data/word_hnd.lst: $!\n";
open(MRT, "/home/bharathi/PNJ1/usr3/sangal/tools/src/scrpt/lang_data/word_mrt.lst") ||
  die "can't open file /home/bharathi/PNJ1/usr3/sangal/tools/src/scrpt/lang_data/word_mrt.lst: $!\n";
open(ORY, "/home/bharathi/PNJ1/usr3/sangal/tools/src/scrpt/lang_data/word_ory.lst") ||
  die "can't open file /home/bharathi/PNJ1/usr3/sangal/tools/src/scrpt/lang_data/word_ory.lst: $!\n";
while(<BNG>) { chop; $bng{$_} = 1; }
while(<TLG>) { chop; $tlg{$_} = 1; }
while(<PNJ>) { chop; $pnj{$_} = 1; }
while(<HND>) { chop; $hnd{$_} = 1; }
while(<MRT>) { chop; $mrt{$_} = 1; }
while(<ORY>) { chop; $ory{$_} = 1; }
close(BNG); close(TLG); close(PNJ); close(HND);close(MRT); close(ORY);
#SEPARATOR = [\",:;'\?><\]\[\}\{\)\( \n\t_\-=!\@#%&\*\.\\/]
$bng_cnt=0; $tlg_cnt=0; $pnj_cnt=0; $hnd_cnt=0; $mrt_cnt=0; $ory_cnt=0; $tot_wrd=0;
while(<>) {
  s/[\",:;'\?><\]\[\}\{\)\(_\-\=\!\@\#\%\&\*\.\\\/]//g;
  s/^\s+//;
  if(/^\s*$/) { 
    # print STDERR "WHITE SPACE ONLY\n"; # Debugging
    next;
  }
  chop;
  @word_lst = split(/\s+|\t+/);
  $tot_wrd += $#word_lst;
  for($i=0; $i<$#word_lst; $i++) {
    if($bng{$word_lst[$i]} == 1) { $bng_cnt++;
      # print STDERR "BNG :$word_lst[$i]:\n"; #DEBUGGING
    }
    if($tlg{$word_lst[$i]} == 1) { $tlg_cnt++;
      # print STDERR "TLG :$word_lst[$i]:\n"; #DEBUGGING
    }
    if($pnj{$word_lst[$i]} == 1) { $pnj_cnt++;
      # print STDERR "PNJ :$word_lst[$i]:\n"; #DEBUGGING
    }
    if($hnd{$word_lst[$i]} == 1) { $hnd_cnt++;
      # print STDERR "HND :$word_lst[$i]:\n"; #DEBUGGING
    }
    if($mrt{$word_lst[$i]} == 1) { $mrt_cnt++;
      # print STDERR "MRT :$word_lst[$i]:\n"; #DEBUGGING
    }
    if($ory{$word_lst[$i]} == 1) { $ory_cnt++;
      # print STDERR "ORY :$word_lst[$i]:\n"; #DEBUGGING
    }
  }
  if ($tot_wrd >= $word_max) { last; } # Exit while loop.
} # End of while loop

if ($tot_wrd == 0) { 
  print STDERR "Warn: Zero words in file.\n";
  $output1 = 'UNDEF';
}
else {
  $bng=$bng_cnt*100/$tot_wrd;
  $tlg=$tlg_cnt*100/$tot_wrd;
  $pnj=$pnj_cnt*100/$tot_wrd;
  $hnd=$hnd_cnt*100/$tot_wrd;
  $mrt=$mrt_cnt*100/$tot_wrd;
  $ory=$ory_cnt*100/$tot_wrd;
  if ($v_charac) {
    print STDERR "WORDS:$tot_wrd -> ";
    #print STDERR sprintf("PNJ:%d% HND:%d% BNG:%d% ORY:%d% MRT:%d% TLG:%d% \n",
    print STDERR sprintf("PNJ:%d HND:%d BNG:%d ORY:%d MRT:%d TLG:%d /",
                            $pnj, $hnd, $bng, $ory, $mrt, $tlg);
     #print STDERR sprintf("HND:%d% PNJ:%d% BNG:%d% TLG:%d% MRT:%d% ORY:%d% \n",
     #                      $hnd, $pnj, $bng, $tlg, $mrt, $ory);
  }

  # Highest goes to output. (Error check 1. Percentage more than 30.
  # check 2: Highest and second highest numbers are more than 20% apart.
  @list = ($pnj, $hnd, $bng, $ory, $mrt, $tlg);
  @newlist = sort numerically @list;
   #foreach $l (@list) { print $l, " "; }  print "\n";    #DEBUG
   #foreach $l (@newlist) { print $l, " "; }  print "\n"; #DEBUG
  if    ($newlist[$#list] == $hnd) { $output1 = 'hindi'; }
  elsif ($newlist[$#list] == $pnj) { $output1 = 'punjabi'; }
  elsif ($newlist[$#list] == $bng) { $output1 = 'bengali'; }
  elsif ($newlist[$#list] == $tlg) { $output1 = 'telugu'; }
  elsif ($newlist[$#list] == $mrt) { $output1 = 'marathi'; }
  elsif ($newlist[$#list] == $ory) { $output1 = 'oriya'; }
  else { $output1 = 'UNDEF'; }

  if ($tot_wrd <= 30) { print STDERR "Warn: Less than 30 words in file. Check answer.\n"; }
  if    ($newlist[$#list] <= 25) { $output1 = 'UNDEF'; }
  elsif ($newlist[$#list - 1] >= (0.8 * $newlist[$#list])) {
    print STDERR "Warn: Not sure of the identified language. Check answer. \n";
  }
}
print $output1, "\n";

sub numerically { $a <=> $b; }

