# Selects and rearranges the coloumns of disease34.txt database from snomed.
#   Example usage: c:\perl\perl  med_rev.pl  < diseas34.txt > diseas34.out
# The output has the first topo_number (from field 4), 
#   followed by disease name (field 3), and field 0.
# Also creates a secondary output file: med_rev.sec.
# Lines in the input which have empty field 4, are written to file: med_rev.err
#
# Following is the format of the database:
# "D0-00004"	""	"01"	"Disease of skin, NOS"	"(T-01000) (DF-00000)"	""	""
# "D0-00004"	""	"02"	"Dermatosis, NOS"	"(T-01000) (DF-00000)"	"709.9"	""
# "D0-00004"	""	"02"	"Skin disorder, NOS"	"(T-01000) (DF-00000)"	""	""
# "D0-00010"	""	"01"	"Dermatitis, NOS"	"(T-01000) (M-40000)"	"692.9"	""
# Fields in the above (separated by \t):
#    0          1        2       3                      4
#  5    6

open (STDERR, ">med_rev.err") ||
  die "Unable to open file med_rev.err: $!\n";
open (SECND, ">med_rev.sec") ||
  die "Unable to open file med_rev.sec: $!\n";
format STDOUT =
@<<<<<<<<<<   @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< @<<<<<<<<<
$topo_num[0],  $flds[3],  $flds[0]
.
while (<>) {
  chop;
  @flds = split (/\t/);
  if ($#flds >= 7) { print STDERR "Invalid number of fields: $#flds:: $_\n"; }
  if ($flds[4] =~ /^"(.*)"$/) { $flds[4] = $1; }
  @topo_num = split (/ +/, $flds[4]);
  if ($topo_num[0] eq '') { print STDERR $_, "\n"; } 
  else { write STDOUT; }
    #else { print $topo_num[0], " ", $flds[3], "\t", $flds[0], "\n"; }
  for ($i=1;  $i <= $#topo_num;  $i++ ) {
    print SECND $topo_num[$i], " ", $flds[3], "\t", $flds[0], "\n";
  }
}
