#!/usr/bin/perl
# Takes a description of command line and rc file options, 
# and generates the cmd file.
#   Example usage:  gencmd.cmd  fmtrec.opt
# This will generate the file fmtrec.cmd which will call the
# function 'fmtrec' in a file fmtrec.pl.
# cmd assumes many to many.

require("/home/bharathi/PNJ1/usr3/sangal/tools/src/sysapp/gencmdmenu.pl");
require("/home/bharathi/PNJ1/usr3/sangal/tools/src/sysapp/genmenu.pl");
require ("/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/printusage.pl");


# Assumes that the args begin after the params. (Each param begins by -)
local ($i, $parmlastpos, $argbegpos, $arg, $suff, $funcname, $argsinfile);
$parmlastpos = -1; # Gives pos of last param in ARGV. Default no params.
$argbegpos = -1;  # Gives position of 1st argument in ARGV. Default no args
$argsinfile = 0;  # Default args file names are not in a file.
$suff = '.cmd'; # Default suffix for output file if necessary.
$funcname = 'DUMMY'; # Default to be used, if func name cannot be generated from
                     # input file name.
for ($i=0; $i <= $#ARGV; $i++) { # Extract the parameters and locate
                                 #  starting loc of command args.
  if (substr($ARGV[$i],0,1) eq '-') {  # A parameter found.
    $parmlastpos++;  # Change the following lines to suit your needs.
    if (substr($ARGV[$i],1,1) eq 'h') { # print help info.
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/sysapp/gencmdmenu.cmd');
      die;
    }
    elsif (substr($ARGV[$i],1,1) eq 's') { # Suffix for output file names.
       $suff = substr ($ARGV[$i],2);
    }
    # elsif (substr($ARGV[$i],1,1) eq 'f') { # Function name
    #    $funcname = substr ($ARGV[$i],2);
    # }
    else { print STDERR "Parameter not recognized $ARGV[$i]. Ignoring.\n";
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/sysapp/gencmdmenu.cmd');
    }
  }
  else { # Argument found. Parameters end.
    if (substr($ARGV[$i],0,1) eq '@') {  # A file of args found
      $argsinfile = 1;
      $ARGV[$i] = substr($ARGV[$i], 1);
    }
    $argbegpos = $i;
    last;
  }
}
#print STDERR "DEB params end: $parmlastpos;  args begin: $argbegpos; total: $#ARGV;\n";

# Process the arguments in the command line then call gencmd.
# 1. Can be used as a filter. OR
# 2. If one or more file arguments are given, they are treated as
#    inputs files, and the output file name is given
#    by the input file name suffixed by the default suffix
#    (which can be changed by approp flag).

if ($argbegpos < 0) { # No args.
  &gencmdmenu(STDIN, STDOUT);
}
elsif ($argsinfile) {  # Args in file.
  open (ARGFILE, "$ARGV[$argbegpos]") ||
    die "Unable to open args file $ARGV[$argbegpos]\n" ;
  while (<ARGFILE>) { # Read args.
    chop;
    $funcname = '';
    if (!(open (INFILE, $_))) {
      print STDERR "Unable to open file $_\n" ;
      next;
    }
    if (/\.[^.]*$/) { $funcname = $`; }  # Strip off trailing file ext
    else { $funcname = $_; }
    if (!(open (OUTFILE, ">$funcname$suff"))) {
      print STDERR "Unable to open out file $funcname$suff\n";
      close (INFILE);
      next;
    }
    &gencmdmenu (INFILE, OUTFILE);
    close (INFILE);
    close (OUTFILE);
  }
  close (ARGFILE);
}
else { # Call the program with each arg. 
  for ($arg = $argbegpos; $arg <= $#ARGV; $arg++) {
    $funcname = '';
    if (!(open (INFILE, "$ARGV[$arg]"))) {
      print STDERR "Unable to open file $ARGV[$arg]\n" ;
      next;
    }
    if ($ARGV[$arg] =~ /\.[^.]*$/) { $funcname = $`; }
    else { $funcname = $ARGV[$arg]; }
    if (!(open (OUTFILE, ">$funcname$suff"))) {
      print STDERR "Unable to open out file $funcname$suff\n";
      close (INFILE);
      next;
    }
    &gencmdmenu (INFILE, OUTFILE);
    close (INFILE);
    close (OUTFILE);
  }
}

