#!/usr/bin/perl
#%COMMENT
# This is a mail handler which takes an e-mail message
# and if the mail contains LANG=TELUGU,NOTAT=i8 then runs anusaaraka
# for the language. Otherwise, does the normal thing.
#   Example usage:  mail_lang.pl < in.tmp
#
#%CMD TYPE 11

$verbose = 1; # If verbose option set, print out extra error msgs. #OPT -v sw1


local ($msghd, $msgbody, $proc_over, $save_tobuf, $bodyptr, 
              $deb, @buffer, $bufcnt);
$msghd = 1;     # 1 means message header continuing.
$msgbody = 0;   # 1 means message body continuing.
 # $proc_over = 0; # 1 means processing over. Write to stdout or $buf.
$save_tobuf = 1;   # 1 means do not write to stdout. Save in $buf.
$bodyptr = -1;  # Points to start of msg body in @buf. Valid only if $save_tobuf is 1.
$deb = 0;       # 1 means debug flag on.
$bufcnt = -1;   # $bufcnt is a count of elements of @buf in use.
                #  @buf is an array where lines are sent until the
                #  mail body is found or some other condition satisfied.
                #  after that the lines are sent to stdout.
# Now  start processing the input mail message
$bufcnt++; $buf[$bufcnt] = "\n"; # Needed when this program used in '.forward'
$runanu_lang = 'telugu';  # Assume Telugu if notation is non-english.
while (<>) {
  # if ($proc_over) {
  #   if ($save_tobuf) { $bufcnt++;  $buf[$bufcnt] = $_; }
  #   else { print; }
  # }
  if ($msghd) {  # Inside the message header.
    if ($_ eq "\n") { # Header terminates. Body to start.
      if ($save_tobuf) { 
        $bufcnt++;  $buf[$bufcnt] = $_; $bodyptr = 1 + $bufcnt;
      }
      else { print; }
      &terminate_header ();  
      if ($runanu_lang ne 'telugu') { &flush_buf (); }
    }
    elsif (/^[^\s]+: /) {  # A possible field found
      if ($save_tobuf) { $bufcnt++;  $buf[$bufcnt] = $_; }
      else { print; }
      if ($deb) { print "--A field found:$_"; }
      $fld = $&;   chop ($fld);   $rem = $';  chop($rem);
         # Save the values of some fields
      if ($fld eq 'From:') { $fldfrom = $rem; }
      elsif ($fld eq 'Subject:') { 
        $fldsubj = $rem;
        if ($fldsubj =~  /lang(uage){0,1}\s*=\s*telugu/i) {
          $runanu_lang = 'telugu'; 
           # $proc_over = 1;
        }
        if ($fldsubj =~  /notat(ion){0,1}\s*=\s*(.*)([\s,;]|$)/i) {
          $runanu_notat = $2;
           # $proc_over = 1;
        }
      }
      elsif ($fld eq 'Cc:') { $fldcc = $rem; }
    }
    else {  # An ordinary header line (without field in beginning)
      if ($save_tobuf) { $bufcnt++;  $buf[$bufcnt] = $_; }
      else { print; }
      if ($deb) { print "--in header:$_"; }
    }
  }
  elsif ($msgbody) {  # We are inside the message body
     # if (/^From /) {  # A new header found. Terminates message body.
     #   &terminate_body ();
     # }
     # else { # Usual line in the message body.
    if ($deb) { print "--Body of message:$_"; }
    if ($save_tobuf) { $bufcnt++;  $buf[$bufcnt] = $_; }
    else { print; }
     # }
  }
  else { 
    print STDERR "mail_lang.pl: Program error. Neither body nor header flag.\n";
    if ($save_tobuf) { $bufcnt++;  $buf[$bufcnt] = $_; }
    else { print; }
  }
} # End of main while loop reading from input file

#if ($runanu_lang ne 'telugu') { &flush_buf (); }  # Not a telugu lang. mail.
#else { # Run telugu anusaaraka on the body of message.

# Input might be in telugu and anusaaraka may have to be run
$sys_err = 0;
if (($save_tobuf == 0) || ($bodyptr < 0) ) {
  print STDERR "mail_lang.pl: Prog error. Body not found in buf.\n";
   # print STDERR "2\n";
  &flush_buf();
}
 #elsif ($bodyptr > $bufcnt) {  # Body is empty.
 #  print STDERR "mail_lang.pl: Warn: Body is empty.\n";
 #  &flush_buf ();
 #}
else {  # Save body and run anusaaraka if necessary.
  if (!(-d "anutmp")) {  # Dir does not exist
    if (-e "anutmp") { system ("mv anutmp anutmp.001"); } # Move file
    $sys_err = system ("mkdir anutmp");
    if ($sys_err != 0) { print STDERR "Unable to create dir anutmp: $!\n"; }
  }
  $tmpfile = "$$" . 'mail_lang.tmp';
  if (-e "anutmp/$tmpfile") { system ("rm anutmp/$tmpfile"); }
  if (!(open (MSGBODY, ">anutmp/$tmpfile")))  {
    print STDERR "mail_lang.pl: Unable to open file anutmp/$tmpfile: $!\n";
    &flush_buf();
  }
  else {
    for ($j = $bodyptr;  $j <= $bufcnt;  $j++){   # Empty the buffer
      print MSGBODY $buf[$j];
    }
    close (MSGBODY);
    # Test script/notation used. Is it other than English?
    $notat = `/home/bharathi/PNJ1/usr3/sangal/bin/scrpt < anutmp/$tmpfile`;
    chop ($notat);  # Remove new line char
    if ($verbose) {
      if ($fldsubj ne '') { $subjpart = 'subj ' . $fldsubj . ','; }
      print STDERR "For message from $fldfrom, $subjpart", 
        "script found to be: $notat\n";
    }
    if (($runanu_notat ne '') && ($notat ne $runanu_notat)) {
      $sys_err = 1;
      print STDERR "Script notation shown in subj field does not ",
        "match with contents. Not calling anusaaraka.\n";
    }
    else {
      if ($notat eq 'english') { $sys_err = 1; }  # Do not run anusaaraka
      elsif ($notat eq 'ra') { $trigger = '/home/bharathi/PNJ1/usr3/sangal/bin/trigger_new'; }
      elsif ($notat eq 'i7') { # No ready made trigger. Do conversion.
        system ("cd anutmp;  mv  $tmpfile  $tmpfile.i7;\\
                 /home/bharathi/PNJ1/usr3/sangal/bin/i7-ra < $tmpfile.i7 > $tmpfile");
        $trigger = '/home/bharathi/PNJ1/usr3/sangal/bin/trigger_new';
      }
      elsif ($notat eq 'i8') { $trigger = '/home/bharathi/PNJ1/usr3/sangal/bin/trigger_d'; }
      elsif ($notat eq 'bhk') { $trigger = '/home/bharathi/PNJ1/usr3/sangal/bin/trigger_bhk'; }
      else { $sys_err = 1; }  # Do not run anusaaraka
    }

    if ($sys_err == 0) {
      if ($verbose) {
        print STDERR 
          ' Calling Telugu-Hindi anusaaraka trigger.', "\n";
      }
      system ("(cd anutmp;  \\
        $trigger  < $tmpfile  > $tmpfile.out  2> $tmpfile.err )");
        #cp  $tmpfile   $tmpfile.out)"); #While DEBUG: Repl line above with this line.
    }
     # print STDERR "3\n";
    &flush_buf();
    if ($sys_err == 0) {
      print "\n", "     ======= Telugu-Hindi anusaaraka output (inp notation $notat) =======\n";
      #system ("(cd anutmp;  cat $tmpfile.out)"); # Instead of this line added next 4 lines.
      open (ANUOUTPUT, "anutmp/$tmpfile.out") ||
        die "Unable to open file anutmp/$tmpfile.out: $!\n";
      while (<ANUOUTPUT>) { print $_; }
      close (ANUOUTPUT);
    }
  }
}
#}
    

# if ($msghd) { # Means message header never got terminated. Premature end.
#   print STDERR "mail_lang.pl: Header never got terminated.\n";
#   &terminate_header ();  &flush_buf ();
# }

#-----------------------------------------------------------------
# Message header has terminated. Body expected to start. Do the needful.
sub terminate_header {
  $msghd = 0;  $msgbody = 1; 
  if ($deb) { print "--Header over:$_"; }
}
sub flush_buf {
  local ($j);
  $save_tobuf = 0;
  for ($j = 0;  $j <= $bufcnt;  $j++){   # Empty the buffer
    print $buf[$j];
  }
  $bufcnt = -1;
}

# # Beginning of message header encountered. Terminates body. Do needful.
# sub terminate_body {
#   $msghd = 1;   $msgbody = 0;
#   $index = -1;
#   $curfile = select(STDOUT);
#   if ($curfile ne STDOUT) { close (FOLDER); }
#   if ($deb) { print "--Header starts.\n"; }
#   $bufcnt++; $buf[$bufcnt] = $_;
#   if ($tousr) {  # Remail the message in usrf.tmp to named userid.
#     close (USRF);
#     system "mail $usrname  < /home/bharathi/PNJ1/usr3/sangal/Mail/usrf.tmp";
#     print  LOG "mailing to $usrname\. Subj: $fldsubj\n";
#     $tousr = 0;
#   }
# }
