#!/usr/bin/perl
# This is a mail handler which takes e-mail messages
# and for each message if it contains a print command,
# sends it to the printer.
# To execute it with respect to a mail message in in.tmp do:
#         maillpr.pl < in.tmp  [ > /dev/ttyS5 ]
# This should be executed automatically.

# If the subject field contains 'To Line Printer:::'
#
# A list of authorized users can also be specified in .mailprc
# (Trivial to implement it, but not yet implemented.)


$msghd = 0;  # 1 means message header found.
$msgbody = 1; # 1 means message body continuing. (Before the first message 
         #  header is found, the lines will go to stdout, as no folder is open.)
$tolpr = 0;  # 1 means the message is printed.
$deb = 0;    # debugging flag.
if (-e 'mailfrc.log') {
  open (LOG, ">>/root/Mail/mailfrc.log") || print "Unable to open appnd file: mailfrc.log\n";
}
else {
  open (LOG, ">/root/Mail/mailfrc.log") || print "Unable to open file: mailfrc.log\n";
}


##--------------------------------------------------------------
## Get the list of pre-specified addresses/patterns and their folders:

$frccnt = -1;  # Counter for number of entries in .mailfrc file.

#open (FRC, "/root/Mail/.mailfrc") || die "Unable to open file: .mailfrc\n";
#while (<FRC>) {
#  if (!(/^\s*#/) && !(/^\s*$/) ) {# Not a comment or blank line.Process.
#    $frccnt++;
#    if (/^\s+/) { $_ = $'; }  # Remove opening space.
#    ( $field[$frccnt], $pat[$frccnt], $const[$frccnt], $folder[$frccnt] ) = split (/\s+/, $_);
#    if ($const[$frccnt] ne "Folder:") {
#      print LOG "Folder not specified in file .mailfrc :$_";
#      $frccnt--;
#    }
#  }
#}
#if ($frccnt == -1) { die ".mailfrc file is empty.\n"; }
#close (FRC);
#--------------------------------------------------------------
# # Get the list of permitted users who can execute commands.
# $prccnt = -1;  # Counter for number of entries in mailprc file.
# if (-e "mailprc") {  # if the file of permissions exists
#   open (PRC, "/root/Mail/mailprc") || print LOG "Unable to open file: mailprc\n";
#   while (<PRC>) {
#     if (/^\s+/) { $_ = $'; }  # remove opening white space
#     if (!(/^#/)) { # Not a comment line. Process.
#       if ( /^([\w\-\.\@\!]+)/ ) {
#         $prccnt++;
#         $permitted[$prccnt] = $1;
#       }
#       else { print LOG "User addr not found in file mailprc :$_"; }
#     }
#   }
#   if ($prccnt == -1) { print LOG "mailprc file is empty.\n"; }
#   close (PRC);
# }
#--------------------------------------------------------------
# Now  start processing the input mail message
$bufcnt = -1;  # @buf is an array where messages are sent until
               #   the body is found.
$index = -1; # Gives the position of matched folder found in message.
while (<>) {
  if ($msghd) {  # Inside the message header.
    if ($_ eq "\n") { # Header terminates. Body to start.
      &terminate_header ();
    }
    elsif (/^[^\s]+: /) {  # A possible field found
      $bufcnt++; $buf[$bufcnt] = $_;
      if ($deb) { print "--A field found:$_"; }
      $fld = $&;   chop ($fld);   $rem = $';  chop($rem);
         # Save the values of some fields
      if ($fld eq 'From:') { $fldfrom = $rem; }
      elsif ($fld eq 'Subject:') { $fldsubj = $rem; }
      elsif ($fld eq 'Cc:') { $fldcc = $rem; }

      if ($index == -1) { # Check if from the pre-specified list.
        for  ($i = 0; $i <= $frccnt; $i++) {
          if (($fld eq $field[$i]) && ( /[\s]*[\s<]$pat[$i][>,@\s][\s]*/i )) {
              #    if (($fld eq $field[$i]) && 
              #        (/([\s<])[\s]*$pat[$i]([>,\s])[\s]*/) &&
              #        (($1 ne '<') || ($2 eq '>')) #ensure matching <.>
              #       ) {
            $index = $i; # Store loc of matched item in pre-specfd list.
            last;  # Quit for-loop after the first pattern found.
          }
        }  # End for loop
      }
    }
    else {  # An ordinary header line (without field in beginning)
      $bufcnt++; $buf[$bufcnt] = $_;
      if ($deb) { print "--in header:$_"; }
    }
  }
  elsif ($msgbody) {  # We are inside the message body
    if (/^From /) {  # A new header found. Terminates message body.
      &terminate_body ();
    }
    else { # Usual line in the message body.
      if ($deb) { print "--Body of message:$_"; }
      print;
      if ($tolpr) { print LPRCMD ; }
    }
  }
  else { 
    if ($deb) { print "--Neither body nor header:$_"; } 
    print;
    if ($tolpr) { print LPRCMD ; }
  }
} # End of main while loop reading from input file

if ($msghd) { # Means message never got terminated. Premature end.
  &terminate_header ();
}

if ($tolpr) {  # if the last message was for remailing.
  close (LPRCMD);
  system "/home/bharathi/PNJ1/usr3/sangal/bin/testprint < /root/Mail/lprcmd.tmp";
  print  LOG "Sending to lpr for $usrname\: `ls -l /root/Mail/lprcmd.tmp`";
}
close (LOG);
#-----------------------------------------------------------------
# Message header has terminated. Body expected to start. Do the needful.
sub terminate_header {
  $msghd = 0;  $msgbody = 1; 
  if ($deb) { print "--Header over:$_"; }
  if ($index != -1) { # Folder name found. Select folder.
    $success = 1;
    if (-e $folder[$index]) {
      if (!(open (FOLDER, ">>$folder[$index]") )) {
        $success = 0 ;
        print LOG "Unable to open out append file: $folder[$index]. Ignoring.\n";
      }
    }
    else {
      if (!(open (FOLDER, ">$folder[$index]") )) {
        $success = 0;
        print LOG "Unable to open output file: $folder[$index]. Ignoring.\n";
      }
    }
    if ($success) { select (FOLDER); }
  } # End select folder. If no success, stdout will be used
        #if (($fldfrom =~ /guraosh/) && ($fldsubj =~ /To Line Printer::/)) {
  if ($fldsubj =~ /To Line Printer::/) {
    $tolpr = 1;
    open (LPRCMD, ">/root/Mail/lprcmd.tmp") 
      || print LOG "Unable to open file: /root/Mail/lprcmd.tmp\n";
    print LPRCMD "\~s $fldsubj\n";
    $usrname = $';
    if ($usrname =~ /^\s*([^\s]+)/ ) { $usrname = $1; }
    else { 
      $usrname = '';
      print LOG "User name not given. Message from: $fldfrom\. Subj:$fldsubj\n";
      $tolpr = 0;
    }
  }
  for ($j = 0;  $j <= $bufcnt;  $j++){# Empty the buffer
    print $buf[$j];
    if ($tolpr) { print LPRCMD $buf[$j]; }
  }
  $bufcnt = -1;
  print;  # print this line.
  if ($tolpr) { print LPRCMD ; }
}

# Beginning of message header encountered. Terminates body. Do needful.
sub terminate_body {
  $msghd = 1;   $msgbody = 0;
  $index = -1;
  $curfile = select(STDOUT);
  if ($curfile ne STDOUT) { close (FOLDER); }
  if ($deb) { print "--Header starts.\n"; }
  $bufcnt++; $buf[$bufcnt] = $_;
  if ($tolpr) {  # Send the message body to the printer.
    close (LPRCMD);
    system "/home/bharathi/PNJ1/usr3/sangal/bin/testprint < /root/Mail/lprcmd.tmp";
    print  LOG "Sending to lpr for $usrname\: `ls -l /root/Mail/lprcmd.tmp`";
    $tolpr = 0;
  }
}
