#!/usr/bin/perl
# Checks usages of disk space against allotted quotas.
#   Example usage: quota.pl ALLOTTED-QUOTAS USERS-WITH-DISKUSAGE
open(QUOTA,$ARGV[0]) || die "Unable to open quota file: $ARGV[0]\n";
open(USE,$ARGV[1]) || die "Unable to open user file: $ARGV[1]\n";
while (<QUOTA>) {
  if (/ *([a-zA-Z0-9]*) *([0-9]*)/) { 
    $quota{$1} = $2;
    #    print $1, " ", $quota{$1}, "\n";  # For debugging
  }
  else { print STDERR "Invalid format for quota: $_"; }
}
# print STDERR "------\n" ;  # For debugging
while (<USE>) {
  if (/ *([a-zA-Z0-9]*) *([a-zA-Z0-9]*)/) { 
    #    print STDERR $1, " ", $quota{$1}, "\n"; # For debugging
    $user = $1; $usage = $2;
    if ($quota{$user} < $usage) {
       print "USER ", $user," OCCUPYING ", $usage, ". ALLOTTED QUOTA ", $quota{$user}, "\n";
    }
  }
}
