#!/usr/bin/perl
#%COMMENT
# Used for restoring the accounts in /etc/passwd given 
# the 'ls -l' output of the users home dirs (from /usr3, /usr4, etc.)
#   Example usage: restore_passwd.pl < usr3.ls >> /etc/passwd
# LIMITATION. Assumes the following:
#  1. The name of the user is the same as his home dir.
#  2. Does not look at group id. Makes it '100'.
#%CME TYPE 11

$dirname = '/usr3';  # Name of the home directory containing the user accounts. #OPT  -d
$verbose = 0;  # Verbose output. Print userids. #OPT  -v sw1

while (<>) {
  @all = split(/\s+/);
   # print STDERR "DEB: $all[0]  $all[4]\n";
   #if (substr($all[0], 0, 1) eq '-') { # To check that the info is for a file, not directory.
   #}
  if ($#all < 0) { next; }  # Blank line.
  if ($all[0] =~ /:$/) {  chop($all[0]);  $dirname = $all[0];  } # Skip directories
  else {
    if ('total' eq substr($all[0], 0, 5)) { next; }  # skip this line. Directory.
    if (!($all[2] =~ /^[0-9]+$/)) {  next; } # userid already exists.
    if ('d' eq substr($all[0], 0, 1)) {  # Process.
      $fname = $all[8];
      #if ($fname =~ /\/$/ ) {  next; }
      if ($fname =~ /\*$/ ) {  chop ($fname);  }  # Remove '*' from +x files.
      if ($all[2] == 0) {
        $all[2] = 99;
        print STDERR "Warn: a root password found. Changing to 99.: $fname\n";
      }
      print  $fname, ':*:', $all[2], ':100:', $fname, ':',
                $dirname, '/', $fname, ':/bin/bash', "\n";
      if ($verbose) { print STDERR $fname, "\n"; }
    }
  }
}

