#!/usr/bin/perl
# This is used to create login ids and other information from
# one linux machine to another. Input must be that part of /etc/passwd
# file which contains entries of users you want to transfer.
#   Example usage:  transusers.pl  < users.ini

# Example entry
# 0     : 1           : 2 : 3 : 4           : 5          :  6
# sangal:hdpHf8HgfCgNc:501:100:Rajeev Sangal:/home/bharathi/PNJ1/usr3/sangal:/bin/bash
# epc002:vxxKCvbbyT57s:502:100:Amba Kulkarni:/usr3/epc002:/bin/bash
# vc:gROXkuID2AXz2:503:100:Vineet Chaitanya:/usr3/vc:/bin/bash
# pwrdn::0:0:root:/root:shutdown -h now

# Store the information about each user from the new system in 
# the user database.
open (PASSWD, '/etc/passwd') ||
  die "Unable to open /etc/passwd file.\n";
$uidmax = -10;  # init to some low value
while (<PASSWD>) {
  chop;
  ($loginid, $password, $uid, $gid, $username, $home, $shell) = split (/:/);
  $userdb{$loginid} = $_;
  if ($uid > $uidmax) { $uidmax = $uid; }
}
$uidcur = $uidmax + 1;  # New uids will be assigned more than max value
close (PASSWD);

# Create userids on the new machine using the STDIN file.
open (PASSWDNEW, ">>/etc/passwd") ||
   die "Unable to open file for appending: /etc/passwd.\n";
while (<>) {
  chop;
  ($loginid, $password, $uid, $gid, $username, $home, $shell) = split (/:/);
  if ($userdb{$loginid}) {
    print "Login id $loginid already exists. Not being created.\n";
  }
  elsif (-d $home) {
    print "Directory $home already exists. Login id $loginid not created.\n"
  }
  else {
    if ($gid != 100) {
      print STDERR "Warning: gid not equal to 100 for $loginid. Using it as it is: $gid.\n";
    }
    print PASSWDNEW $loginid, ':', '',  ':', $uidcur, ':', 
      $gid, ':', $username, ':', $home, ':', $shell, "\n";
    $res = system ("(mkdir  $home; cd $home; tar -xvf /root/dot.tar >/dev/null)");
    $userdb {$loginid} = $_;
    $newuserdb {$loginid} = $_;
    if ($res == 0) {
      # system ("(chown -R $loginid $home; chgrp -R $gid $home)");
    }
    else {
      print "Error creating login id $loginid.\n";
    }
    $uidcur++;
  }
}
close (PASSWDNEW);

foreach $u (keys %newuserdb) {
  $_ = $newuserdb {$u};
  ($loginid, $password, $uid, $gid, $username, $home, $shell) = split (/:/);
  system ("(chown -R $loginid $home; chgrp -R $gid $home)");
}
  
  
