# For a sequence of files whose names are given in $ARGV[0],
# generates entries suitable for index creation by latex.
# Index entries in the input file should have a syntax given by 
# textproc\index.hlp.   For the notation generated see latex manual.
$debug = 0;
$pgnum = 0;
$err = STDOUT;
# $crtex = 1;
# $crind = 1;
if ($debug) { print $err 'DEB: Entered indboth.pl';}
open (FNAMES, $ARGV[0]) || die "Unable to open file: $ARGV[0]\n";
open (IND, ">$ARGV[0]\.ind")|| die "Unable to open out file: $ARGV[0]\.ind\n";
# For each file name in file given by arg of command.
while (<FNAMES>) {
  chop;
  $fnm = $_;
  print  $err "\n%-----------------$fnm\n";
  open (IN, $fnm) || die "Unable to open file: $fnm\n";
  open (TEX, ">x" . $fnm) || die "Unable to open out file: x$fnm\n";
  #  print TEX  "%-----------------$fnm\n";
  while (<IN>) {
    # Generate index entry command for latex.
    chop;
    if ($debug) { print $err "\nDEB: Next line: $_"; }
    $line = $_;
    CUR:
    while ($_ ne "") {  # Process the current line
       if (!/(uu|UU|vv|VV|zz|ZZ)/) {
          # Pattern did not match anything.
          print TEX $_; $_ = ""; last CUR;
       }
       if ($debug) { print $err "\nBegin iter: /$`/$&/$'/"; }
       $key = $&;
       print TEX $`;
       $_ = $';
       if (($key eq "zz")|($key eq "ZZ"))  { $pgnum++; }
       else {
          $nextchar = substr ($_, 0, 1);
          if ($nextchar =~ /[123{]/) {
             # Character 1,2,3,{ has been found.
             $found = 1;
             $_ = substr ($_, 1, length($_) - 1);
          }
          else { $found = 0; }
 
          # Now $_ begins with a word or more to be put in the index.
          # $key = uu,vv,etc found.  $nextchar=next char if 1,2,3,{.
          # $found=1 if $nextchar is 1,2,3,{.
          $nomatch = 0;
          SW:
          {
            ((!$found)|($nextchar eq '1')) 
               && do { /([0-9a-zA-Z\-]*)/; 
                       $pre = $`; $pat = $&; $post = $'; last SW; };
            ($nextchar eq '2') 
               && do{ /([0-9a-zA-Z\-]*)[^0-9a-zA-Z\-]*([0-9a-zA-Z\-]*)/;
                       $pre = $`; $pat = $&; $post = $'; last SW; };
            ($nextchar eq '3') 
               && do { /([0-9a-zA-Z\-]*)[^0-9a-zA-Z\-]*([0-9a-zA-Z\-]*)[^0-9a-zA-Z\-]*([0-9a-zA-Z\-]*)/; 
                       $pre = $`; $pat = $&; $post = $'; last SW; };
            $nomatch = 1;
          }
          if (!$nomatch) {  # Carry out the action after the above match
             if ($debug) { 
                print $err "\nINDEX: $pat//BEFORE:$pre/AFTER:$post/"; }
             $_ = $post;
             if (($key eq "uu")|($key eq "UU")) { print TEX  $pat; }
             if (($key eq "uu")|($key eq "vv")) { $pat =~ tr/A-Z/a-z/; }
             if ($crtex) { print TEX "\\index{$pat}"; } 
             if ($crind) { print IND "$pat $pgnum\n"; }
          }
          elsif ($nextchar eq "{") {
             /}/;
             if ($debug) { 
                print $err "\nINDEX: $`//BEFORE:{/AFTER:$'/"; }
             $_ = $';
             if (($key eq "uu")|($key eq "UU")) { print TEX  $`; }
             $t = $`;
             if (($key eq "uu")|($key eq "vv")) { $t =~ tr/A-Z/a-z/; }
             if ($crtex) { print TEX "\\index{$t}"; }
             if ($crind) { print IND "$t $pgnum\n"; }
          } 
          else { print $err "\nNo match when expected line $.: $_"; }
          if ($debug) {print $err "\nEnd iter:   ", $_; }
       }
    } # End of do loop (for current line) CUR
  if ($crtex) { print TEX "\n"; }
  } # End of loop for file. i.e. for all lines in the file.
  close (IN);
  close (TEX);
}
close (FNAMES);
close (IND);
1;
