#!/usr/bin/perl
# Given a file of sections, sub-sections, etc. in PGDTS notes format, 
# produce a table of contents. For example, the input file contains
#  FILENAME1:-- SECTION TITLE1
#  FILENAME1:--- SUB-SECTION TITLEA
#  FILENAME2:-- SECTION TITLE2
# Produce output:
#  FILENAME1
#   -- SECTION TITLE1 
#      -- SUB-SECTION TITLE2
#  FILENAME2
#   -- SECTION TITLE2 
# Also convert FILENAME to ISCII-8 from IITK Roman alphabetic

while (<>) {
  if (/^([a-zA-Z_\-0-9]+):(-+)/) {
    $level = $2;
    $rest = substr ($', 1);
    print STDERR "DEBUG: level =$level, rest=$rest";
    if ($chap ne $1) { # New chapter begins.
      $prev_chap = $chap;   $chap = $1;
      system ("echo $chap > toc.tmp");
      $title = `ri < toc.tmp`;
      print "\n", $title, "\n";
    }
    chop($level);  $level =~ s/-/   /g;
    $level =~ s/  $/- /;
    print $level, $rest;
  }
  else { print STDERR "mk_toc.pl: Line not in toc format:$_"; }
}
