#!/usr/bin/perl
# Takes a file on which 'slidepre.pl' has been run,
# and restores the file. (Actually, it restores the
# bullets (which are '-', '+' etc.).)
#
# This is what slidepre.pl does: 
# Takes an ordinary file for slides and "preprocesses"
#  it so that fmt program does not disturb the indenting.
# All lines in which characters '- ' or '+ ' are the first
# non-white space characters, a line with '\indent' is inserted
# followed by a new line. 

$last = '';
while (<>) {
  if (/^\\indent$/) {
       #if (/^\\indent([\-\+]{0,1})$/) { #For possible change later.
       #  $bulletmark = $1;
    if ($last ne "\n") { print STDERR "Non-empty line before line no.: $.\n"; }
    $junk = <>; 
    if ($junk ne "\n") { print STDERR "Non-empty line: $.\n"; }
    $_ = <>;
    if (/  ([^ ])/) { $last = $` . '- ' . $1 . $'; }
    elsif (/ ([\-]+\n)/) { $last = '-' . $1; }  # For page sep: --------
     #else { print '-', $_; }  # For debugging
  }
  else { print $last;   $last = $_; }
}
print $last;

