#!/usr/bin/perl
# Takes an ordinary file for slides and "preprocesses"
# it so that fmt program does not disturb the indenting.
#
# fmt program wraps around lines or breaks them to meet the
# given coloumn width but maintains the indenting of the first line.
# This program preprocesses lines with '-' as the first char, so
# that they are not merged with previous lines by fmt.
#
# All lines in which characters '- ' or '+ ' are the first
# non-white space characters, a line with '\indent' is inserted
# followed by a new line. 
# After this  the fmt program can be run on the resulting file,
# after which slidepost.pl can be run to restore the things.

while (<>) {
  if (/^\s*[\-\+]/) {      # Changed from: /^\s*[\-\+] /
    $rest = $';
    $pre = $&;  $pre =~ s/[\-\+]/ /g;
    print "\n", '\indent', "\n\n";
    print $pre, $rest;
  }
  else { print; }
}

