#!/usr/bin/perl
# Creates a html file for the given text file.
#   Usage:  slide_html.pl  < a.txt  > a.html
# Author: Vikas Bansal, 31 Oct 1998
# Options:
# -notoc	-  Generate table of contents. Default:1(yes) 
require("/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/printusage.pl");

# Assumes that the args begin after the params. (Each param begins by -)
local ($i, $parmlastpos, $argbegpos, $Finname, $Foutname);
local ($gen_toc);
$parmlastpos = -1; # Gives pos of last param in ARGV. Default no params.
$argbegpos = -1;  # Gives position of 1st argument in ARGV. Default no args
$gen_toc = 1; #  Generate table of contents. Default:1(yes)  Default value as shown.

# Look up .slide_htmlrc file. Override defaults.
if (open (RC, '.slide_htmlrc')) {
  while (<RC>) {
    chop;
    if (/\s*#/) {  next; }   # Ignore. A comment line.
    if (/\s*-/) {  # A parameter found.
      $_ = '-' . $';
      if (substr($_,1,1) eq 'h') { # print help info.
        &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/wordproc/slide_html.cmd');
        die;
      }
      elsif (substr($_,1, 5) eq  'notoc') {
        $gen_toc = 0;
      }
      else { 
          print STDERR "slide_html.cmd: Unrecognized param in rc file: $_.\n";
          &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/wordproc/slide_html.cmd');
          die;
      }
    }
    else { # 
      print STDERR "slide_html.cmd: Param must begin with '-' in rc file: $_. Ignoring.\n";
    }
  }
  close (RC);
}

for ($i=0; $i <= $#ARGV; $i++) { # Extract the parameters and locate
                                 #  starting loc of command args.
     # Command line args override those of the rc file.
  if (substr($ARGV[$i],0,1) eq '-') {  # A parameter found.
    $parmlastpos++;  # Change the following lines to suit your needs.
    if (substr($ARGV[$i],1,1) eq 'h') { # print help info.
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/wordproc/slide_html.cmd');
      die;
    }
    elsif (substr($ARGV[$i],1, 5) eq  'notoc') {
      $gen_toc = 0;
    }
    else { 
        print STDERR "slide_html.cmd: Unrecognized param: $ARGV[$i].\n";
        &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/wordproc/slide_html.cmd');
        die;
    }
  }
  else { # Argument found. Parameters end.
    $argbegpos = $i;
    last;
  }
}

# Process the arguments in the command line then call slide_html.
# 1. Can be used as a filter. OR
# 2. file args can be given instead of filters.

if ($argbegpos < 0) { # No args.
  &slide_html(STDIN, STDOUT);
}
elsif (($#ARGV - $argbegpos) == 0) { # Only one arg given. Execute the command with arg and stdout.
  open (INFILE, "$ARGV[$argbegpos]") ||
     die "slide_html.cmd: Unable to open file $ARGV[$argbegpos]\n" ;
  $Finname = $ARGV[$argbegpos];  $Foutname = '';
  &slide_html(INFILE, STDOUT);
  close (INFILE);
}
elsif (($#ARGV - $argbegpos) == 1) { # Two args given. Execute the command with arg1 and arg2.
  open (INFILE, "$ARGV[$argbegpos]") ||
     die "slide_html.cmd: Unable to open input file $ARGV[$argbegpos]\n" ;
  open (OUTFILE, ">$ARGV[$argbegpos + 1]") ||
     die "slide_html.cmd: Unable to open output file $ARGV[$argbegpos + 1]\n" ;
  $Finname = $ARGV[$argbegpos];  $Foutname = $ARGV[$argbegpos+1];  
  &slide_html(INFILE, OUTFILE);
  close (OUTFILE);
  close (INFILE);
}
else { print STDERR "slide_html.cmd: Too many arguments.\n"; }
#------------------------------------------------------

sub slide_html {
local ($W_fin, $W_fout) = @_;
select($W_fout);
#%COMMENT
# Creates a html file for the given text file.
#   Usage:  slide_html.pl  < a.txt  > a.html
# Author: Vikas Bansal, 31 Oct 1998
#%CMD TYPE 11

print "<HTML>\n";
print "<HEAD>\n";
print "<TITLE>       </TITLE>\n";
print '</HEAD>', "\n";
print "<BODY>\n";
print "<P>\n";

$s_count = 1;
print "<A NAME=\"SLIDE$s_count\"> ";
print "<P>\n";
print "<PRE>"; # maintains formatting of page
if ($gen_toc) {
  $TOC = "\n";
  $TOC .= "<P><A NAME=\"INDEX\">\n    -- INDEX -- \n<P>";
  $get_title = 1;
}
while (<$W_fin>) {
  chop;
  if (/^-----/) {   # New slide starts.
    $s_prev = $s_count-1;
    $s_next = $s_count+1;
    print "</PRE>\n"; # maintains formatting of page 
    print "$s_count  <A HREF=\"#SLIDE$s_next\">NEXT-PAGE</A> \n"; 
    print "<A HREF=\"#SLIDE$s_prev\">PREVIOUS-PAGE</A> \n";
    if ($gen_toc) {
      print "<A HREF=\"#INDEX\">INDEX</A> \n";
    }
    print '</A>',"\n";    # print $_, '<BR>', "\n";
    $s_count++;
    print "<A NAME=\"SLIDE$s_count\"> ";
    print "<P>\n";
    print "<PRE>"; #maintains the formatting of page
    if ($gen_toc) { $get_title = 1; }
  }
  else { 
    print $_, "\n";
     #print $_, '<BR>', "\n";  # Removed <BR> after <PRE> was added.
    if ($gen_toc) { # add to the table of contents
      if ($get_title) {
        if ($_) { 
          $tmpcount = $s_count - 1;
          $TOC .= "<A HREF=\"#SLIDE$s_count\">$s_count $_</A><P>\n";
          $get_title = 0;
        }
      }
    } # endif gen_toc 
  }
}
# Generate for the last page
$s_prev = $s_count -1;
print "</PRE>"; # maintains formatting of page 
print "$s_count  <A HREF=\"#SLIDE$s_prev\">PREVIOUS-PAGE</A> \n";
if ($gen_toc) {
  print "<A HREF=\"#INDEX\">INDEX</A> \n";
}

if ($gen_toc) { print $TOC; }
print '</A>', "\n";
print '</BODY>',"\n";
print '</HTML>',"\n";
}
1;
