#!/usr/bin/perl
# Makes pages of a fixed size S (default: 18 lines).
# If a page is less than S, inserts blank lines. If a page
# is more than that inserts page separators and a '...contd.' string.
#   Usage:  slide_page.pl  < a.txt  > a.pag
# Options:
# -n	-  Size of page in number of line_count 
require("/home/bharathi/PNJ1/usr3/sangal/tools/src/etc/printusage.pl");

# Assumes that the args begin after the params. (Each param begins by -)
local ($i, $parmlastpos, $argbegpos, $Finname, $Foutname);
local ($page_size);
$parmlastpos = -1; # Gives pos of last param in ARGV. Default no params.
$argbegpos = -1;  # Gives position of 1st argument in ARGV. Default no args
$page_size = 18; # Default  Size of page in number of line_count 

# Look up .slide_pagerc file. Override defaults.
if (open (RC, '.slide_pagerc')) {
  while (<RC>) {
    chop;
    if (/\s*#/) {  next; }   # Ignore. A comment line.
    if (/\s*-/) {  # A parameter found.
      $_ = '-' . $';
      if (substr($_,1,1) eq 'h') { # print help info.
        &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/wordproc/slide_page.cmd');
        die;
      }
      elsif (substr($_,1, 1) eq  'n') {
        $page_size = substr ($_, 2);
      }
      else { 
          print STDERR "slide_page.cmd: Unrecognized param in rc file: $_.\n";
          &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/wordproc/slide_page.cmd');
          die;
      }
    }
    else { # 
      print STDERR "slide_page.cmd: Param must begin with '-' in rc file: $_. Ignoring.\n";
    }
  }
  close (RC);
}

for ($i=0; $i <= $#ARGV; $i++) { # Extract the parameters and locate
                                 #  starting loc of command args.
     # Command line args override those of the rc file.
  if (substr($ARGV[$i],0,1) eq '-') {  # A parameter found.
    $parmlastpos++;  # Change the following lines to suit your needs.
    if (substr($ARGV[$i],1,1) eq 'h') { # print help info.
      &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/wordproc/slide_page.cmd');
      die;
    }
    elsif (substr($ARGV[$i],1, 1) eq  'n') {
      $page_size = substr ($ARGV[$i], 2);
    }
    else { 
        print STDERR "slide_page.cmd: Unrecognized param: $ARGV[$i].\n";
        &printusage ('/home/bharathi/PNJ1/usr3/sangal/tools/src/wordproc/slide_page.cmd');
        die;
    }
  }
  else { # Argument found. Parameters end.
    $argbegpos = $i;
    last;
  }
}

# Process the arguments in the command line then call slide_page.
# 1. Can be used as a filter. OR
# 2. file args can be given instead of filters.

if ($argbegpos < 0) { # No args.
  &slide_page(STDIN, STDOUT);
}
elsif (($#ARGV - $argbegpos) == 0) { # Only one arg given. Execute the command with arg and stdout.
  open (INFILE, "$ARGV[$argbegpos]") ||
     die "slide_page.cmd: Unable to open file $ARGV[$argbegpos]\n" ;
  $Finname = $ARGV[$argbegpos];  $Foutname = '';
  &slide_page(INFILE, STDOUT);
  close (INFILE);
}
elsif (($#ARGV - $argbegpos) == 1) { # Two args given. Execute the command with arg1 and arg2.
  open (INFILE, "$ARGV[$argbegpos]") ||
     die "slide_page.cmd: Unable to open input file $ARGV[$argbegpos]\n" ;
  open (OUTFILE, ">$ARGV[$argbegpos + 1]") ||
     die "slide_page.cmd: Unable to open output file $ARGV[$argbegpos + 1]\n" ;
  $Finname = $ARGV[$argbegpos];  $Foutname = $ARGV[$argbegpos+1];  
  &slide_page(INFILE, OUTFILE);
  close (OUTFILE);
  close (INFILE);
}
else { print STDERR "slide_page.cmd: Too many arguments.\n"; }
#------------------------------------------------------

sub slide_page {
local ($W_fin, $W_fout) = @_;
select($W_fout);
#%COMMENT
# Makes pages of a fixed size S (default: 18 lines).
# If a page is less than S, inserts blank lines. If a page
# is more than that inserts page separators and a '...contd.' string.
#   Usage:  slide_page.pl  < a.txt  > a.pag
#%CMD TYPE 11


$page_count = 1;
$line_count = 0;
while (<$W_fin>) {
  $line_count++;
  if (/^-----/) {   # New page starts. Insert requisite blank line_count.
    for ($i=$line_count; $i <= $page_size;  $i++) { print "\n"; }
    #print "\n", $page_count, "\n";  # Remove putting of page count
    print;
    $line_count = 0;  $page_count++;
  }
  elsif ($line_count >= $page_size) {  # Break slide page into two.
    print "               (continue...)\n"; 
    print '-----', "\n", ' ...continued', "\n", "\n";
    print;
    $line_count = 4;  $page_count++;
  }
  else { print; }
}

if ($line_count < $page_size) { #  Take care of the last page
  for ($i=$line_count; $i <= $page_size;  $i++) { print "\n"; }
  #print "\n", $page_count, "\n";  # Remove putting of page count
}
}
1;
