#!/usr/bin/perl
#%COMMENT
# Makes pages of a fixed size S (default: 18 lines).
# If a page is less than S, inserts blank lines. If a page
# is more than that inserts page separators and a '...contd.' string.
#   Usage:  slide_page.pl  < a.txt  > a.pag
#%CMD TYPE 11

$page_size = 18;  # Size of page in number of line_count #OPT -n

$page_count = 1;
$line_count = 0;
while (<>) {
  $line_count++;
  if (/^-----/) {   # New page starts. Insert requisite blank line_count.
    for ($i=$line_count; $i <= $page_size;  $i++) { print "\n"; }
    #print "\n", $page_count, "\n";  # Remove putting of page count
    print;
    $line_count = 0;  $page_count++;
  }
  elsif ($line_count >= $page_size) {  # Break slide page into two.
    print "               (continue...)\n"; 
    print '-----', "\n", ' ...continued', "\n", "\n";
    print;
    $line_count = 4;  $page_count++;
  }
  else { print; }
}

if ($line_count < $page_size) { #  Take care of the last page
  for ($i=$line_count; $i <= $page_size;  $i++) { print "\n"; }
  #print "\n", $page_count, "\n";  # Remove putting of page count
}
