# Pulls out the lines marked as version 2 out of tex files as shown below:
#  %v2 p<number> {verbat}  \{
#    Matter to be pulled out.
#  %v2 }

$errfile = STDOUT;
$sw = 0;   $verbat_flag = 0;
while (<>) {
  if ($sw) {print;}
  if (/%v2/) {    # Begin or end marker found.
     $front = $`;
     $rest = $';
     if ($rest =~ /^ +\}/) {  # It is End marker 
            # print "$front\n";
        if ($verbat_flag) {print "\\end{verbatim}\n";}
        if ($sw == 0) { print $errfile "Non-nested matter.\n$_"; }
        $sw = 0; 
     }
     if ($rest =~ /^ +p([0-9]+(-[0-9]+)?) +(verbat +)?\{/ ) {# begin marker
        $pagenum = $1;   $verbat = $3;
        print "\nPage $pagenum\n";
        if ($verbat) { # begin verbatim
           print "{\\small \\begin{verbatim}\n";
           $verbat_flag = 1;
        }
        if ($sw == 1) { print $errfile "Double-nested matter.\n$_"; }
        $sw = 1;
     }
     else { # something wrong with v2 syntax.
        print "Error in v2 syntax:\n$_";  # Assume start of begin marker
        $pagenum = $1;   $verbat = $2;
        print "\nPage $pagenum\n";
        if ($verbat) { # begin verbatim
           print "{\\small \\begin{verbatim}\n";
           $verbat_flag = 1;
        }
        if ($sw == 1) { print $errfile "Double-nested matter.\n$_"; }
        $sw = 1;
     }
  }  # v2 syntax processed 
}
1;
