#!/usr/bin/perl
#Takes an input file in which order of file is given.
#OUTPUT - Create HTML files for all files.
#e.g cd anu_paricaya
#../mk_html.pl README
#OUTPUT - toc.htm plus all html files which are read by README
open(TOC1, ">toc1.htm") || die "Unable to open toc1.htm:$!\n";
print TOC1 "<HTML>\n";
print TOC1 "<HEAD>\n";
print TOC1 "<TITLE>       </TITLE>\n";
print TOC1 '</HEAD>', "\n";
print TOC1 "<BODY>\n";
print TOC1 "<PRE>\n";
$file_in = $ARGV[0];
open(IN, "$file_in");
$chp_no = 0;
%index = 0;
%index_name = 0;
open(TOC, ">toc2.htm") || die "Unable to open toc2.htm:$!\n";
while(<IN>) {
  chop;
  if (/^\-[^\-]/) {
    $chp_no++;
    $index{$chp_no} = 1;
    $chp_full_nme = $';
    $chp_nme = $chp_full_nme;
    $chp_nme =~ s/[\t|\s]+.*$//; # It is a file.
    $index_name{$chp_no} = $chp_name;
    print TOC "<P>";
    print TOC "	<A HREF=\"CHAPTER$chp_no.htm\">$chp_no $chp_nme </A>\n";
    print TOC1 "<P>";
    print TOC1 "	<A HREF=\"CHAPTER$chp_no.htm\">$chp_no $chp_nme </A>\n";
    $sec_no = 0;
    open(CHP, "$chp_nme") || die "Unable to open $chp_nme$!\n";
    $chp_cnt_pre = $chp_no - 1;
    $chp_cnt_nxt = $chp_no + 1;
    $first_line = <CHP>;
    chop($first_line);
    while(<CHP>) {
      chop;
      $line = $_;
      if (/^\-\-[^\-]/) { #marking for section
        $sec_no++;
        $index_no = $chp_no.'.'.$sec_no;
        $index{$index_no} = 1;
        $sec_no_pre = $sec_no - 1;
        $sec_no_nxt = $sec_no + 1;
        $sub_sec_no = 0;
        $title = $_; #Name of the section.
        $title =~ s/^\-\-//;
        $index_name{$index_no} = $title;
        print TOC "<P>";
        print TOC "		<A HREF=\"CHAPTER$chp_no.htm#SEC$index_no\">$index_no $title </A>\n";
      }
      elsif (/^\-\-\-[^\-]/) {
        $sub_sec_no++;
        $index_no = $chp_no.'.'.$sec_no.'.'.$sub_sec_no;
        $index{$index_no} = 1;
        $sub_sec_pre = $sub_sec_no - 1;
        $sub_sec_nxt = $sub_sec_no + 1;
        $sub_title = $_; # Name of sub-section.
        $sub_title =~ s/^\-\-\-//;
        $index_name{$index_no} = $sub_title;
        print TOC "<P>";
        print TOC "			<A HREF=\"CHAPTER$chp_no.htm#SEC$index_no\">$index_no $sub_title </A>\n";
      }
    }
    close (<CHP>);
  }
}
#foreach $l (%index) { print "$l\n"; }
print TOC1 "------------------------------------------------------------\n";
print TOC "</PRE>\n";
print TOC "</BODY>\n";
close (<IN>);
close (<TOC>);
close (<TOC1>);
system ("cat toc1.htm toc2.htm >toc.htm");
system ("rm toc1.htm toc2.htm");

#Start making HTML files.
open(IN, "$file_in");
$chp_no = 0;
while(<IN>) {
  chop;
  if (/^\-[^\-]/) {
    $chp_no++;
    $chp_full_nme = $';
    $chp_nme = $chp_full_nme;
    $chp_nme =~ s/[\t|\s]+.*$//; # It is a file.
    $sec_no = 0;
    open(CHP, "$chp_nme") || die "Unable to open $chp_nme$!\n";
    $chp_cnt_pre = $chp_no - 1;
    $chp_cnt_nxt = $chp_no + 1;
    #Create HTML file for each file.
    open(HOUT, ">CHAPTER$chp_no.htm") || die "Unable to open $chp_nme.htm:$!\n";
    print HOUT "<PRE>\n";
    $first_line = <CHP>;
    chop($first_line);
    $first_line =~ s/^\s+//;
    #$first_line_and_no = $chp_no.$first_line;
    print HOUT "	$chp_no.$first_line (";
    #print HOUT "$first_line_and_no ";
    if ($index{$chp_cnt_nxt} == 1) {
      print HOUT "<A HREF=\"CHAPTER$chp_cnt_nxt.htm\">NEXT-CHAPTER </A>";
    }
    if ($chp_cnt_pre != 0) {
      print HOUT "<A HREF=\"CHAPTER$chp_cnt_pre.htm\">PREV-CHAPTER </A>";
    }
    print HOUT "<A HREF=\"toc.htm\">CONTENTS</A>";
    print HOUT ")\n\n";

    #Print TABLE OF CONTENTS OF CURRENT CHAPTER.
    open(TMP, ">tmp") || die "Unable to open tmp:$!\n"; 
    foreach $key (%index) {
      $key_name = $index_name{$key};
      print TMP "$key $key_name\n";
    }
    close(<TMP>);
    system("sort < tmp > tmp.s");
    open(TMP, "tmp.s") || die "Unable to open tmp.s:$!\n"; 
    while(<TMP>) {
     chop;
     @key_value = split(/\s+/);
     if ($key_value[0] =~ /^$chp_no\.[1-9]+\.[1-9]+/) { #Checking for sections 
       print HOUT "	<A HREF=\"#SEC$key_value[0]\">$_ </A>\n";
     }
     elsif ($key_value[0] =~ /^$chp_no\.[1-9]+/) { #Checking for sub-sections.
       print HOUT "<A HREF=\"#SEC$key_value[0]\">$_ </A>\n";
     }
    }
    close (<TMP>);
    while(<CHP>) {
      chop;
      $line = $_;
      if (/^\-\-[^\-]/) { #marking for section
        $sec_no++;
        $sec_no_pre = $sec_no - 1;
        $sec_no_nxt = $sec_no + 1;
        $next_sec = $chp_no.'.'.$sec_no_nxt;
        $prev_sec = $chp_no.'.'.$sec_no_pre;
        $cur_sec = $chp_no.'.'.$sec_no;
        $line =~ s/^\-\-/$cur_sec/;
        print HOUT "<A NAME=\"SEC$cur_sec\">\n";
        print HOUT "$line (";
        $sub_sec_no = 0;
        $title = $_; #Name of the section.
        $title =~ s/^\-\-//;
        if ($index{$next_sec} == 1) { 
          print HOUT "<A HREF=\"#SEC$next_sec\">\[$next_sec\] </A>";
        }
        #Check for sub section
        $tmp_sub_sec = $chp_no.'.'.$sec_no.'.1';
        if ($index{$tmp_sub_sec} == 1) { 
          print HOUT "<A HREF=\"#SEC$tmp_sub_sec\">\[$tmp_sub_sec\] </A>";
        }
        if($sec_no_pre != 0) {
          print HOUT "<A HREF=\"#SEC$prev_sec\">\[$prev_sec\] </A>";
        }
        #print HOUT "<A HREF=\"toc.htm\">CONTENTS</A>";
        print HOUT "<A HREF=\"CHAPTER$chp_no.htm\">\[UP\]</A>";
        print HOUT ")";
      }
      elsif (/^\-\-\-[^\-]/) {
        $sub_sec_no++;
        $sub_sec_pre = $sub_sec_no - 1;
        $sub_sec_nxt = $sub_sec_no + 1;
        $next_sub_sec = $chp_no.'.'.$sec_no.'.'.$sub_sec_nxt;
        $prev_sub_sec = $chp_no.'.'.$sec_no.'.'.$sub_sec_pre;
        $cur_sub_sec = $chp_no.'.'.$sec_no.'.'.$sub_sec_no;
        print HOUT "<A NAME=\"SEC$cur_sub_sec\">\n";
        $line =~ s/^\-\-\-/$cur_sub_sec/;
        print HOUT "$line (";
        $sub_title = $_; # Name of sub-section.
        $sub_title =~ s/^\-\-\-//;
        if( $index{$next_sec} == 1) {
          print HOUT "<A HREF=\"#SEC$next_sec\">\[$next_sec\] </A>";
        }
        print HOUT "<A HREF=\"#SEC$cur_sec\">\[$cur_sec\] </A>";
        if( $index{$next_sub_sec} == 1) {
          print HOUT "<A HREF=\"#SEC$next_sub_sec\">\[$next_sub_sec\] </A>";
        }
        if($sub_sec_pre != 0) {
          print HOUT "<A HREF=\"#SEC$prev_sub_sec\">\[$prev_sub_sec\] </A>";
        }
        #print HOUT "<A HREF=\"toc.htm\">CONTENTS</A>";
        print HOUT "<A HREF=\"CHAPTER$chp_no.htm\">\[UP\]</A>";
        print HOUT ")";
      }
      else {  print HOUT "$line"; }
      print HOUT "\n";
    }
    close (<CHP>);
  }
}
print HOUT "</PRE>\n";
close (<HOUT>);
system ("rm tmp tmp.s");
