#!/usr/bin/perl
# Converts the typed text so that it has normally used conventions
# regarding spaces and punctuation marks etc.
# Renames the given file by putting '.old' suffix, and the
# new file is given the same name as its argument.
#   Example usage: typing.pl  FILENAME
# The old file is named as FILENAME.old.

$^I = '.old';
while (<>) {
  s/ +,/,/g;          # remove space before ','
  s/,([^ ])/, \1/g;  # add a space after ','
  s/ +\./\./g;
  s/\.([^ ])/\. \1/g;
  s/ +:/:/g;
  s/:([^ ])/: \1/g;

  s/ +\)/\)/g;  # remove spaces before ')'
  s/\( +/\(/g;  # remove spaces after '('
  s/([^ ])\(/\1 \(/g;  # add a space before '(' if none.
  s/\)([^ ])/\) \1/g;  # add a space after ')' if none.

  s/ +\}/\}/g;   # similar for '{', '}'
  s/\{ +/\{/g;
  s/([^ ])\{/\1 \{/g;
  s/\}([^ ])/\} \1/g;

  s/ +\]/\]/g;   # similar for '[', ']'
  s/\[ +/\[/g;
  s/([^ ])\[/\1 \[/g;
  s/\]([^ ])/\] \1/g;

     #s/([^ ])  /\1 /g;  # Remove two spaces if not in the beginning
  if (/^ +/) { $tmppre = $&; $tmp = $'; } 
  else       { $tmppre = ''; $tmp = $_;}
  $tmp =~ s/  +/ /g;  # Remove two spaces (not in beginning of line)
  $_ = $tmppre . $tmp;
    
  print;
}
